define(function(require, exports, module) {
	$.ns("c360.albumData","c360.app","c360.backButtonFn");
	
	require('app/app');
	require('route/backButton');//back键路由
	require('common/download');//下载
	
	var alertDialog = require('ui/dialog/alert/alert');

	c360.backButtonFn = function(){
		cNative.closeTopestView();
	};

	$(function(){
		init();
	});	

	function init(){
		//静态常量
		var FILTER_VERSION = 8,
			MAX_OPERLENGTH = cNative.nativeAPIVersion>FILTER_VERSION?500:150,
			MAX_NUM = 500;

		var aid = utils.getQuery("aid"),
			ajaxing = false;
		
		c360.app = new c360.views.AppView({
			el:document.getElementById("album"),
			item:c360.views.Photo,
			userEvents:{
				'tap #deletes':'deleteSelectPhotos',
				'tap #separate':'separate',
				'tap #operate':'operateFn',
				'tap #multiple':'multiple',
				'tap #download':'download',
				'tap #back':'back',
				'tap #share':'share'
			},
			toBack:function(evnet){
				cNative.closeTopestView();
				// utils.gotoPage("index.html");
			},
			initDom:function(){
				this.$albumName = this.$("#albumName");
				this.$footer = this.$('footer');
			},
			initEventListener:function(){
				c360.events.on("deletePhotos:album",this.syncDeletePhotos,this);
			},
			loadMoreCallback:function(limit,callback){
				var _this = this,
					json = {aid:aid};
				if(this.startTime){
					json.startTime = this.startTime;
				}
				//限制只请求多少张照片,用于删除了若干照片后,补相应张的照片数据回来
				if(limit){
					json.limit = limit;
				}

				c360.server.album(json,function(res){
					if(res.status == 200){

						//返回值中有albumData,则更新c360.albumData相应的数据,应对有新上传数据的问题
						if(res.data.albumData){
							//把相册信息放到 c360.albumnData 中
							$.extend(c360.albumData,res.data.albumData);
							//首次加载,显示相册名
							if(_this.collection.length === 0){
								_this.editAlbumName(c360.albumData.name);

							}
							
						}

						_this.loadEnd(res.data);
						
						//当集合里的数据等于相册总数时,说明所有数据已经加载完了
						if(_this.collection.length == c360.albumData.count){
							c360.haveData = false;
							_this.noMoreData();
						}

						//说明有新上传的数据,数据加载完毕后再开始同步数据防止count和Collection的length对不上但有以下几个特例:
						//翻页后不需要同步,因为前面几张不是封面
						//有limit也不需要同步封面,因为在删除的回调中已经同步过了
						if(utils.getQuery("count") != c360.albumData.count && !_this.hadPageOver() && !limit){
							_this.syncAlbumCover([],true);
						}

						if(callback && typeof callback == "function"){
							callback();
						}

					}
					else{
						notification.bubble(res.message);
						/*
						*检查collection为空
						*1.跨设备把相册修改后,相册aid变了(临时相册变为正式相册),第一次点击进去后台拿不到数据会报401
						*2.删除相册,把相册所有数据都删完了,临界点的在调一次报401,但是后面还有数据
						 */
						_this.checkDataIsEmpty();
					}
					_this.refresh();
				});
			},
			multiple:function(){
				if(this.isOverLimit()){
					notification.bubble(cNative.nativeAPIVersion>FILTER_VERSION?lang.selectedOver500:lang.selectedOver150);
					return;
				}
				this.listView.show({aid:c360.albumData.id,count:this.collection.length,name:c360.albumData.name});
				// c360.events.trigger("activePanel",{aid:c360.albumData.id,count:this.collection.length,name:c360.albumData.name});
			},
			back:function(){
				cNative.closeTopestView();
			},
			editAlbumName:function(name){
				this.$albumName.text(name);
			},
			download:function(evt){
				var $footer = $(evt.currentTarget).closest("footer");
				if($footer.hasClass("disable")) return;

				var data = this.getSelectedPhotos(),
					keys = [];
					photos = data.photos;
				for(var i = 0,len=photos.length;i<len;i++){
					keys.push(photos[i].key);
				}
				c360.downloadPhoto.showDownLoadDialog(keys, keys.length==1?true:false);

				// alertDialog.render({
				// 	title:lang.downLoadTipTitle,
				// 	content:lang.downLoadTipContent,
				// 	certain:lang.iKnow
				// },function(){
				// 	this.close();
				// });
			},
			share:function(evt){
				var $footer = $(evt.currentTarget).closest("footer");
				if($footer.hasClass("disable")) return;

				$footer.addClass("disable");
				setTimeout(function(){
					$footer.removeClass("disable");
					$footer = null;
				},500);

				var data = this.getSelectedPhotos(),
					pids = data.pids,
					photos = data.photos;
				if(pids.length === 0) return;//容错处理

				c360.storage.set("shareData",{
					pids:pids,
					photos:photos,
					name:c360.albumData.name,
					aids:[],
					url:location.href
				});

				c360.share.main.share();

				// utils.gotoPage("share.html",true,{showTitleBar:true,animation:4});
			},
			separate:function(evt){
				if($(evt.currentTarget).closest("footer").hasClass("disable")) return;
				if(this.isAjaxing()) return;
				var _this = this;
				var photos = this.getSelectedPhotos(),
					earliestPhoto = photos.photos[0],
					defaultName = null,
					pids = photos.pids;

				if(pids.length === 0) return;//容错处理

				/*
				*取最早一张照片的时间为分离相册的默认主题
				 */
				defaultName = earliestPhoto.date;

				var txt = lang.separateTips.replace('{n}',pids.length);
				if(lang.language == "en_US" && pids.length<2){
					txt = lang.separateTips.replace('{n} photos',pids.length+" photo");
				}

				alertDialog.render({
					title:"",
					content:'<div class="title albumSeparate"><span class="album_icon"></span>'+txt+'</div>\
							<input type="text" placeholder="'+lang.inputTheme+'" value="'+defaultName+'" />',
					certain:lang.certain,
					focus:true
				},function(){
					c360.dialog.showLoad();
					//主题名不能为空
					var albumName = this.$('input').val();
					if(albumName === ""){
						notification.bubble(lang.inputOver30);
						c360.dialog.hideLoad();
						return;
					}
					_this.setAjaxing(true);
					c360.server.splitPhotos({
						pids:pids,
						aid:c360.albumData.aid,
						name:albumName
					},function(res){
						if(res.status == 200){
							notification.bubble(lang.success);
							alertDialog.close();
							_this.deleteCallback(pids);
						}else{
							c360.dialog.hideLoad();
							notification.bubble(res.message);
						}
						_this.setAjaxing(false);
					});
				});
			},
			deleteSelectPhotos:function(evt){
				if($(evt.currentTarget).closest("footer").hasClass("disable")) return;
				if(this.isAjaxing()) return;
				var _this = this,
					photos = this.getSelectedPhotos(),
					pids = photos.pids;

				if(pids.length === 0) return;//容错处理

				notification.loading(true,lang.deleting);
				this.setAjaxing(true);
				c360.server.deletes(pids,function(res){
					if(res.status == 200){
						notification.bubble(lang.deleteTips);
						_this.deleteCallback(pids);						
					}else{
						notification.bubble(res.message);
					}
					notification.loading(false,lang.deleting);
					_this.setAjaxing(false);
				});
				
			},
			deleteCallback:function(pids,noSync){
				var _this = this;
				//重新计算相册照片总数
				this.recount(pids.length);
				//根据pid数组删除对应的照片(model删除会触发删除相应的dom)
				this.deleteModelByIds(pids);
				
				//如果还有数据,先把数据补上来在发同步请求,否则直接开始同步
				if(c360.haveData){
						//把新数据请求回来后,再发同步消息,避免当前所剩照片数不够照片封面显示比如64张照片删除63张照片
						//每次补全数据最多补一页数据,即补64张
						this.loadMore(pids.length>64?64:pids.length,function(){
						//单张大图发过来的同步请求,相册内页接收到后,相册内页自己就不再向外发送同步请求了,因为它自身都是被同步对象
						if(!noSync){
							//开始同步删除的数据
							_this.syncAlbumCover(pids);
						}
					});
				}else{
					if(!noSync){
						//开始同步删除的数据
						this.syncAlbumCover(pids);
					}
				}
			},
			/*
			* 将最新的封面组装好,通过同步接口发出去
			* 用于同步首页,相册封面数据
			 */
			syncAlbumCover:function(pids,hasNewPhoto){
				c360.events.trigger("syncAlbum",{aid:c360.albumData.aid,pids:pids,count:c360.albumData.count,covers:this.getCoversData(),nowIsInAlbum:true,hasNewPhoto:hasNewPhoto});
			},
			/*
			* 处理所有需要同步的数据,比如删除photos以后可能会处理描述等数据
			* 用于同步单张大图删除照片后,删除相册内页对应的照片
			*/
			syncDeletePhotos:function(json){
				var data = json.albumData;
				//处理删除photos
				if(data.pids){
					this.deleteCallback(data.pids,true);
					//单张大图删完照片后,会把新的相册count发回来,需要更新count不然再次点进去count没变,单张大图拿到的count是原来的count
					// c360.albumData.count = data.count;
				}
			},
			//重新计算相册照片总数
			recount:function(subNum){
				c360.albumData.count -= subNum;
			},
			setAjaxing:function(val){
				ajaxing = val;
			},
			isAjaxing:function(){
				return ajaxing;
			},
			//组装该相册的相册封面数据,用户数据同步时传给我的云相册对应的相册
			getCoversData:function(){
				//如果是第一个相册,那么默认封面是15张照片,否则是7张封面
				var coverArr = [],
					collection = this.collection,
					photoModel = null,
					len = c360.storage.get("isFirstAlbum")=="1"?15:7;
				//如果相册照片总数小于规定的封面张数,那么取所有的照片作为封面
				len = Math.min(c360.albumData.count,len);

				for( var i = 0; i<len; i++ ){
					photoModel = collection.models[i];
					try{
						coverArr.push({pid:photoModel.get("id"),key:photoModel.get("key"),w:photoModel.get("w"),h:photoModel.get("h")});
					}catch(e){
						console.log("can't find "+i+" photos and collection length is "+collection.length);
					}
					
				}
				//如果封面是4的倍数减去1张,显示给封面
				if(coverArr.length%4==0){
					coverArr.pop();
				}
				return coverArr;
			},
			//已选照片数变化
			selectedPhotosNumChange:function(num){
				if(num <=MAX_OPERLENGTH){
					this.$footer[num>0?"removeClass":"addClass"]("disable");

					var txt = lang.selectedPhotosNum.replace('{n}',num);
					if(lang.language == "en_US" && num<2){
						txt = lang.selectedPhotosNum.replace('{n} photos',num+" photo");
					}

					this.$albumName.text(txt);
				}else{
					this.$footer.addClass("disable");
					this.$albumName.text(c360.albumData.name);
					// c360.operEnable = false;
				}
			},
			noPhoto:function(){
				if(c360.haveData){
					this.loadMore();
				}else{
					if(this.hadPageOver()){
						this.backTop();
					}else{
						//如果照片全部删除完了,等待500毫秒退出相册已确保同步数据完成
						setTimeout(function(){
							c360.events.trigger("syncAlbum",{aid:aid,pids:[],count:0,nowIsInAlbum:true});
							cNative.closeTopestView();
						},500);
					}
				}
			}
		});
	}

});