define(function(require, exports, module) {
	var uploadPhoto = require('common/uploadPhoto.js'),
		storage = require('common/storage');
	var IOS_SHOW_BUBBLE_NUM = 0;
	//监听是否出提示
	if (utils.isAndroid()) {
		cNative.getUploadSetting(function(uploadSetting){
			/**
			 * 上传显示逻辑很混乱,这里解释不清,如果有人接手此部分代码,请直接问产品经理 by goingta
			 */
			//之前没有弹窗提示,则在这里弹出框提示并打开上传开关,否则显示上传提示条
			if (uploadSetting.showUploadInfo) {
				notification.confirm(lang.firstInTips,function(buttonIndex){
					if(buttonIndex == 1){//第一个按钮,即马上设置
						utils.gotoPage("uploadSetting.html",true,{showTitleBar:true});
						c360.statis.storageKey("android_uploadSetting_setNow");
					}else{//我知道了
						c360.statis.storageKey("android_uploadSetting_wait");
					}
				},lang.tips,lang.nowSet+","+lang.IhaveKnow);
				//打开上传开关
				cNative.startUploading();
			}else{
				if(!uploadSetting.canUpload){
					showUploadTips(uploadSetting.count);
				}
			}
			//如果有新上传的照片则提示new字
			if(uploadSetting.uploadedCount){
				$("#refresh").addClass("new").click(function(){
					cNative.clearUploadedCount();
				});
			}
		});
	}else if (utils.isIOS()) {
		cNative.getUploadInfo(function(uploadInfo){
			
			//获取未上传照片数据
			var remainCount = uploadInfo.restCount;
			if (remainCount>IOS_SHOW_BUBBLE_NUM && !uploadInfo.isUploading) {

				showUploadTips(remainCount);
				
			}else if( uploadInfo.isUploading || uploadInfo.isMaking){
				uploadPhoto.begin(function() {
					window.location.href = window.location.href + '?v=' + new Date().getTime();
				}, true);
			}
		});
		
	}


	//绑定上传开关变化事件,根据上传开关状态判断是否显示或隐藏上传按钮,主要针对android
	c360.events.on("upLoadSwitchOpen",function(json){
		if(json.open){
			hideUploadTips();
		}else{
			showUploadTips();
		}
	});
	
	function showUploadTips(count){
		if($("#upLoadTips").length){
			$("#upLoadTips").show();
		}else{
			var tipsHtml = null,
				btns = null,
				dataBtn = null;
			if(utils.isIOS()){
				var txt = lang.uploadCount_ios.replace('{n}',count);
				if(lang.language == "en_US" && count<2){
					txt = lang.uploadCount_ios.replace('{n} photos',count+" photo");
				}
				tipsHtml = '<span class="txt">'+txt+'</span><span class="txt">'+lang.uploadTips_ios+'</span>';
				btns = lang.uploadNow;
				dataBtn='ios_upload';
			}else{
				//没有需要上传的照片时,不现实待上传照片数(注:android返回的count不准确,防止其返回负数)
				if(parseInt(count)>0){
					var txt = lang.uploadCount_adr.replace('{n}',count);
					if(lang.language == "en_US" && count<2){
						txt = lang.uploadCount_adr.replace('{n} photos',count+" photo");
					}
					tipsHtml = '<span class="warning txt">'+lang.uploadTips_adr+'</span><span class="txt">'+txt+'</span>';
				}else{
					tipsHtml = '<span class="warning txt">'+lang.uploadTips_adr+'</span>';
				}
				btns = lang.uploadNowOpen;
				dataBtn='android_upload';
			}
			$("#photo-list").before('<div id="upLoadTips">\
										<div class="fl">\
											<div class="fl">\
												<img src="images/upload_default.png"/>\
											</div>\
											<div class="fl">\
												'+tipsHtml+'\
											</div>\
										</div>\
										<div class="fr">\
											<span id="upLoadBtn" data-btn="' + dataBtn +'">'+btns+'</span>\
										</div>\
									</div>');

			addListenerEvent();
			if(count>0){
				//获取待上传照片的缩略图
				cNative.getUploadImageThumb(function(imgInfo){
					$("#upLoadTips img").attr("src","data:image/jpeg;base64,"+imgInfo.img);
				});
			}else{
				$("#upLoadTips").addClass('noCount');
			}
		}
	}

	function hideUploadTips(){
		$("#upLoadTips").hide();
	}

	//给上传按钮绑定事件
	function addListenerEvent(){
		var $uploadBtn = $("#upLoadBtn");
		if($uploadBtn.length){
			$uploadBtn.bind("tap",function(){
				$("#upLoadTips").hide();
				uploadPhoto.begin(function(remainCount){
					var openNewView = utils.getQuery('openNewView')||'';
					utils.gotoPage("index.html?openNewView="+openNewView+"&t="+(new Date).getTime());
				});
			});
		}
	}
		
});