define(function(require, exports, module) {
	$.ns("c360.backButtonFn", "c360.app");

	var notification = require('common/Notification'),
		autoUpdate = require('common/autoUpdate'); //自动更新模块

	require('app/app');
	require('route/backButton'); //back键路由
	require('app/common/upload'); //显示上传逻辑

	c360.backButtonFn = function() {
		//清除 loading, 和回调
		cNative.removeKeepedCallBack({
			name: 'upgradeForce'
		}, function(data) {});
		cNative.displayLoadingIcon({
			show: false,
			msg: "",
			modal: true
		});
		//4.8以上有照片广场
		if(utils.getQuery('openNewView')=="1"){
			cNative.closeTopestView()
		}else{
			cNative.gotoNativeView({
				viewId: 'returnLastView',
				from: ''
			});
		}
	};

	$(function() {
		init();
	});

	function init() {
		//静态常量
		var MAX_NUM = 50;

		window.cNative.getLoginUser(function(res) {
			if (!c360.storage.get('hasVisitChangeEmailPage') && res.data.changeEmail == 1) {
				utils.gotoPage('changeEmail.html?v=' + Date.now(), true);
			}
		});
		try{
			if(!navigator.onLine){
				c360.statis.storageKey("offline");
			}
		}catch(e){
			
		}
		
		c360.app = new c360.views.AppView({
			el: document.getElementById("index"),
			item: c360.views.Album,
			userEvents:{
				'tap #refresh':'reload'
			},
			maxNum: MAX_NUM,
			initDom: function() {
				this.$refresh = this.$("#refresh");
			},
			initEventListener: function() {
				c360.events.on("editAlbum:index", this.editAlbumByAid, this);
			},
			loadMoreCallback: function() {
				var _this = this,
					json = {};
				if (this.startTime) {
					json.startTime = this.startTime;
				}

				c360.server.index(json, function(res) {
					if (res.status == 200) {

						//自动更新,放在渲染数据之前
						var upgradeInfo = res.data.upgradeInfo || false;
						autoUpdate.update(upgradeInfo);
						//渲染数据
						_this.loadEnd(res.data);
					} else {
						notification.bubble(res.message);
					}
					_this.refresh();
				});
			},
			reload:function(){
				var openNewView = utils.getQuery('openNewView')||'';
				window.location.href = 'index.html?openNewView='+openNewView+'&t='+new Date().getTime();
			},
			showLoading: function() {
				this.pullAjaxing = true;
				this.$refresh.removeClass("active");
				this.$loading.addClass("active").show();
				this.$more.text(lang.loading);
			},
			hideLoading: function() {
				this.pullAjaxing = false;
				this.$refresh.addClass("active");
				this.$loading.removeClass("active").hide();
				this.$more.text(lang.more);
			},
			/*
			 * 用于同步相册封面数据
			 * 如果相册封面数据需要修改,通过次方法设置相册的新数据
			 */
			editAlbumByAid: function(json) {
				this.collection.get(json.aid).set(json.albumData);
			}
		});
	}
});