define(function(require, exports, module) {
	$.ns("c360.app","c360.backButtonFn");

	require('app/app');
	require('route/backButton');//back键路由
	var notification = require('common/Notification');
	$(function(){
		init();
	});	

	c360.backButtonFn = function(){
		cNative.closeTopestView();
		// utils.gotoPage("cloudSetting.html");
	};
	
	function init(){
		//静态常量
		var FILTER_VERSION = 4.6;
		
		c360.app = new c360.views.AppView({
			el:document.getElementById("recycle"),
			item:c360.views.Photo,
			isOpenNewView:false,
			userEvents:{
				'tap #deletes':'deleteSelectPhotos',
				'tap #operate':'operateFn',
				'tap #restore':'restore',
				'tap #multiple':'multiple',
				'tap #back':'back',
				'tap #clean':'cleanRecycle'
			},
			initDom:function(){
				this.$footer = this.$("footer");
				this.$title = this.$("header>h1");
			},
			loadMoreCallback:function(dir){
				var _this = this,
					json = {};
				if(this.startTime){
					json.startTime = this.startTime;
				}

				c360.server.recycle(json,function(res){
					if(res.status == 200){
						_this.loadEnd(res.data);
					}
					else{
						notification.bubble(res.message);
					}
					_this.refresh();
				});
			},
			multiple:function(){
				if(this.isOverLimit()){
					Notification.bubble(lang.selectedOver500);
					return;
				}
				this.listView.show({count:this.collection.length});
				// c360.events.trigger("activePanel",{count:this.collection.length});
			},
			back:function(){
				cNative.closeTopestView();
			},
			deleteSelectPhotos:function(evt){
				if($(evt.currentTarget).closest("footer").hasClass("disable")) return;
				var _this = this;
				var pids = this.getSelectedPhotos().pids;
				if(pids.length == 0) return;
				notification.confirm(lang.recycleDestroy,function(buttonIndex){
					if(buttonIndex == 1){//第一个按钮,即确定按钮
						notification.loading(true);
						c360.server.destroy({pids:pids},function(res){
							if(res.status == 200){
								notification.bubble(lang.deleteSuccess);
								//根据pid数组删除对应的照片(model删除会触发删除相应的dom)
								_this.deleteModelByIds(pids);
							}else{
								notification.bubble(res.message);
							}
							notification.loading(false);
						});
					}
				},lang.deleteConfirm);
			},
			//回复照片
			restore:function(evt){
				if($(evt.currentTarget).closest("footer").hasClass("disable")) return;
				var _this = this;
				var pids = this.getSelectedPhotos().pids;
				if(pids.length == 0) return;
				notification.loading(true);
				c360.server.restore(pids,function(res){
					if(res.status == 200){
						notification.bubble(lang.recoverSuccess);
						//根据pid数组删除对应的照片(model删除会触发删除相应的dom)
						_this.deleteModelByIds(pids);
					}else{
						notification.bubble(res.message);
					}
					notification.loading(false);
				});
			},
			//清空回收站
			cleanRecycle:function(){
				var _this = this;
				if(this.collection.length){
					notification.confirm(lang.recycleDestroy,function(buttonIndex){
						if(buttonIndex == 1){//第一个按钮,即确定按钮
							notification.loading(true);
							c360.server.destroy({},function(res){
								if(res.status == 200){
									notification.bubble(lang.deleteSuccess);
								}else{
									notification.bubble(res.message);
								}
							});
							notification.loading(false);
							//清空collection
							_this.collection.reset();
							//清空dom,调用了empty后,提示文字也被清掉了,所以要重新添加进去
							_this.$("#photo-list").empty().html(_this.$ad);

							_this.$ad.show();

							_this.$more.hide();
						}
						
					},lang.deleteConfirm);
				}
			},
			selectedPhotosNumChange:function(num){
				if(num == undefined){
					this.$title.text(lang.recycle);
					this.$footer.addClass("disable");
				}else{
					var txt = lang.selectedPhotosNum.replace('{n}',num);
					if(lang.language == "en_US" && num<2){
						txt = lang.selectedPhotosNum.replace('{n} photos',num+" photo");
					}
					this.$title.text(txt);
					this.$footer.removeClass("disable");
				}
			}
		});

	}
});