(function(window) {

	//事件广播 nativeViewDispatchEvent 的回调
	window.__nativeViewDispatchEventCallbackHandler = function(resp){
		console.log('__nativeViewDispatchEventCallbackHandler:'+resp.event+"--"+location.href);
		try{
			var event = resp.event;
			var data = resp.data;
			if("[object String]"==Object.prototype.toString.call(data)){
				data = JSON.parse(data);//把回传的data反解析,是字符串形式的json则还原成json对象,是字符串数组的还原成数组
			}			
			if(window['c360'] && window['c360']['events']){
				// c360.event.trigger(event,[data]);
				c360.events.trigger(event,data);
			}else{
				$(document).trigger(event,[data]);
			}			
		}catch(err){
			console.log('__nativeViewDispatchEventCallbackHandler', err);
		}
	}

	//http://wiki.pinguo.us:8011/index.php?title=2.0%E4%BA%8C%E6%9C%9F%E4%B8%8AHTML5%E4%B8%8ENATIVE%E4%BA%A4%E4%BA%92%E6%8E%A5%E5%8F%A3%E6%96%87%E6%A1%A3#.E5.85.B3.E9.97.AD.E6.9C.80.E9.A1.B6.E7.BA.A7.E9.A1.B5.E9.9D.A2_closeTopestView
	var exec = null;
	var userData = null; //cache the userData for later use.
	var Native = function() {
		
		this.deviceType = ""; //手机型号， 字符串， 如： iPad3, iPhone4S, GT2345
		this.deviceScreenWidth = 0; //手机屏幕尺寸-宽度, 整形， 如： 1024
		this.deviceScreenHeight = 0; //手机屏幕尺寸-高度, 整形， 如： 1024
		this.deviceDPI = 0; //手机屏幕密度， 整形， 如 240
		this.deviceMac = ""; //手机MAC地址, 字符串，小写，如：f0:4d:a2:63:50:09， 如果获取不到请留长度为0的字符串
		this.softWareName = ""; //软件名字, 字符串，如：Camera360
		this.softWareVersion = ""; //软件版本号, 字符串，如：4.01, 3.0.3
		this.systemVersion = ""; //手机系统版本, 字符串, 如： iOS5.01， android4.1
		this.staticSystem = ""; //’ios’ 自己设定的系统常量，字符串，小写，可用的值为:  android wp8 ios
		this.nativeAPIVersion = 0; //云相册版本号, 整形， 如： 231
        this.lang = "";

		//cordova.addConstructor(function() {	});
	}

	var func = function(onSuccess, onFailure, className, method, param) {


		if (utils.isMobile) {
			var startTime = new Date().getTime();
			//输出调用信息
			utils.log('calling ' + className + "." + method + " with " + param.length + " params.");
			if (param.length) {
				for (var i = param.length - 1; i >= 0; i--) {
					utils.log('calling ' + className + "." + method + " " + i + ' ', param[i]);
				};
			}
			var callback = function(arg) {
				//输出函数调用后的信息
				utils.log('called ' + className + "." + method + ", cost=" + (new Date().getTime() - startTime));
				utils.log('called ' + className + "." + method + " ", arg);
				if (null != onSuccess) {
					onSuccess(arg);
				}
			}
			
			if (!exec) exec = cordova.require('cordova/exec');
			
			exec(callback, callback, className, method, param);
		}

	};



	//设置是否锁屏
	Native.prototype.userLogout = function(callBack) {
		func(callBack, callBack, "Native", "userLogout", []);
	};

	//设置是否锁屏
	Native.prototype.disabledScreenLock = function(arg, callBack) {
		func(callBack, callBack, "Native", "disabledScreenLock", [arg]);
	};
	//设置屏幕亮度
	Native.prototype.setBrightness = function(arg, callBack) {
		func(callBack, callBack, "Native", "setBrightness", [arg]);
	};
	//获取屏幕亮度
	Native.prototype.getBrightness = function(callBack) {
		func(callBack, callBack, "Native", "getBrightness", []);
	};

	//测试函数
	Native.prototype.doTest = function(callBack) {
		func(callBack, callBack, "Native", "doTest", []);
	};
	//初始化函数 doInit
	Native.prototype.doInit = function(callBack) {
		func(callBack, callBack, "Native", "doInit", []);
	};
	//反初始化函数 doUnInit
	Native.prototype.doUnInit = function(callBack) {
		func(callBack, callBack, "Native", "doUnInit", []);
	};
	//返回上一页面 backPreView
	Native.prototype.backPreView = function(callBack) {
		func(callBack, callBack, "Native", "backPreView", []);
	};

	//return the cached userData
	Native.prototype.getUser = function(callBack) {
		return userData || {};
	};

	//发短信 sendSMS
	Native.prototype.sendSMS = function(arg, callBack) {
		func(callBack, callBack, "Native", "sendSMS", [arg]);
	};

	//发短信 showStatusMessage
	Native.prototype.showStatusMessage = function(arg, callBack) {
		func(callBack, callBack, "Native", "showStatusMessage", [arg]);
	};



	//Loading displayLoadingIcon
	Native.prototype.displayLoadingIcon = function(arg, callBack) {
		arg.msg = arg.msg + "";
		func(callBack, callBack, "Native", "displayLoadingIcon", [arg]);
	};
	

	//气泡消息 showBubbleMessage
	Native.prototype.showBubbleMessage = function(arg, callBack) {
		arg.msg = arg.msg + "";
		func(callBack, callBack, "Native", "showBubbleMessage", [arg]);
	};

	//---------------------------------------------获取native信息------------------------------------------------------------
	//获取Native信息 getNativeInfo
	Native.prototype.getNativeInfo = function(callBack) {
		func(callBack, callBack, "Native", "getNativeInfo", []);
	};



	//---------------------------------------------设置和获取用户信息----------------------------------------------------------
	//设置用户信息 setLoginUser
	Native.prototype.setLoginUser = function(arg, callBack) {
		var _this = this;
		var cb = function(data) {
			_this.getLoginUser(function(info) {
				callBack(info);
			});
			
		}
		func(cb, cb, "Native", "setLoginUser", [arg]);
	};
	//获取用户信息 getLoginUser
	Native.prototype.getLoginUser = function(callBack) {
		if (null == userData || !userData.uid) {
			//cache the userData for later use.
			var cb = function(data) {
				userData = data;
				callBack(userData);
			}
			func(cb, cb, "Native", "getLoginUser", [{}]);
		} else {
			callBack(userData);
		}

	};
	

	
	//用户sina SSO 登陆 ssoLoginSina
	Native.prototype.ssoLogin = function(arg, callBack) {
		func(callBack, callBack, "Native", "ssoLogin", [arg]);
	};



	//---------------------------------------------云上传----------------------------------------------------------------------
	//获取上传信息getUploadInfo
	Native.prototype.getUploadInfo = function(callBack) {
		func(callBack, callBack, "Native", "getUploadInfo", [{}]);
	};
	//获取待上传照片的缩略图
	Native.prototype.getUploadImageThumb = function(callBack) {
		func(callBack, callBack, "Native", "getUploadImageThumb", [{}]);
	};
	//开始上传 startUploading
	Native.prototype.startUploading = function(arg, callBack) {
		func(callBack, callBack, "Native", "startUploading", [arg]);
	};
	//设置上传策略：针对android
	Native.prototype.setUploadSetting = function(arg, callBack) {
		func(callBack, callBack, "Native", "setUploadSetting", [arg]);
	};
	//开始上传
	Native.prototype.startDownload = function(arg, callBack) {
		func(callBack, callBack, "Native", "startDownload", [arg]);
	};
	//停止上传
	Native.prototype.stopDownload = function(callBack) {
		func(callBack, callBack, "Native", "stopDownload", [{}]);
	};
	//设置缓存数据：针对android
	Native.prototype.setLocalstorage = function(arg, callBack) {
		func(callBack, callBack, "Native", "setLocalstorage", [arg]);
	};
	//清除所有缓存数据：针对android
	Native.prototype.clearLocalstorage = function(arg , callBack) {
		func(callBack, callBack, "Native", "clearLocalstorage", [arg]);
	};
	//获取缓存数据：针对android
	Native.prototype.getLocalstorage = function(arg, callBack) {
		func(callBack, callBack, "Native", "getLocalstorage", [arg]);
	};
	//获取上传策略: 针对android
	Native.prototype.getUploadSetting = function(callBack) {
		func(callBack, callBack, "Native", "getUploadSetting", [{}]);
	};
	//获取上传状态: 针对android
	Native.prototype.getUploadEnableState = function(callBack) {
		func(callBack, callBack, "Native", "getUploadEnableState", [{}]);
	};
	Native.prototype.clearUploadedCount = function(callBack){
		func(callBack, callBack, "Native", "clearUploadedCount", [{}]);
	};
	//停止上传 stopUploading
	Native.prototype.stopUploading = function(callBack) {
		func(callBack, callBack, "Native", "stopUploading", [{}]);
	};



	//-------------------------------------------SNS同步-----------------------------------------------------------------------
	//设置SNS信息：setSNSInfo
	Native.prototype.setSNSInfo = function(arg, callBack) {
		func(callBack, callBack, "Native", "setSNSInfo", [arg]);
	};
	//获取SNS信息：getSNSInfo
	Native.prototype.getSNSInfo = function(callBack) {
		func(callBack, callBack, "Native", "getSNSInfo", [{}]);
	};


	//------------------------------------------版本自动更新-------------------------------------------------------------------
	//触发强制自动更新 upgradeForce
	Native.prototype.upgradeForce = function(arg, callBack) {
		func(callBack, callBack, "Native", "upgradeForce", [arg]);
	};
	//触发自动更新包下载 upgradeDownload
	Native.prototype.upgradeDownload = function(arg, callBack) {
		func(callBack, callBack, "Native", "upgradeDownload", [arg]);
	};
	//触发更新包解压 upgradeUnpack
	Native.prototype.upgradeUnpack = function(arg, callBack) {
		func(callBack, callBack, "Native", "upgradeUnpack", [arg]);
	};



	//------------------------------------------分享到Native--------------------------------------------------------------------

	//分享到QQ shareToQQ
	Native.prototype.shareToQQ = function(arg, callBack) {
		func(callBack, callBack, "Native", "shareToQQ", [arg]);
	};
	//分享到微信朋友圈接口 shareToWeixinGroup
	Native.prototype.shareToWeixinGroup = function(arg, callBack) {
		func(callBack, callBack, "Native", "shareToWeixinGroup", [arg]);
	};
	//通过微信分享信息到好友 shareToWeixin
	Native.prototype.shareToWeixin = function(arg, callBack) {
		func(callBack, callBack, "Native", "shareToWeixin", [arg]);
	};
	//检测用户本地是否安装有微信，QQ，客户端，是否支持新浪SSO登录
	Native.prototype.getNativeShareInfo = function(callBack) {
		func(callBack, callBack, "Native", "getNativeShareInfo", [{}]);
	};
	//检测用户本地是否安装有微信，QQ，客户端，是否支持新浪SSO登录
	Native.prototype.shareToSNS = function(arg,callBack) {
		func(callBack, callBack, "Native", "shareToSNS", [arg]);
	};



	//------------------------------------------首页照相模式获取----------------------------------------------------------------
	//home选择照相模式
	Native.prototype.gotoCameraMode = function(arg, callBack) {
		func(callBack, callBack, "Native", "gotoCameraMode", [arg]);
	};
	//home获取照相模式
	Native.prototype.getCameraMode = function(callBack) {
		func(callBack, callBack, "Native", "getCameraMode", [{}]);
	};


	//------------------------------------------页面控制API----------------------------------------------------------------------
	//读取页面列表 getNativeViews
	Native.prototype.getNativeViews = function(callBack) {
		func(callBack, callBack, "Native", "getNativeViews", [{}]);
	};
	//进入某个页面 gotoNativeView
	Native.prototype.gotoNativeView = function(arg, callBack) {
		//加上关闭webview事件监听,不在这加就得在所有页面点击返回(Android包含物理键)监听 by goingta
		try{
			c360.events.trigger("pageClose");
		}catch(e){
			
		}
		func(callBack, callBack, "Native", "gotoNativeView", [arg]);
	};
	//打开新页面 openNewView
	Native.prototype.openNewView = function(arg, callBack) {
		func(callBack, callBack, "Native", "openNewView", [arg]);
	};
	//关闭最顶级页面 closeTopestView
	Native.prototype.closeTopestView = function(callBack) {
		//加上关闭webview事件监听,不在这加就得在所有页面点击返回(Android包含物理键)监听 by goingta
		try{
			c360.events.trigger("pageClose");
		}catch(e){
			
		}
		func(callBack, callBack, "Native", "closeTopestView", [{}]);
	};


	//事件广播 nativeViewDispatchEvent
	Native.prototype.nativeViewDispatchEvent = function(arg,callBack) {
		if(typeof arg.data != "string"){
			arg.data = JSON.stringify(arg.data);
		}
		func(callBack, callBack, "Native", "nativeViewDispatchEvent", [arg]);
	};
	


	//------------------------------------------设置同步API----------------------------------------------------------------------
	//读取设置版本 getNativeSettingsVersion
	Native.prototype.getNativeSettingsVersion = function(callBack) {
		func(callBack, callBack, "Native", "getNativeSettingsVersion", [{}]);
	};
	//读取设置 getNativeSettings
	Native.prototype.getNativeSettings = function(callBack) {
		func(callBack, callBack, "Native", "getNativeSettings", [{}]);
	};
	//更新设置 setNativeSettings
	Native.prototype.setNativeSettings = function(arg, callBack) {
		func(callBack, callBack, "Native", "setNativeSettings", [arg]);
	};
	//读取服务器地址
	Native.prototype.getServerHost = function(callBack) {
		func(callBack, callBack, "Native", "getServerHost", []);
	};
	//设置服务器地址
	Native.prototype.setServerHost = function(arg, callBack) {
		func(callBack, callBack, "Native", "setServerHost", [arg]);
	};



	//------------------------------------------HTTP Request API----------------------------------------------------------------------
	Native.prototype.doHttpGet = function(url, params, callBack) {
		if (userData && userData.uid) {
			if (!params) {
				params = {};
			}
			params.localkey = userData.pwd;
		}
		func(callBack, callBack, 'HttpRequestPlugin', 'execute', [url, 'get', params, {
			trustAll: true
		}]);
	};

	Native.prototype.doHttpPost = function(url, params, callBack) {
		if (userData && userData.uid) {
			if (!params) {
				params = {};
			}
			params.localkey = userData.pwd;
		}
		func(callBack, callBack, 'HttpRequestPlugin', 'execute', [url, 'post', params, {
			trustAll: true
		}]);
	};

	//图片裁切 cropImage
	Native.prototype.cropImage = function(arg,callBack) {
		func(callBack, callBack, "Native", "cropImage", [arg]);
	};

	//清除指定回调
	Native.prototype.removeKeepedCallBack = function(arg,callBack) {
		func(callBack, callBack, "Native", "removeKeepedCallBack", [arg]);
	};

	//清除全部回调
	Native.prototype.removeAllKeepedCallBack = function(callBack) {
		func(callBack, callBack, "Native", "removeAllKeepedCallBack", []);
	};


	Native.prototype.getInfo=function(){
		return {
			deviceType: this.deviceType,
			deviceScreenWidth:this.deviceScreenWidth,
			deviceScreenHeight:this.deviceScreenHeight,
			deviceDPI:this.deviceDPI,
			deviceMac:this.deviceMac,
			softWareName:this.softWareName,
			softWareVersion:this.softWareVersion,
			systemVersion:this.systemVersion,
			staticSystem:this.staticSystem,
			nativeAPIVersion:this.nativeAPIVersion,
            lang:this.lang,
            ver: utils.ver
        };
	}

	


	if (!window.cNative) window.cNative = new Native();

})(window);