define(function(require, exports, module) {

	$.ns('c360.SNS');

	c360.SNS = {
		info: {},
		callback: {},
		loginsuccess: {},
		bindLen:0,
		unbindLen:0
	}

	c360.SNS.get = function(code){
		return this.info[code];
	};

	c360.SNS.getSNSList = function(callback) {
		var _this = this, nowTime = null, i = 0, len = 0, data = null;
		this.bindLen = 0;
		this.unbindLen = 0;
		c360.server.shareSNSList(function(json) {
			if(json.status == 200){
				nowTime = new Date().getTime();
				data = json.data;
				for(len = data.length; i < len ; i++){	
					if(data[i].binding == 1){
						++_this.bindLen;
					}else{
						++_this.unbindLen;
					}
					_this.info[data[i].name] = data[i];
					if(data.name != 'email'){
						_this.info[data[i].name].expire_in += nowTime;
					}
				}
				callback(data);
			}else{
				if(utils.isMobile){
					notification.bubble(json.message);
				}else{
					alert(json.message);
				}
			}
		});
	}

	c360.SNS.getSNSBind = function(){
		return {
			bindLen:this.bindLen,
			unbindLen:this.unbindLen
		};
	}

	c360.SNS.login = function(appcode, callback) {

		this.callback[appcode] = callback;

		this.loginsuccess[appcode] = false;

		var serverIp = $.serverIp || 'http://cloud.camera360.com',

			localkey = null,

			user = window.cNative.getUser(),

			deviceType = window.cNative.deviceType,

			url = null;

		if(user && user.data && user.data.localkey){
			localkey = user.data.localkey;
		}

		url = serverIp + '/sns/login/bindUrl?siteCode=' + appcode + '&source=mobile&redirect=1&localkey='+localkey+'&deviceType='+deviceType;

		utils.openWin.apply(this,[url, 'callResult', this.listener, this.rollback]);
	}

	//绑定SNS账号过程中,非正常退出时执行回滚操作,还原之前的操作
	c360.SNS.rollback = function(url) {

	}

	//loginCallback:绑定SNS账号成功后,提供给php调用的回调函数
	/*param : 
	 * isTrue bool true-成功,false-失败
	 * nickname var 对应社区用户昵称
	 * appcode var 对应社区的appcode
	 */
	c360.SNS.loginCallback = function(paramObj) {
		this.loginsuccess[paramObj.name] = paramObj.isTrue;
		if (paramObj.isTrue) {
			var nowTime = new Date().getTime();
		    paramObj.expire_in += nowTime;

			$.extend(this.info[paramObj.name], paramObj);

			this.info[paramObj.name].binding = 1;
			this.info[paramObj.name].status = 200;
			this.info[paramObj.name].site_code = paramObj.name;
			this.info[paramObj.name].nickname = paramObj.nickname;
			this.info[paramObj.name].avatar = paramObj.thirdFace;

			--this.unbindLen;
			
			++this.bindLen;
		}
		if (typeof this.callback[paramObj.name] == "function") {
			this.callback[paramObj.name](paramObj.isTrue, paramObj.name);
			delete this.callback[paramObj.name];
		}
	}

	c360.SNS.logout = function(appcode, callback) {
		var _this = this;
		server.share.setExpireTime(appcode, this.info[appcode].uid, function(resp) {
			if (resp.status == 200) {
				_this.info[appcode].binding = 0;
				_this.info[appcode].status = 400;
			}
			callback(resp, appcode);
		});
	}

	c360.SNS.listener = function(location) {

		var callbackUrl = location,

			callbackData = decodeURIComponent(callbackUrl),

			arr = callbackData.split('callResult?')[1].split('&'),

			paramObj = {},

			i = 0,

			arrLen = arr.length,

			keyAndValue = null;

		for (; i < arrLen; i++) {

			keyAndValue = arr[i].split('=');

			if(keyAndValue[0] == 'isTrue'){
				paramObj = $.extend(paramObj,{isTrue:keyAndValue[1]});
			}else if(keyAndValue[0] == 'thirdInfo'){
				paramObj = $.extend(paramObj,JSON.parse(keyAndValue[1]));
			}
		}

		this.loginCallback(paramObj);
		
	};
	
});