/**************************************************************************/
/*                                                                        */
/* Copyright (c)2010-2012  Pinguo Company             　　　　　　　      */
/*                 品果科技                            版权所有 2010-2012                    */
/*                                                                        */
/* PROPRIETARY RIGHTS of Pinguo Company are involved in the  　　　　　　 */
/* subject matter of this material.  All manufacturing, reproduction, use,*/
/* and sales rights pertaining to this subject matter are governed by the */
/* license agreement.  The recipient of this software implicitly accepts  */
/* the terms of the license.                                              */
/* 本软件文档资料是品果公司的资产,任何人士阅读和使用本资料必须获得                               */
/* 相应的书面授权,承担保密责任和接受相应的法律约束.                          */
/*                                                                        */
/**************************************************************************/

/*

	2013-08-20  跨相册大图浏览,导致的问题:
	1.分离相册时候,更新PRE和NEXT
	2.当前相册所有照片删除完,更新PRE和NEXT,
	3.修改临时相册主题名称,会导致生成永久相册并改变AID,需要更新PRE和NEXT
	4.导致的相同AID,但PRE和NEXT属性不同的排重问题.(暂时修改为lid not in max),

	上述问题,1,2,3项暂时做丢表处理. will change in the feature.
*/
(function(window) {
	$.ns("c360.cache");
	//静态常量
	var PAGE_NUM = 48;
	var b = c360.cache;

	b.db = null,

	b.isAvailable = function() {
		if (!c360.database || !c360.database.available) {
			return false;
		}

		if (!databaseRequest) {
			return false;
		}

		if (!databaseCallback) {
			return false;
		}

		return true;
	};

	b.filterRequest = function(requestData, ajaxRequest) {
		if (requestData.serverData && requestData.serverData.startTime) {
			requestData.serverData.startTime = Number(requestData.serverData.startTime);
		}
		var _this = this;
		var method = requestData.method;
		if (databaseRequest[method]) { //在请求时如果方法存在于request里走的分支
			utils.log("filterRequest 在请求时如果方法存在于request里走的分支");
			var tmpCallback = requestData.callback;
			requestData.callback = function(resp) {
				tmpCallback && tmpCallback(resp);
				if (resp.status == 200 && !resp._cache) {
					databaseCallback[method](resp.data, requestData.serverData);
				}
			}
			return databaseRequest[method].doFetchData(requestData, ajaxRequest);
		} else if (databaseCallback[method]) { //在请求时如果方法存在于callback里走的分支
			utils.log("filterRequest 在请求时如果方法存在于callback里走的分支");

			var tmpCallback = requestData.callback,
				delegateCallback = databaseCallback.controlCallbackArray.indexOf(requestData.method);

			if (delegateCallback >= 0) {
				requestData.callback = function(resp) {
					if (resp.status == 200) {
						databaseCallback[method](resp.data, requestData.serverData, tmpCallback, resp);
					} else {
						tmpCallback && tmpCallback(resp);
					}
				}
			} else {
				requestData.callback = function(resp) {
					if (resp.status == 200) {
						databaseCallback[method](resp.data, requestData.serverData);
					}
					tmpCallback && tmpCallback(resp);
				};
			}
			return ajaxRequest(requestData);
		} else {
			utils.log("filterRequest normal");
			return ajaxRequest(requestData);
		}
	};


	var databaseRequest = {

		config: {
			albumCount: PAGE_NUM,
			trashCount: PAGE_NUM,
			homeCount: 10,
			needUpdate: false
		}
	};

	databaseRequest['mobile/page/albums'] = {
		queryHomeToAlbum: function(item, res, obj, requestData, index, len, ajaxRequest) { // item, res, obj, requestData, i, len
			var length = res.rows.length,
				arr = [];
			for (var i = 0; i < length; i++) {
				var temp = res.rows.item(i);
				temp.pid = temp.id;
				arr.push(temp);
			}
			if (length % 4 == 0) {
				arr.pop();
			};
			item.covers = arr;
			obj.data.listData.push(item);
			if (index == len - 1) { //如果外部LOOP已经循环到最后一次，则执行callback
				utils.log("#### data is from local cache. Cost:" + (new Date().getTime() - requestData.t));
				if (len < 10) {
					obj.data.hasMore = false;
					c360.events && c360.events.trigger('appViewIsLoading');
					ajaxRequest(requestData);
				}

				utils.log('data is from local database and the count:' + len);
				if (len > 0) {
					requestData.callback(obj);
				}

			}
		},

		queryHome: function(tx, result, requestData, onFail, ajaxRequest) { //(tx, sql, param, arg, callback, startTime) {
			var _this = this;
			var startTime = requestData.serverData.startTime || false,
				obj = {
					_cache: true,
					message: 'success',
					status: 200,
					data: {
						hasMore: true,
						listData: []
					}
				};
			var len = result.rows.length,
				nowDate = new Date(),
				nowYear = nowDate.getFullYear(),
				nowMonth = nowDate.getMonth() + 1 < 10 ? '0' + (nowDate.getMonth() + 1) : (nowDate.getMonth() + 1),
				nowDay = nowDate.getDate() < 10 ? '0' + nowDate.getDate() : nowDate.getDate(),
				nowNumber = Number(nowYear + nowMonth + nowDay);

			if (len == 0) {
				ajaxRequest(requestData);
				return;
			};
			var item = null,
				flag = (lang.language == 'zh_CN' || lang.language == 'zh_TW') ? true : false;
			for (var i = 0; i < len; i++) {
				item = JSON.parse(JSON.stringify(result.rows.item(i)));
				delete item.readable;
				delete item.lid;

				var thisDate = new Date(parseFloat(item.dateTime) * 1000),
					thisYear = thisDate.getFullYear(),
					thisMonth = thisDate.getMonth() + 1 < 10 ? '0' + (thisDate.getMonth() + 1) : (thisDate.getMonth() + 1),
					thisDay = thisDate.getDate() < 10 ? '0' + thisDate.getDate() : thisDate.getDate(),
					thisNumber = Number(thisYear + thisMonth + thisDay);

				if (nowNumber == thisNumber && flag == true) {
					item.day = lang.today;
					item.yearMonth = '';
				} else if (nowNumber == thisNumber + 1 && flag == true) {
					item.day = lang.yestoday;
					item.yearMonth = '';
				} else if (nowNumber == thisNumber + 2 && flag == true) {
					item.day = lang.beforeYestoday;
					item.yearMonth = '';
				} else {
					item.day = thisDay;
					item.yearMonth = thisYear + '/' + thisMonth;
				}
				var sql = null;
				if (i == 0 && startTime == false) { //表示是置顶相册,封面数量为15张
					sql = 'SELECT * FROM album WHERE aid=? AND readable=1 ORDER BY cast(dateTime as float) limit 15';
				} else {
					sql = 'SELECT * FROM album WHERE aid=? AND readable=1 ORDER BY cast(dateTime as float) limit 7';
				}
				(function() {
					var k = i;
					var it = item;
					tx.executeSql(sql, [item.id], function(tx, res) {
						try {
							_this.queryHomeToAlbum(it, res, obj, requestData, k, len, ajaxRequest);
						} catch (err) {
							utils.log('!!! databaseRequest: mobile/page/albums ERROR ' + err);
							onFail(tx, err);
						};
					});
				})();
			}
		},

		doFetchData: function(requestData, ajaxRequest) {
			utils.log('databaseRequest: mobile/page/albums');

			var _this = this,
				startTime = requestData.serverData.startTime || false,
				paramArr = startTime == false ? [] : [startTime],
				onFailCalled = false,
				onFail = function(err) {
					if (!onFailCalled) {
						onFailCalled = true;
						ajaxRequest(requestData);
						c360.database.clearAllTables('drop');
						utils.log('databaseRequest: mobile/page/albums ' + err);
					}
				};

			var sql = 'SELECT * FROM home ORDER BY cast(dateTime as float) DESC limit 10';
			startTime && (sql = 'SELECT * FROM home WHERE cast(dateTime as float)<? ORDER BY cast(dateTime as float) DESC limit 10');

			c360.cache.db.transaction(function(tx) {
				tx.executeSql(sql, paramArr, function(tx, rs) {
					try {
						_this.queryHome(tx, rs, requestData, onFail, ajaxRequest);
					} catch (exp) {
						utils.log('!!! databaseRequest: mobile/page/albums ERROR ' + exp);

					}
				});
			}, onFail);
		}
	};

	databaseRequest['mobile/page/trash'] = {

		queryTrash: function(result, requestData, ajaxRequest) {
			var _this = this;
			var obj = {
				_cache: true,
				message: 'success',
				status: 200,
				data: {
					hasMore: true,
					listData: []
				}
			};

			var len = result.rows.length;
			for (var i = 0; i < len; i++) {
				obj.data.listData.push(result.rows.item(i));
			}
			utils.log("#### data is from local cache. Cost:" + (new Date().getTime() - requestData.t));

			if (len < PAGE_NUM) {
				obj.data.hasMore = false;
				c360.events && c360.events.trigger('appViewIsLoading');
				ajaxRequest(requestData);
			}
			utils.log('data is from local database and the count:' + len);
			if (len > 0) {
				requestData.callback(obj);
			}
		},

		doFetchData: function(requestData, ajaxRequest) {
			utils.log('databaseRequest: mobile/page/trash');
			var _this = this,
				startTime = requestData.serverData.startTime || false,
				sql = 'SELECT * FROM trash ORDER BY cast(dateTime as float) DESC LIMIT '+PAGE_NUM,
				paramArr = startTime ? [startTime] : [],
				onFailCalled = false,
				onFail = function(err) {
					if (!onFailCalled) {
						onFailCalled = true;
						c360.database.clearAllTables('drop');
						utils.log('databaseRequest: mobile/page/trash ' + err);
						ajaxRequest(requestData);
					}
				};

			startTime && (sql = 'SELECT * FROM trash WHERE cast(dateTime as float)<? ORDER BY cast(dateTime as float) DESC LIMIT '+PAGE_NUM);

			c360.cache.db.transaction(function(tx) {
				try {
					tx.executeSql(sql, paramArr, function(tx, result) {
						_this.queryTrash(result, requestData, ajaxRequest);
					}, onFail);
				} catch (err) {
					utils.log('!!! databaseRequest: mobile/page/trash ERROR ' + err);
					onFail();
				}
			}, onFail);
		}
	};


	databaseRequest['mobile/page/pictures'] = {

		queryAlbum: function(result, requestData, ajaxRequest) {
			var _this = this,
				obj = {
					_cache: true,
					message: 'success',
					status: 200,
					data: {
						listData: [],
						hasMore: true,
						albumData: {}
					}
				};

			var len = result.rows.length;

			for (var i = 0; i < len; i++) {
				obj.data.listData.push(result.rows.item(i));
			}
			if (len > 0) {
				obj.data.albumData.aid = result.rows.item(0).aid;
				obj.data.albumData.name = result.rows.item(0).name;
				obj.data.albumData.count = result.rows.item(0).count;
			}

			utils.log("#### data is from local cache. Cost:" + (new Date().getTime() - requestData.t));
			if (len < PAGE_NUM) {
				obj.data.hasMore = false;
				c360.events && c360.events.trigger('appViewIsLoading');
				ajaxRequest(requestData);
			}
			utils.log('data is from local database and the count:' + len);
			if (len > 0) {
				requestData.callback(obj);
			}
		},

		doFetchData: function(requestData, ajaxRequest) {
			utils.log('databaseRequest: mobile/page/pictures');
			var _this = this,
				startTime = requestData.serverData.startTime || false,
				aid = requestData.serverData.aid,
				limit = requestData.serverData.limit || PAGE_NUM,
				sql = 'SELECT * FROM album WHERE aid=? AND readable=1 ORDER BY cast(dateTime as float) limit ' + limit,
				paramArr = startTime ? [aid, startTime] : [aid],
				onFailCalled = false,
				onFail = function(err) {
					if (!onFailCalled) {
						onFailCalled = true;
						c360.database.clearAllTables('drop');
						utils.log('databaseRequest: mobile/page/pictures ' + err);
						ajaxRequest(requestData);
					}
				};
			startTime && (sql = 'SELECT * FROM album WHERE aid=? AND readable=1 AND cast(dateTime as float)>? ORDER BY cast(dateTime as float) limit ' + limit);
			c360.cache.db.transaction(function(tx) {
				try {
					tx.executeSql(sql, paramArr, function(tx, result) {
						_this.queryAlbum(result, requestData, ajaxRequest);
					}, onFail);
				} catch (err) {
					utils.log('!!! databaseRequest: mobile/page/pictures ERROR ' + err);
					onFail();
				};
			}, onFail);
		}
	};

	databaseRequest['mobile/page/pictureInfo'] = {
		queryPicture: function(result, obj, requestData, ajaxRequest) {
			var _this = this;
			var len = result.rows.length;

			if (len == 0) {
				ajaxRequest(requestData);
				return;
			}

			for (var i = 0; i < len; i++) {
				obj.data.list.push(result.rows.item(i));
			}

			utils.log("#### data is from local cache. Cost:" + (new Date().getTime() - requestData.t));
			utils.log('data is from local database and the count:' + len);
			requestData.callback(obj);
		},

		doFetchData: function(requestData, ajaxRequest) {
			utils.log('databaseRequest: mobile/page/pictureInfo');
			var _this = this,
				aid = requestData.serverData.aid,
				startTime = requestData.serverData.startTime,
				dir = requestData.serverData.dir,
				limit = requestData.serverData.limit || 10, 
				obj = {
					_cache: true,
					message: 'success',
					status: 200,
					data: {
						hasMore: true,
						list: []
					}
				},
				sql = 'SELECT * FROM photo WHERE cast(dateTime as float)>? AND readable=1 AND aid=? ORDER BY cast(dateTime as float) limit ?',
				onFailCalled = false,
				onFail = function(err) {
					if (!onFailCalled) {
						onFailCalled = true;
						c360.database.clearAllTables('drop');
						utils.log('databaseRequest: mobile/page/pictureInfo ' + err);
						ajaxRequest(requestData);
					}
				};

			if (!startTime) { //如果没有startTime 表示跨相册,直接请求服务器.
				ajaxRequest(requestData);
				return;
			}

			if (dir != 1) {
				sql = 'SELECT * FROM photo WHERE cast(dateTime as float)<? AND readable=1 AND aid=? ORDER BY cast(dateTime as float) DESC limit ?';
			}
			c360.cache.db.transaction(function(tx) {
				try {
					tx.executeSql(sql, [startTime, aid, limit], function(tx, result) {
						_this.queryPicture(result, obj, requestData, ajaxRequest, dir);
					}, onFail);
				} catch (err) {
					utils.log('!!! databaseRequest: mobile/page/pictureInfo ERROR ' + err);
					onFail();
				};
			}, onFail);
		}
	};


	var databaseCallback = {

		controlCallbackArray: ['mobile/picture/delete', 'mobile/picture/restore', 'mobile/album/splitPhotos'],

		//回收站请求数据时,将数据插入TRASH表,并删除重复的数据
		'mobile/page/trash': function(data) {
			var arr = data.listData,
				onFailCalled = false,
				onFail = function(err) {
					if (!onFailCalled) {
						onFailCalled = true;
						utils.log('databaseCallback mobile/page/trash ERROR:' + err);
						c360.database.clearAllTables('drop');
					}
				};

			utils.log('databaseCallback: mobile/page/trash');
			c360.cache.db.transaction(function(tx) {

				for (var i = 0; i < arr.length; i++) {
					tx.executeSql('INSERT INTO trash (id, key, dateTime) VALUES(?,?,?)', [arr[i].id, arr[i].key, arr[i].dateTime],

						function(tx, result) {}, onFail);
				}
				tx.executeSql('DELETE FROM trash WHERE lid NOT IN(SELECT MAX(lid) FROM trash GROUP BY id)', [],

					function(tx, result) {
						utils.log('localdatabase:' + 'clear repeat success!');
					}, onFail);
			}, onFail);
		},

		//相册内页请求数据时,将数据插入ALBUM表,并删除重复的数据,还要将数据组装并写入PHOTO表
		"mobile/page/pictures": function(res, param) {
			utils.log('databaseCallback: mobile/page/pictures');
			var album = res.albumData,
				list = res.listData,
				len = list.length,
				onFailCalled = false,
				onFail = function(err) {
					if (!onFailCalled) {
						onFailCalled = true;
						utils.log('databaseCallback mobile/page/pictures ERROR:' + err);
						c360.database.clearAllTables('drop');
					}

				};
			var timer1 = new Date().getTime();
			c360.cache.db.transaction(function(tx) {
				tx.executeSql('UPDATE home SET count=? WHERE id=?', [album.count, album.aid], function(tx, result) {
					utils.log('update home table count success');
				}, onFail);

				tx.executeSql('UPDATE album SET count=? WHERE aid=?', [album.count, album.aid], function(tx, result) {
					utils.log('update album table count success');
				}, onFail);
				for (var i = 0; i < len; i++) {
					tx.executeSql('INSERT INTO album (aid,name,count,id,key,dateTime,date,location,w,h,desc,readable) VALUES(?,?,?,?,?,?,?,?,?,?,?,?)', [album.aid, album.name, album.count, list[i].id, list[i].key, list[i].dateTime, list[i].date, list[i].location, list[i].w, list[i].h, list[i].desc, 1],

						function(tx, result) {
							utils.log('localdatabase:' + 'save data success in album page');
						}, onFail);
					tx.executeSql('INSERT INTO photo (aid,pid,key,w,h,desc,dateTime,readable) VALUES(?,?,?,?,?,?,?,?)', [param.aid, list[i].id, list[i].key, list[i].w, list[i].h, list[i].desc, list[i].dateTime, 1],

						function(tx, result) {
							utils.log('localdatabase:' + 'save data success in photo page');
						}, onFail);
				}

				tx.executeSql('DELETE FROM album WHERE lid NOT IN(SELECT MAX(lid) FROM album GROUP BY id)', [],

					function(tx, result) {
						utils.log('localdatabase:' + 'clear repeat success!');
					}, onFail);

				tx.executeSql('DELETE FROM photo WHERE lid NOT IN(SELECT MAX(lid) FROM photo GROUP BY pid)', [],

					function(tx, result) {
						utils.log('localdatabase:' + 'clear repeat success!');
					}, onFail);
			}, onFail, function() {
				var timer2 = new Date().getTime();
				console.log('insert into database cost:' + timer2 - timer1);
			});
		},

		//设置照片的描述,同时要更新ALBUM表和PHOTO表的数据
		'mobile/picture/setDesc': function(res, param) {
			var onFailCalled = false,
				onFail = function(err) {
					if (!onFailCalled) {
						onFailCalled = true;
						utils.log('databaseCallback mobile/picture/setDesc ERROR:' + err);
						c360.database.clearAllTables('drop');
					}

				};
			c360.cache.db.transaction(function(tx) {
				tx.executeSql('UPDATE album SET desc=? WHERE id=?', [param.desc, param.pid], function(tx, result) {
					utils.log('localdatabase:' + 'change photo description success in album');
				}, onFail);

				tx.executeSql('UPDATE photo SET desc=? WHERE pid=?', [param.desc, param.pid], function(tx, result) {
					utils.log('localdatabase:' + 'change photo description success in photo');
				}, onFail);
			}, onFail);
		},

		//设置相册的描述,同时要更新ALBUM表和PHOTO表的数据
		'mobile/album/setName': function(res, param) {
			var newAid = res.aid,
				oldAid = param.aid,
				name = res.name?res.name:'',
				location = res.location?res.location:'';
			var onFailCalled = false,
				onFail = function(err) {
					if (!onFailCalled) {
						onFailCalled = true;
						utils.log('databaseCallback mobile/album/setName ERROR:' + err);
						c360.database.clearAllTables('drop');
					}
				};

			if(newAid != oldAid){
				onFail();//因为相册清空后，AID将消失，导致相邻两个相册的pre和next属性改变,操作量巨大,所有暂时重置表  	//will change by zhangzhi
			}
			utils.log('databaseCallback: mobile/album/setName');
			c360.cache.db.transaction(function(tx) {
				tx.executeSql('UPDATE home SET id=?,name=?,location=? WHERE id=?', [newAid,name,location,oldAid], function(tx, result) {
					utils.log('localdatabase:' + 'change album name success in home table');
				}, onFail);

				tx.executeSql('UPDATE album SET aid=?,name=?,location=? WHERE aid=?', [newAid,name,location,oldAid], function(tx, result) {
					utils.log('localdatabase:' + 'change album name success in album table');
				}, onFail);

				tx.executeSql('UPDATE photo SET aid=? WHERE aid=?', [newAid, oldAid], function(tx, result) {
					utils.log('localdatabase:' + 'change photo table aid success in photo table');
				}, onFail);

			}, onFail);
		},

		//当删除照片的时候,需要根据所删除照片的PID把ALBUM表,PHOTO表里的对应数据的READABLE属性设置为0,并将数据添加进TRASH表
		'mobile/picture/delete': function(res, param, callback, resp) {
			var hasCallbacked = false, //是否已经调用过callback,为了解决android多次回调transaction的问题
				onFailCalled = false,
				onFail = function(err) {
					if (!onFailCalled && !hasCallbacked) {
						if (callback) {
							callback(resp);
						}
						hasCallbacked = true;
						onFailCalled = true;
						utils.log('databaseCallback mobile/picture/delete ERROR:' + err);
						c360.database.clearAllTables('drop');
					}

				};
			utils.log('databaseCallback: mobile/picture/delete');
			var len = param.pids.length,
				arr = [];
			param.pids.forEach(function(item) {
				arr.push("'" + item + "'");

			});
			var str = arr.join(",");
			c360.cache.db.transaction(function(tx) {
				tx.executeSql('SELECT * FROM album WHERE id IN(' + str + ')', [], function(tx, result) {
					for (var i = 0; i < result.rows.length; i++) {
						var option = result.rows.item(i);
						utils.log(option.id, option.key, option.dateTime);
						tx.executeSql('INSERT INTO trash (id, key, dateTime) VALUES(?,?,?)', [option.id, option.key, option.dateTime]);
					}
				}, onFail);

				tx.executeSql('UPDATE photo SET readable=0 WHERE pid IN(' + str + ')', [], function(tx, result) {
					utils.log('localdatabase:' + 'delete photos success in photo table');
				}, onFail);

				tx.executeSql('UPDATE album SET readable=0 WHERE id IN(' + str + ')', [], function(tx, result) {
					utils.log('localdatabase:' + 'delete photos success in album table');
				}, onFail);
				tx.executeSql('SELECT aid,count FROM album WHERE id=?', [param.pids[0]], function(tx, result) {
					if ((result.rows.item(0).count - len) == 0) { //count -len ==0 表示该相册内的照片已经全部删除完
						onFail();//因为相册清空后，AID将消失，导致相邻两个相册的pre和next属性改变,操作量巨大,所有暂时重置表  	//will change by zhangzhi
						tx.executeSql('DELETE FROM album WHERE aid=?', [result.rows.item(0).aid], function(tx, result) {}, onFail);
						tx.executeSql('DELETE FROM photo WHERE aid=?', [result.rows.item(0).aid], function(tx, result) {}, onFail);
						tx.executeSql('DELETE FROM home WHERE id=?', [result.rows.item(0).aid], function(tx, result) {}, onFail);
					} else { //否则就改变相册COUNT数
						tx.executeSql('UPDATE home SET count=count-' + len + ' WHERE id=?', [result.rows.item(0).aid], function(tx, result) {}, onFail);
						tx.executeSql('UPDATE album SET count=count-' + len + ' WHERE aid=?', [result.rows.item(0).aid], function(tx, result) {}, onFail);
					}

				}, onFail);
			}, onFail, function() {
				if (callback && !hasCallbacked) {
					hasCallbacked = true;
					callback(resp);
				}
			});
		},

		//照片还原, 清空所有表
		'mobile/picture/restore': function(res, param, callback, resp) {

			utils.log('databaseCallback: mobile/picture/restore');
			c360.database.clearAllTables('drop', function() {
				if (callback) {
					callback(resp);
				}
			}, function() {
				if (callback) {
					callback(resp);
				}
			});
		},

		//首页相册的数据
		'mobile/page/albums': function(res) {
			var onFailCalled = false,
				onFail = function(err) {
					if (!onFailCalled) {
						onFailCalled = true;
						utils.log('databaseCallback mobile/page/albums ERROR:' + err);
						c360.database.clearAllTables('drop');
					}

				};
			utils.log('databaseCallback: mobile/page/albums');
			var timer1 = new Date().getTime();
			c360.cache.db.transaction(function(tx) {
				res.listData.forEach(function(item) {
					tx.executeSql('INSERT INTO home (id,dateTime,name,count,yearMonth,day,location,readable,pre,next) VALUES(?,?,?,?,?,?,?,?)', [item.id, parseFloat(item.dateTime), item.name, item.count, item.yearMonth, item.day, item.location, 1,item.pre,item.next], function(tx, result) {
						utils.log('localdatabase:' + 'save data success in home table');
					}, onFail);
					item.covers.forEach(function(res) {
						tx.executeSql('INSERT INTO album (aid,name,count,id,key,dateTime,date,location,w,h,desc,readable) VALUES(?,?,?,?,?,?,?,?,?,?,?,?)', [item.id, item.name, item.count, res.pid, res.key, res.dateTime, res.date, res.location, res.w, res.h, res.desc, 1],

							function(tx, result) {
								utils.log('localdatabase:' + 'save data success in album page');
							}, onFail);

						tx.executeSql('INSERT INTO photo (aid,pid,key,w,h,desc,dateTime,readable) VALUES(?,?,?,?,?,?,?,?)', [item.id, res.pid, res.key, res.w, res.h, res.desc, res.dateTime, 1],

							function(tx, result) {
								utils.log('localdatabase:' + 'save data success in photo page');
							}, onFail);
					});
				});

				tx.executeSql('DELETE FROM home WHERE lid NOT IN(SELECT MAX(lid) FROM home GROUP BY id)', [],

					function(tx, result) {
						utils.log('localdatabase:' + 'clear repeat success!');
					}, onFail);

				tx.executeSql('DELETE FROM photo WHERE lid NOT IN(SELECT MAX(lid) FROM photo GROUP BY pid)', [],

					function(tx, result) {
						utils.log('localdatabase:' + 'clear repeat success!');
					}, onFail);

				tx.executeSql('DELETE FROM album WHERE lid NOT IN(SELECT MAX(lid) FROM album GROUP BY id)', [],

					function(tx, result) {
						utils.log('localdatabase:' + 'clear repeat success!');
					}, onFail);
			}, onFail, function() {
				var timer2 = new Date().getTime();
				console.log('insert into database cost:' + (timer2 - timer1));
			});
		},

		//销毁照片,删除TRASH表数据,如果是清空,则再删除ALBUM和PHOTO的所有不可读数据,如果是指定删除,则根据删除的PID删除ALBUM和PHOTO中对应的数据
		'mobile/picture/destroy': function(res, param) {
			var onFailCalled = false,
				onFail = function(err) {
					if (!onFailCalled) {
						onFailCalled = true;
						utils.log('databaseCallback mobile/picture/destroy ERROR:' + err);
						c360.database.clearAllTables('drop');
					}
				};
			utils.log('databaseCallback: mobile/picture/destroy');
			c360.cache.db.transaction(function(tx) {
				if (param.pids == undefined) {
					tx.executeSql('DELETE FROM trash', [], function(tx, result) {}, onFail);
					tx.executeSql('DELETE FROM album WHERE readable=0', [], function(tx, result) {}, onFail);
					tx.executeSql('DELETE FROM photo WHERE readable=0', [], function(tx, result) {}, onFail);
				} else {
					var len = param.pids.length,
						arr = [];
					param.pids.forEach(function(item) {
						arr.push("'" + item + "'");

					});
					var str = arr.join(",");
					tx.executeSql('DELETE FROM trash WHERE id IN(' + str + ')', [], function(tx, result) {}, onFail);
					tx.executeSql('DELETE FROM album WHERE id IN(' + str + ')', [], function(tx, result) {}, onFail);
					tx.executeSql('DELETE FROM photo WHERE pid IN(' + str + ')', [], function(tx, result) {}, onFail);
				}
			}, onFail);
		},

		'mobile/page/pictureInfo': function(res, param) {
			var onFailCalled = false,
				onFail = function(err) {
					if (!onFailCalled) {
						onFailCalled = true;
						utils.log('databaseCallback mobile/page/pictureInfo ERROR:' + err);
						c360.database.clearAllTables('drop');
					}

				};
			utils.log('databaseCallback: mobile/page/pictureInfo');
			c360.cache.db.transaction(function(tx) {
				res.list.forEach(function(item, index) {
					tx.executeSql('INSERT INTO photo (aid,pid,key,w,h,desc,dateTime,readable) VALUES(?,?,?,?,?,?,?,?)', [param.aid, item.pid, item.key, item.w, item.h, item.desc, item.dateTime, 1],

						function(tx, result) {
							if (index == res.list.length - 1) {
								tx.executeSql('DELETE FROM photo WHERE lid NOT IN(SELECT MAX(lid) FROM photo GROUP BY pid)', [],

									function(tx, result) {
										utils.log('localdatabase:' + 'clear repeat success!');
									}, onFail);
							}
							utils.log('localdatabase:' + 'save data success in photo page');
						}, onFail);
				});
			}, onFail);
		},

		//分离照片,需要更新HOME,ALBUM, photo表
		'mobile/album/splitPhotos': function(res, param, callback, resp) {
			var hasCallbacked = false,
				onFailCalled = false,
				onFail = function(err) {
					if (!onFailCalled && !hasCallbacked) {
						if (callback) {
							callback(resp);
						};
						hasCallbacked = true;
						onFailCalled = true;
						utils.log('databaseCallback mobile/album/splitPhotos ERROR:' + err);
						c360.database.clearAllTables('drop');
					}

				};
				onFail();//因为相册清空后，AID将消失，导致相邻两个相册的pre和next属性改变,操作量巨大,所有暂时重置表  	//will change by zhangzhi
			utils.log('databaseCallback: mobile/album/splitPhotos');
			var oldAid = param.aid,
				name = param.name,
				arr = [],
				len = param.pids.length;
			param.pids.forEach(function(item) {
				arr.push("'" + item + "'");

			});
			var str = arr.join(",");
			//更改ALBUM中的被分离的照片数据,更改的有AID,NAME,COUNT属性,
			//更改ALBUM中原始相册的COUNT属性,
			//更改HOME表中原始相册的COUNT属性,
			//在新相册的数据中找到时间最早的照片的DATETIME,并转换成新相册需要的属性,按照倒序查找LOCATION字段不为空的3条数据并生成相册的LOCATION,
			//最后将新的相册数据插入HOME表
			c360.cache.db.transaction(function(tx) {
				tx.executeSql('UPDATE photo SET aid=? WHERE id IN(' + str + ')', [res.aid], function(tx, result){
					utils.log('update photo table the aid of some photo bacause splitPhotos');
				}, onFail);
				tx.executeSql('UPDATE album SET aid=?,count=?,name=? WHERE id IN(' + str + ')', [res.aid, len, name], function(tx, result) {
					tx.executeSql('UPDATE album SET count=count-' + len + ' WHERE aid=?', [oldAid], function(tx, result) {}, onFail);
					tx.executeSql('UPDATE home SET count=count-' + len + ' WHERE id=?', [oldAid], function(tx, result) {
						tx.executeSql('SELECT count FROM home WHERE id=?', [oldAid], function(tx, result) {
							if (result.rows.length == 0) {
								tx.executeSql('DELETE FROM home WHERE id=?', [oldAid], function(tx, result) {
									utils.log('this data in home is empty so delete it success');
								}, function(tx, error) {});
							}
						}, onFail);
					}, onFail);

					tx.executeSql('SELECT dateTime FROM album WHERE id IN(' + str + ') ORDER BY cast(dateTime as float)', [], function(tx, result) {
						var albumDateTime = Number(result.rows.item(0).dateTime),
							time = new Date(albumDateTime * 1000),
							year = time.getFullYear(),
							month = time.getMonth() + 1,
							day = time.getDate(),
							yearMonth = year + '-' + (month < 10 ? '0' + month : month);

						tx.executeSql('SELECT location FROM album WHERE aid=? AND location!="" ORDER BY cast(dateTime as float) DESC limit 15', [res.aid], function(tx, result) {
							var location = [],
								loopLen = result.rows.length > 3 ? 3 : result.rows.length;
							for (var i = 0; i < loopLen; i++) {
								location.push(result.rows.item(i).location);
							}
							var locationStr = location.join(',');
							tx.executeSql('INSERT INTO home (id,dateTime,name,count,yearMonth,day,location,readable) VALUES(?,?,?,?,?,?,?,?)', [res.aid, albumDateTime, name, len, yearMonth, day, locationStr, 1],

								function(tx, result) {}, onFail);
						}, onFail);
					}, onFail);
				}, onFail);
			}, onFail, function() {
				//托管callback
				if (callback && !hasCallbacked) {
					hasCallbacked = true;
					callback(resp);
				}
			});
		}

	};

})(window);