 /**************************************************************************/
 /*                                                                        */
 /* Copyright (c)2010-2012  Pinguo Company             　　　　　　　      */
 /*                 品果科技                            版权所有 2010-2012                    */
 /*                                                                        */
 /* PROPRIETARY RIGHTS of Pinguo Company are involved in the  　　　　　　 */
 /* subject matter of this material.  All manufacturing, reproduction, use,*/
 /* and sales rights pertaining to this subject matter are governed by the */
 /* license agreement.  The recipient of this software implicitly accepts  */
 /* the terms of the license.                                              */
 /* 本软件文档资料是品果公司的资产,任何人士阅读和使用本资料必须获得                               */
 /* 相应的书面授权,承担保密责任和接受相应的法律约束.                          */
 /*                                                                        */
 /**************************************************************************/

 (function(window) {
 	$.ns('c360.database');
 	var a = c360.database;
 	a.available = false;
 	var db = null;
 	a.db = db;
 	a.localStorageReady = window.localStorage ? true : false;

 	/*
 	 * 本地存储数据:
 	 * isCreated  数据库是否已经创建, 如果未创建,则不走缓存.  只有在"我的云相册"页面第一次请求数据的时候创建数据库
 	 * isTruncated 数据库是否已经被清库了, 如果已经被清库, 则只有在"我的云相册"页面第一次请求数据的时候开始插入数据
 	 * lang  数据库的语言, 如果发现数据库语言与当前语言不符, 则需要清库
 	 * version  数据库的版本, 如果发现版本与utils.ver不符,则不走缓存, 并需要删除数据库
 	 *
 	 */
 	a.get = function(key) {
 		return window.localStorage.getItem("database." + key);
 	}
 	a.set = function(key, data, callback) {
 		window.localStorage.setItem("database." + key, data);
 		callback && callback();
 	}

 	a.trans = function(transaction, fail, success) {
 		if (db) {
 			db.transaction(transaction, fail, success);
 		} else {
 			fail({
 				message: 'database is not ready'
 			});
 		}
 	}

 	a.checkAvailable = function(lang, version) {
 		if (lang != this.get('lang')) {
 			console.log("database available: lang dose not match!");
 			return false;
 		}
 		if (version != this.get('version')) {
 			console.log("database available: version dose not match!");
 			return false;
 		}
 		if (this.get('isCreated') == 'false' || this.get('isCreated') == null) {
 			console.log("database available: table is not created yet!");
 			return false;
 		}
 		return true;
 	}

 	a.openDataBase = function() {
 		try {
 			if (!window.openDatabase) {
 				console.log("window.openDatabase is not supported!");
 				return false;
 			}
 			db = window.openDatabase('camera360_beta1', '1', 'My Database', 3 * 1024 * 1024);
 			return db;
 		} catch (err) {
 			console.log("open db failed: " + err);
 			return false;
 		};
 	};


 	/*
	数据库清除的触发条件
	1. 用户注销 delete
	2. 强制刷新 delete  由于强制刷新的特殊性,因清表后的立即刷新,可能导致清表操作不完全,导致页面白屏,所以采用设置isCreated的方法,在刷新后,再从新建表
	3. 回收站还原操作 delete trash表保留
	*/
 	a.clearAllTables = function(method, fail, success) {
 		var _this = this,
 			count = 0,
 			total = 4,
 			sql = null,
 			method = method || 'drop';
 		if (method.toLowerCase() == 'drop') {
 			sql = 'DROP TABLE IF EXISTS ';
 		} else if (method.toLowerCase() == 'delete') {
 			sql = 'DELETE FROM ';
 		};
 		this.trans(function(tx) {
 			tx.executeSql(sql + 'home');
 			tx.executeSql(sql + 'album');
 			tx.executeSql(sql + 'photo');
 			tx.executeSql(sql + 'trash');
 		}, function(err) {
 			count = -10000000;
 			fail && fail(err);
 			console.log('clearAllTables fail');
 			method == 'drop' && _this.set('isCreated', 'false');
 		}, function(tx, result) {
 			if (utils.supportDatebase) {
 				method == 'drop' && _this.set('isCreated', 'false');
 				console.log('clearAllTables success and the isCreated is seted "false"');
 				success && success(tx, result);
 			} else {
 				if (++count >= total) {
 					method == 'drop' && _this.set('isCreated', 'false');
 					console.log('clearAllTables success and the isCreated is seted "false"');
 					success && success(tx, result);
 				}
 			}
 		});
 	};

 	a.createTable = function(drop, fail, success) {
 		var _this = this,
 			count = 0,
 			total = drop == true ? 12 : 8;
 		this.trans(function(tx) {
 			if (drop) {
 				tx.executeSql('DROP TABLE IF EXISTS home');
 				tx.executeSql('DROP TABLE IF EXISTS album');
 				tx.executeSql('DROP TABLE IF EXISTS photo');
 				tx.executeSql('DROP TABLE IF EXISTS trash');
 			}
 			tx.executeSql('CREATE TABLE IF NOT EXISTS home(lid INTEGER PRIMARY KEY AUTOINCREMENT, id TEXT, dateTime TEXT, name TEXT, count INTEGER, yearMonth TEXT, day INTEGER, location TEXT, readable INTEGER, pre TEXT, next TEXT)');
 			tx.executeSql('CREATE TABLE IF NOT EXISTS trash(lid INTEGER PRIMARY KEY AUTOINCREMENT, id TEXT, key TEXT, dateTime TEXT)');
 			tx.executeSql('CREATE TABLE IF NOT EXISTS album(lid INTEGER PRIMARY KEY AUTOINCREMENT, aid TEXT, name TEXT, count INTEGER, id TEXT, key TEXT, dateTime TEXT, date TEXT, location TEXT, w INTEGER, h INTEGER, desc TEXT, readable INTEGER)');
 			tx.executeSql('CREATE TABLE IF NOT EXISTS photo(lid INTEGER PRIMARY KEY AUTOINCREMENT, aid TEXT, pid TEXT, key TEXT, w INTEGER, h INTEGER, desc TEXT, dateTime TEXT, readable INTEGER)');

 			tx.executeSql('CREATE INDEX IF NOT EXISTS home_dateTime ON home(dateTime ASC)');
 			tx.executeSql('CREATE INDEX IF NOT EXISTS trash_dateTime ON trash(dateTime ASC)');
 			tx.executeSql('CREATE INDEX IF NOT EXISTS album_dateTime ON album(dateTime ASC)');
 			tx.executeSql('CREATE INDEX IF NOT EXISTS photo_dateTime ON photo(dateTime ASC)');
 		}, function(err) {
 			fail && fail(err);
 			count = -10000000;
 		}, function(tx, result) {
 			if (utils.supportDatebase) {
 				console.log('createTable success');
 				success && success(tx, result);
 			} else {
 				if (++count >= total) {
 					console.log('createTable success');
 					success && success(tx, result);
 				}
 			}
 		});
 	};

 	a.gotoCheckCache = function(p, doAjaxRequest) {
 		if (c360.cache && c360.cache.isAvailable()) {
 			return c360.cache.filterRequest(p, doAjaxRequest);
 		} else {
 			return doAjaxRequest(p);
 		}
 	};

 	a.theFirstRequestInHome = function(p) {
 		if (p.method == 'mobile/page/albums' && !p.serverData.startTime) {
 			return true;
 		} else {
 			return false;
 		}
 	};

 	a.initDB = function(doAjaxRequest, p, logout) {
 		var _this = this;
 		if (!a.localStorageReady) {
 			console.log('localStorageReady is false');
 			doAjaxRequest && doAjaxRequest(p);
 			return;
 		};

 		console.log('localStorageReady is true');
 		if (!db) {
 			if (c360.cache) {
 				c360.cache.db = db = _this.openDataBase();
 			} else {
 				doAjaxRequest && doAjaxRequest(p);
 				return;
 			}
 		};

 		if(logout){ //注销功能，只需要初始化数据库
  			return;
 		}

 		if (db) { // 如果DB打开成功,则检测lang,version,isCreated
 			console.log('open database success');
 			if (_this.checkAvailable(lang.language, utils.ver) == true) { //如果表存在，并且版本语言都没有改变，就进行下一步筛选
 				_this.available = true;
 				_this.gotoCheckCache(p, doAjaxRequest);

 			} else if (_this.theFirstRequestInHome(p)) { //如果版本或者语言改变，或没有创建过表，并且是主题页面的第一次ＡＪＡＸ请求则清表重建立
 				console.log('this is the first request in home page and try to create tables');
 				a.createTable(true, function(err) { // 建表失败
 					_this.set('isCreated', 'false');
 					_this.available = false;
 					console.log('opening database success, creating table failed', err);
 					doAjaxRequest && doAjaxRequest(p);

 				}, function() { // 建表成功，进行下一步筛选
 					_this.set('isCreated', 'true');
 					_this.set('lang', lang.language);
 					_this.set('version', utils.ver);
 					_this.available = true;
 					console.log('opening database & creating table success');
 					_this.gotoCheckCache(p, doAjaxRequest);
 				});

 			} else {
 				doAjaxRequest && doAjaxRequest(p);
 			};

 		} else {
 			console.log('opening database failed');
 			doAjaxRequest && doAjaxRequest(p);
 		};
 	};

 })(window);