define(function(require, exports, module) {

	$.ns("c360.downloadPhoto");

	require('css/download.css');
	var FILTER_VERSION = 8;
	var winAlert = require('ui/dialog/progress/progress.js'),
		alertDialog = require('ui/dialog/alert/alert');
		myTimer = 0,

		//多张图片上传模版
		downloadMethodOneTemplate = _.template(" <div class='title'><%= lang.isDownloading %>&nbsp;<span class='nowCount' id='nowCount'>1</span>/<span class='totalCount' id='totalcount'><%= count%></span></div>\
									<div class='content'><div class='restTime' id='restTime'><%= lang.uploadRestTime%><span><%= lang.isCalcing%></span></div>\
									<div id='progress' class='progress'><div class='nowProgress' id='nowProgress'></div></div></div><br/><br/>\
									<div class='progressNotice'><%= lang.downloadPhotoPath%></div>\
									<div class='btns certain' btn-name='alert-dialog-certain'>\
										<span class='btn'><%= certain %></span>\
									</div>"),

		//单张图片上传模版
		downloadMethodTwoTemplate = _.template(" <div class='title'><%= lang.isDownloading %><span class='nowCount' id='nowCount'>1</span>/<span class='totalCount' id='totalcount'><%= count%></span></div>\
									<div class='content'>\
									<div id='progress' class='progress'><div class='nowProgress' id='nowProgress'></div></div></div><br/><br/>\
									<div class='progressNotice'><%= lang.downloadPhotoPath%></div>\
									<div class='btns certain' btn-name='alert-dialog-certain'>\
										<span class='btn'><%= certain %></span>\
									</div>"),
		screensaverContent = _.template("<p><%= lang.photoIsDownloading%></p>")();
	$screensaver = $("<div id='screensaver' class='screensaver'>" + screensaverContent + "</div>");

	var DownloadPhoto = function() {
		this.startTime = 0;
		this.endTime = 0;
		this.prevCount = 0;
		this.isFirstOne = true;
		this.total = 0;
		this.lightCount = 0;
		this.allowControlLight = false;
		this.brightNess = 0.6;
		this.urlArr = [];
		this.callback = null;
		this.isDownloading = false;
		this.restTime = null;
	};

	DownloadPhoto.prototype.light = function(event, light) {
		if (!light) {
			$('#screensaver').hide();
		}
		var _this = c360.downloadPhoto,
			light = light || _this.brightNess;
		window.cNative.setBrightness({
			brightness: light
		});
		_this.lightCount = 0;
	};

	DownloadPhoto.prototype.showDownLoadDialog = function(url, callback){

		var _this = c360.downloadPhoto,
			len = url.length;
			if(callback){
				_this.callback = callback;
			}
		
		if(cNative.nativeAPIVersion<=FILTER_VERSION || utils.isIOS()){
			alertDialog.render({
				title:lang.downLoadTipTitle,
				content:lang.downLoadTipContent,
				certain:lang.iKnow
			},function(){
				this.close();
			});
			return;
		}
		if(navigator.network && navigator.network.connection.type == 'none'){
			window.cNative.showBubbleMessage({msg:lang.timeout,duration:2},function(data){});
		}else{
			if(len == 1){ //只有一张图片
				winAlert.template = downloadMethodTwoTemplate;
			}else{ //多张图片
				winAlert.template = downloadMethodOneTemplate;
			}

			for(var i=0; i<url.length; i++){
				_this.urlArr[i] = 'http://dn-c360.qbox.me/'+url[i]+'?imageView/2/w/960';
			}

			winAlert.render({
				count: len,
				certain: lang.cancel
				}, function() {
					_this.ensureCancel();
					c360.statis.storageKey("singlePhoto_downCancel");
				}, null, {
					domShowCallback: _this.doDownload,
					rejectBackgroundClose: true
				}
			);
		}
	};

	DownloadPhoto.prototype.doDownload = function() {
		var _this = c360.downloadPhoto;
		_this.allowControlLight = true;
		_this.isDownloading = true;
		window.cNative.getBrightness(function(data) {
			if (data.error == 200) {
				_this.brightNess = data.brightness || 0.6;
			}
		});
		_this.startTime = new Date().getTime();

		_this.countDown = window.setInterval(function() {
			if (_this.allowControlLight) {
				_this.lightCount += 1;
				if (_this.lightCount == 60) {
					if ($('#screensaver').length >= 1) {
						$('#screensaver').show();
					} else {
						$('body').append($screensaver);
						document.getElementById('screensaver').addEventListener('touchstart', _this.light);
					}
					_this.light(null, 0.5);
				}
			}

			if (_this.restTime && _this.restTime) {
				_this.restTime--;
				_this.restTime = Math.max(0, _this.restTime);
				var second = parseInt(_this.restTime % 60),
					time = parseInt(_this.restTime / 60) + ':' + (second < 10 ? '0' + second : second);
				$('#restTime span').text(time);
			}
		}, 1000);

		window.cNative.startDownload({
			urls: _this.urlArr,
			callback: 'c360.downloadPhoto.timerFunction'
		});

		//防止锁屏
		window.cNative.disabledScreenLock({
			disable: true
		});
	};

	/*DownloadPhoto.prototype.calcRestTime = function(restCount) {
		var _this = c360.downloadPhoto;
		if (_this.prevCount > restCount) {
			_this.endTime = new Date().getTime();
			_this.prevCount = restCount;
			if (_this.isFirstOne == true) {
				_this.isFirstOne = false;
				_this.baseTime = _this.endTime - _this.startTime;
				var distance = _this.endTime - _this.startTime;
				_this.needTime = (distance * restCount) / 1000;
				_this.startTime = new Date().getTime();
			} else {
				var distance = _this.endTime - _this.startTime;
				distance = (distance + _this.baseTime) / 2;
				_this.baseTime = distance;
				_this.needTime = _this.needTime = (distance * restCount) / 1000;
				_this.startTime = new Date().getTime();
			}
		}
	};*/

	DownloadPhoto.prototype.clearDom = function() {
		var _this = c360.downloadPhoto;
		_this.startTime = 0;
		_this.endTime = 0;
		_this.prevCount = 0;
		_this.isFirstOne = true;
		_this.allowControlLight = false;
		_this.callback = null;
		_this.isDownloading = false;
		$('#screensaver').remove();
		$('#nowProgress').width('0%');
		$('#restTime span').text(lang.isCalcing);
		if (c360.dialog && c360.dialog.config.id == 'progressDialog') {
			c360.dialog.close(true);
		}
		//c360.dialog.close(true);
	};

	DownloadPhoto.prototype.clearMethod = function() {
		var _this = c360.downloadPhoto;
		_this.lightCount = 0;
		this.urlArr.length = 0;
		window.clearInterval(_this.countDown);
		/*window.cNative.removeKeepedCallBack({
			name: 'startUploading'
		});*/
		window.cNative.disabledScreenLock({
			disable: false
		});
		try {
			// 必须房子c360.dialog.close()之前
			document.getElementById('screensaver').removeEventListener('touchstart', _this.light);
		} catch (err) {
			console.log("DownloadPhoto.clear: ERROR: " + err);
		}
	};



	DownloadPhoto.prototype.timerFunction = function(res) {
		var _this = c360.downloadPhoto;
		if (!res) {
			console.log('timerFunction: res is null, ingored!');
			return;
		}
		try {
			if (res.error == 200) {
				if (res.restCount == 0 && res.complete == true) { //上传完成 c12-16
					console.log('timerFunction 下载完成');
					setTimeout(_this.handlerUploadComplete, 50, res);
				} else if (!myTimer) { //更新上传状态
					console.log('timerFunction 更新下载状态');
					myTimer = setTimeout(_this.updateUploadProgress, 180, res);
				} else {
					console.log('timerFunction ingore');
				}
			} else if (res.error == 420) {
				_this.clearDom();
				_this.clearMethod();
				if(_this.callback){
					_this.callback();
				}

			} else { //处理上传出错的情况			
				console.log('timerFunction 处理下载出错的情况');
				//DownloadPhoto.handlerUploadError(res);
				setTimeout(_this.handlerUploadError, 50, res);
			}
		} catch (err) {
			console.log("timerFunction: ERROR: " + err);
		}

	}

	//处理上传完成的情况
	DownloadPhoto.prototype.handlerUploadComplete = function(res) {
		var _this = c360.downloadPhoto;
		_this.clearDom();
		_this.clearMethod();
		window.cNative.showBubbleMessage({
			msg:lang.downloadSuccess,
			duration:2
		});
		if(_this.callback){
			_this.callback();
		}
	};

	//处理上传出错的情况
	DownloadPhoto.prototype.handlerUploadError = function(res) {
		var _this = c360.downloadPhoto,
			status = res.error;

		window.cNative.showBubbleMessage({
			msg:res.msg,
			duration:2
		});
		_this.clearDom();
		_this.clearMethod();
		if(_this.callback){
			_this.callback();
		}
	};

	//更新上传状态
	DownloadPhoto.prototype.updateUploadProgress = function(res) {
		myTimer = 0;
		var _this = c360.downloadPhoto;

		if (_this.prevCount == 0) {

			_this.prevCount = res.totalCount;

		}else if(_this.prevCount > res.restCount){

			_this.restTime = res.restTime;
			_this.prevCount = res.restCount;

		}
		//_this.calcRestTime(res.restCount);
		$('#nowProgress').width(res.progress + '%');
		$('#nowCount').text(res.totalCount + 1 - res.restCount);
	};


	//用户确定点击取消
	DownloadPhoto.prototype.ensureCancel = function() {
		var _this = c360.downloadPhoto;
		window.cNative.stopDownload(function(data) {
			_this.clearDom();
			_this.clearMethod();
		});
		if(_this.callback){
			_this.callback();
		}
	};

	c360.downloadPhoto = new DownloadPhoto();
	return c360.downloadPhoto;

});