/**************************************************************************/
/*                                                                        */
/* Copyright (c)2010-2012  Pinguo Company             　　　　　　　      */
/*                 品果科技                            版权所有 2010-2012                    */
/*                                                                        */
/* PROPRIETARY RIGHTS of Pinguo Company are involved in the  　　　　　　 */
/* subject matter of this material.  All manufacturing, reproduction, use,*/
/* and sales rights pertaining to this subject matter are governed by the */
/* license agreement.  The recipient of this software implicitly accepts  */
/* the terms of the license.                                              */
/* 本软件文档资料是品果公司的资产,任何人士阅读和使用本资料必须获得                               */
/* 相应的书面授权,承担保密责任和接受相应的法律约束.                          */
/*                                                                        */
/**************************************************************************/
(function(window) {
	//有些方法不需要localkey也能够访问, 这些方法名需要保存在unlogined里面
	var unlogined = 'mobile/user/login,mobile/site/h5upgrade,mobile/user/logout,sns/login/createsnsuser,sns/login/bindaccount';

	$.ns("c360.server");

	/*
	 * url:发送请求地址。
	 * serverData:待发送 Key/value 参数。
	 * callback:载入成功时回调函数。
	 * 使用方法：
	 * getJSON(url,[serverData],callback);
	 */
	var getJSON = function() {
		var p = getJSONParseParams(arguments);
		p.retry = 0;
		//有些方法不需要localkey也能够访问
		var login = checkUserLogin(p.method, p.serverData);
		if (login == 0) {
			forceQuit();
			return;
		} else if (login == 1) {

		} else {
			p.serverData.localkey = login;
		}


		var serverIp = $.serverIp || 'https://cloud.camera360.com';
		
		p.server = serverIp + (serverIp[serverIp.legnth - 1] == '/' ? '' : '/') + p.method;


		utils.log("doAjaxRequest requesting " + p.server);
		utils.log("doAjaxRequest requesting " + p.method + " ", p.serverData);
		p.t = new Date().getTime();
		console.log("c360.database.initDB"+(c360.database?true:false));
		
		var ajaxFun = (utils.isMobile&&cNative.nativeAPIVersion>8)?doAjaxRequestByNative:doAjaxRequest;
		
		ajaxFun(p);
		

	}

	var doAjaxRequestByNative = function(p) {
		if(navigator.onLine){
			return cNative.doHttpPost(p.server,p.serverData,function(resp) {
				 	utils.log('http code\t ',resp.code);
		            utils.log('http message\t ',resp.message);
		            utils.log('http body\t ',resp.body);
		            if(resp.code==200){
		                try{
		                    var data =JSON.parse(resp.body);
		                    // utils.log('http body\t ',data);
		                    if(data.status == 200){
		                    	if (p.callback) {
									p.callback(data);
								}
		                    }else if (data.status == 420) {
								forceQuit();
								return;
							}else if(data.status == 500){
								p.callback({
									status: data.status,
									message: lang.timeout
								});
							}else{
								p.callback(data);
							}
							
		                }catch(e){
		                    utils.log("error"+e);
		                }
		            }else{
		                utils.log(resp.code+ " of "+p.server);
		                p.callback({
							status: 500,
							message: lang.timeout
						});
		            }
				});
		}else{
			console.log("resp " + p.method + " statusCode 500");
			p.callback({
				status: 500,
				message: lang.timeout
			});
		}
	}

	var doAjaxRequest = function(p) {
		if(navigator.onLine){
			return $.ajax({
				timeout: 30000,
				type: "get",
				url: p.server,
				data: p.serverData,
				dataType: "jsonp",
				jsonp: 'jsonpCallback',
				success: function(resp) {
					utils.log("resp " + p.method + " COST=" + (new Date().getTime() - p.t));
					utils.log("resp " + p.method + " ", resp);
					if (resp.status == 420) {
						forceQuit();
						return;
					}
					if (p.callback) {
						p.callback(resp);
					}



				},
				error: function(request, textStatus, errorThrown) {
					console.log("resp " + p.method + " error errorThrown=" + errorThrown);
					console.log("resp " + p.method + " error textStatus=" + textStatus);
					if (errorThrown == 'abort' || errorThrown == '') return;
					if (p.retry <= 2) {
						console.log("retrying request " + p.method + " times=" + p.retry);
						p.retry++;
						//window.cNative.showBubbleMessage({msg:''+lang.errorRetry,duration:2});
						doAjaxRequest(p);
					} else {
						// window.cNative.showBubbleMessage({msg:''+lang.loadFail,duration:2});
						p.callback({
							status: 500,
							message: lang.timeout
						});
					}

				},
				statusCode: {
					404: function() {
						console.log("resp " + p.method + " statusCode 400");
						p.callback({
							status: 404,
							message: lang.error404
						});
					},
					500: function() {
						console.log("resp " + p.method + " statusCode 500");
						p.callback({
							status: 500,
							message: lang.error500
						});
					},
					435: function() {
						/*c360.server.logout(function(res){
							if(res.status == 200){
								window.cNative.gotoNativeView({
									viewId:'cloudHomeView',
									from:''
								});
							}
						});*/
					}
				}
			});
		}else{
			console.log("resp " + p.method + " statusCode 500");
			p.callback({
				status: 500,
				message: lang.error500
			});
		}
	}

	//强制退出
	var forceQuit = function() {
		console.log('forceQuit');
		if(window.localStorage){
			window.localStorage.setItem('database.isCreated', 'false');
		}
		window.cNative.showBubbleMessage('Sorry please login');
		window.cNative.displayLoadingIcon({
			show: false,
			msg: "",
			modal: true
		});

		window.cNative.setLoginUser({
			email: '',
			uid: '',
			pwd: '',
			expire: 0
		}, function(data) {
			window.cNative.gotoNativeView({
				viewId: 'cloudHomeView'
			});
		});

	}

	//检查登陆
	var checkUserLogin = function(method, serverData) {
		if (utils.isMobile && unlogined.indexOf(method.toLowerCase()) == -1 && !serverData.localkey) {
			var user = window.cNative.getUser();
			if (!user || !user.data || !user.data.localkey) {
				return -1;
			} else {
				return user.pwd;
			}
		} else {
			return 1;
		}
	}

	//分析getJSON函数的参数
	var getJSONParseParams = function(p) {
		var method = null,
			callback = null,
			serverData = {},
			userNativeHttp = false;
		switch (p.length) {
			case 0:
			case 1:
				throw Error('Missing Arguments');
				break;
			case 2:
				method = p[0];
				callback = p[1];
				if (!callback instanceof Function) {
					throw Error('Invild Arguments');
				}
				break;
			case 3:
				method = p[0];
				serverData = p[1];
				callback = p[2];
				if (!callback instanceof Function) {
					throw Error('Invild Arguments');
				}
				break;
			case 4:
				method = p[0];
				serverData = p[1];
				callback = p[2];
				userNativeHttp =p[3];
				if (!callback instanceof Function) {
					throw Error('Invild Arguments');
				}
				break;
		}

		var params = window.cNative.getInfo();
		for (var i in serverData) {
			params[i] = serverData[i];
		};
		serverData = params;
		serverData.app_key = window.cNative.app_key?window.cNative.app_key:'';

		return {
			method: method,
			callback: callback,
			serverData: serverData,
			userNativeHttp:userNativeHttp
		};
	}

	var Server = {},

		a = Server;
	a.ajaxing = false; //是否在进行ajax请求,监听特殊的请求(需要显示全屏loading的请求)
	a.showLoading = function() {
		this.ajaxing = true;
	}
	a.hideLoading = function() {
		this.ajaxing = false;
	}
	/******************************************************
					初始化每个页面的请求对象
*******************************************************/
	a.login = function(json, callback) {
		return getJSON('mobile/user/login', json, callback)
	}
	a.logout = function(callback) {
		return getJSON('mobile/user/logout', callback)
	}
	a.userinfor = function(json, callback) {
		return getJSON('mobile/user/info', json, callback)
	}
	/*照片瀑布流列表接口 start*/
	//照片首页
	a.homeInfo = function(json,callback) {
		getJSON('mobile/page/home', json,callback);
	};
	/*照片瀑布流列表接口 start*/
	//照片首页
	a.index = function(json, callback) {
		getJSON('mobile/page/albums', json, callback);
	};
	//相册内页
	a.album = function(json, callback) {
		getJSON('mobile/page/pictures', json, callback);
	};
	//回收站
	a.recycle = function(json, callback) {
		getJSON('mobile/page/trash', json, callback);
	}
	//发送统计数据
	a.statis = function(json, callback) {
		getJSON('mobile/message/track', json, callback,true);
	}
	/*照片瀑布流列表接口 end*/

	/*照片相关操接口 start*/
	//(相册内页)照片分离
	a.splitPhotos = function(json, callback) {
		getJSON('mobile/album/splitPhotos', json, callback,true);
	}
	//批量删除照片
	a.deletes = function(pids, callback) {
		getJSON('mobile/picture/delete', {
			pids: pids
		}, callback,true);
	}
	//(回收站)照片还原
	a.restore = function(pids, callback) {
		getJSON('mobile/picture/restore', {
			pids: pids
		}, callback,true);
	}

	a.destroy = function(json, callback) {
		getJSON('mobile/picture/destroy', json, callback,true);
	}

	a.setName = function(json, callback) {
		getJSON('mobile/album/setName', json, callback);
	}

	a.shareSNSList = function(callback) {
		getJSON('mobile/share/showThird', callback);
	};

	a.sharePhotos = function(json, callback) {
		getJSON('mobile/share/sharePhotos', json, callback,true);
	};

	a.shareEmails = function(json, callback) {
		getJSON('mobile/share/shareEmails', json, callback,true);
	};

	a.shareAt = function(json, callback) {
		getJSON('mobile/share/atusers', json, callback);
	};

	a.sendResetEmail = function(json, callback) {
		getJSON('mobile/user/sendResetEmail', json, callback);
	};

	a.photoInfo = function(json, callback) {
		getJSON('mobile/page/pictureInfo', json, callback);
	};

	a.photoDesc = function(json, callback) {
		getJSON('mobile/picture/setDesc', json, callback);
	};

	a.updateInfo = function(json, callback) {
		getJSON('mobile/user/updateInfo', json, callback);
	};
	/*照片相关操接口 end*/
	/*第三方登录,获取第三方登录地址*/
	a.getsns = function(json, callback) {
		getJSON('sns/login/index', json, callback);
	}
	/*sns绑定邮箱*/
	a.snsbindAccount = function(json, callback) {
		getJSON('sns/login/bindAccount', json, callback);
	}
	a.createSnsUser = function(json, callback) {
		getJSON('sns/login/createSnsUser', json, callback);
	}
	a.bindEmal = function(json, callback) {
		getJSON('mobile/user/bindEmail', json, callback);
	}
	a.verifyEmail = function(callback) {
		getJSON('mobile/user/sendverifyEmail', callback);
	}
	a.getPhotoWallLinks = function(json, callback) {
		getJSON('mobile/share/getPhotoWallLinks', json, callback);
	}
	a.updateUserInfo = function(json, callback) {
		getJSON('mobile/user/updateInfo', json, callback);
	}

	/*
	 * 获取指定主题id的相关数据 by goingta
	 * aid: 主题id，字符串类型
	 * isFirst：指定查询的主题是否是列表中第一个,此值用于指定返回封面照片的数目
	 */
	a.getAlbumInfoByAid = function(json, callback) {
		getJSON('mobile/page/themeInfo', json, callback);
	}

	a.changeEmail = function(json, callback){
		getJSON('mobile/user/changeEmail', json, callback);
	}

	a.yahooNoPrompt = function(callback){
		getJSON('mobile/user/yahooNoPrompt', callback);
	}




	
	/*========================================================================================================================================*/
	/*========================================================================================================================================*/
	/*========================================================================================================================================*/
	/*========================================================================================================================================*/
	/*========================================================================================================================================*/
	/*========================================================================================================================================*/
	/*========================================================================================================================================*/
	/*========================================================================================================================================*/
		

/*
	var serverIp = 'http://cloud.camera360.com/';

	var tempCallback = function(callback){
		return function(resp){
			resp.code == 200 && callback($.parseJSON(resp.body));
		};
	};

	a.login = function(json, callback) {
		window.cNative.doHttpGet(serverIp+'mobile/user/login', json, tempCallback(callback));
	}
	a.logout = function(callback) {
		window.cNative.doHttpGet(serverIp+'mobile/user/logout', null, tempCallback(callback));
	}
	a.userinfor = function(json, callback) {
		window.cNative.doHttpGet(serverIp+'mobile/user/info', json, tempCallback(callback));
	}
	a.index = function(json, callback) {
		window.cNative.doHttpGet(serverIp+'mobile/page/albums', json, tempCallback(callback));
	};
	a.album = function(json, callback) {
		window.cNative.doHttpGet(serverIp+'mobile/page/pictures', json, tempCallback(callback));
	};
	a.recycle = function(json, callback) {;
		window.cNative.doHttpGet(serverIp+'mobile/page/trash', json, tempCallback(callback));
	}
	a.splitPhotos = function(json, callback) {
		window.cNative.doHttpGet(serverIp+'mobile/album/splitPhotos', json, tempCallback(callback));
	}

	a.deletes = function(pids, callback) {
		window.cNative.doHttpGet(serverIp+'mobile/picture/delete', {pids:pids}, tempCallback(callback));
	}

	a.restore = function(pids, callback) {
		window.cNative.doHttpGet(serverIp+'mobile/picture/restore', {pids:pids}, tempCallback(callback));
	}

	a.destroy = function(json, callback) {
		window.cNative.doHttpGet(serverIp+'mobile/picture/destroy', json, tempCallback(callback));
	}

	a.setName = function(json, callback) {
		window.cNative.doHttpGet(serverIp+'mobile/album/setName', json, tempCallback(callback));
	}

	a.shareSNSList = function(callback) {
		window.cNative.doHttpGet(serverIp+'mobile/share/showThird', null, tempCallback(callback));
	};

	a.sharePhotos = function(json, callback) {
		window.cNative.doHttpGet(serverIp+'mobile/share/sharePhotos', json, tempCallback(callback));
	};

	a.shareEmails = function(json, callback) {
		window.cNative.doHttpGet(serverIp+'mobile/share/shareEmails', json, tempCallback(callback));
	};

	a.shareAt = function(json, callback) {
		window.cNative.doHttpGet(serverIp+'mobile/share/atusers', json, tempCallback(callback));
	};

	a.sendResetEmail = function(json, callback) {
		window.cNative.doHttpGet(serverIp+'mobile/user/sendResetEmail', json, tempCallback(callback));
	};

	a.photoInfo = function(json, callback) {
		window.cNative.doHttpGet(serverIp+'mobile/page/pictureInfo', json, tempCallback(callback));
	};

	a.photoDesc = function(json, callback) {
		window.cNative.doHttpGet(serverIp+'mobile/picture/setDesc', json, tempCallback(callback));
	};

	a.updateInfo = function(json, callback) {
		window.cNative.doHttpGet(serverIp+'mobile/user/updateInfo', json, tempCallback(callback));
	};
	a.getsns = function(json, callback) {
		window.cNative.doHttpGet(serverIp+'sns/login/index', json, tempCallback(callback));
	}
	a.snsbindAccount = function(json, callback) {
		window.cNative.doHttpGet(serverIp+'sns/login/bindAccount', json, tempCallback(callback));
	}
	a.createSnsUser = function(json, callback) {
		window.cNative.doHttpGet(serverIp+'sns/login/createSnsUser', json, tempCallback(callback));
	}
	a.bindEmal = function(json, callback) {
		window.cNative.doHttpGet(serverIp+'mobile/user/bindEmail', json, tempCallback(callback));
	}
	a.verifyEmail = function(callback) {
		window.cNative.doHttpGet(serverIp+'mobile/user/sendverifyEmail', null, tempCallback(callback));
	}
	a.getPhotoWallLinks = function(json, callback) {
		window.cNative.doHttpGet(serverIp+'mobile/share/getPhotoWallLinks', json, tempCallback(callback));
	}
	a.updateUserInfo = function(json, callback) {
		window.cNative.doHttpGet(serverIp+'mobile/user/updateInfo', json, tempCallback(callback));
	}
	a.getAlbumInfoByAid = function(json, callback) {
		window.cNative.doHttpGet(serverIp+'mobile/page/themeInfo', json, tempCallback(callback));
	}*/

	c360.server = Server;
})(window);