/*
* 该文件存放全局的公用统计数据类。
 */

/*
* 定义命名空间的函数
* @example $.ns("c360.utils.statis");
 */
/**************************************************************************/
/*                                                                        */
/* Copyright (c)2010-2012  Pinguo Company             　　　　　　　      */
/*                 品果科技                            版权所有 2010-2012 */
/*                                                                        */
/* PROPRIETARY RIGHTS of Pinguo Company are involved in the  　　　　　　 */
/* subject matter of this material.  All manufacturing, reproduction, use,*/
/* and sales rights pertaining to this subject matter are governed by the */
/* license agreement.  The recipient of this software implicitly accepts  */
/* the terms of the license.                                              */
/* 本软件文档资料是品果公司的资产,任何人士阅读和使用本资料必须获得        */
/* 相应的书面授权,承担保密责任和接受相应的法律约束.                       */
/*                                                                        */
/**************************************************************************/

(function($,window){
    
    /*
    * 注册全局统计监控,所有需要统计的数据 by goingta
     */
    $.ns("c360.statis");

    $(function() {

        seajs.use('common/storage.js',function(storage){
            c360.statis.storageKey = storageKey;
            var pageLength = storage.get("statisPageLengthForSend")||6,//因为页面统计数据格式是数组,所以这里的值是数组的长度,参加页面统计格式
                btnLength = storage.get("statisBtnLengthForSend")||5,
                pageInTime = (new Date).getTime();
            $("body").on("tap","[data-btn]",statisBtn);
            function statisBtn(event){
                var btnKey = $(event.currentTarget).attr("data-btn");
                storageKey(btnKey);
            };

            //根据key缓存数据
            //目前用于统计按钮, 统计按钮需要给后端传的参数格式为 {key1:count1,key2:count2,key3:count3....}
            function storageKey(key){
                var btnStatisInfo = storage.get("btnStatisInfo")||{};
                //如果此key 不存在....计数器+1
                if(!btnStatisInfo[key]){
                    btnStatisInfo.length = btnStatisInfo.length||0;
                    ++btnStatisInfo.length;
                }
                //值+1
                btnStatisInfo[key] = (btnStatisInfo[key]||0)+1;

                //存有10条记录就往服务器发送
                if(btnStatisInfo.length>=btnLength){
                    //后端不需要Length属性
                   
                    delete btnStatisInfo.length;

                    c360.server.statis({data:JSON.stringify(btnStatisInfo)},function(res){
                        if(res.status == 200){
                            storage.clear("btnStatisInfo");
                            storage.set("statisBtnLengthForSend", res.data.nextReturnNum);
                        }
                    });
                }else{
                    storage.set("btnStatisInfo",btnStatisInfo);
                }
            }   

            c360.events.on("pageClose",pageClose);
            c360.events.on("sendStatis",function(){
                var arrInfo = storage.get("statisPageInfo")||[];
                if(arrInfo.length>=pageLength){
                  
                    c360.server.statis({data:arrInfo.join(","),forPage:1},function(res){
                        if(res.status == 200){
                            storage.clear("statisPageInfo");
                            storage.set("statisPageLengthForSend", res.data.nextReturnNum);
                        }
                    });
                }
            });  

            function pageClose(){
                var page = null;
                try{
                    page = location.href.split("www/");
                    page = page[1].split(".");
                    page = page[0];
                    storagePageInfo(page,(new Date).getTime()-pageInTime);
                }
                catch(e){

                }
            }
            

            //缓存页面停留时间数据 发给后端的格式为  "page1,time1,page2,time2,page3,time3,page1,time1"
            function storagePageInfo(page,stayTime){
                var arrInfo = storage.get("statisPageInfo")||[];
                switch(page)
                {
                    case "userSetting":
                    case "bindAccount":
                    case "cloudSetting":
                        page = "html5";
                        break;
                }
                arrInfo.push(page);
                arrInfo.push(stayTime);
                if(page == "index" || page == "loginWeb")
                {
                    arrInfo.push("html5");
                    arrInfo.push(stayTime);
                }
                if(arrInfo.length>=pageLength){
                  
                    c360.server.statis({data:arrInfo.join(","),forPage:1},function(res){
                        if(res.status == 200){
                            storage.clear("statisPageInfo");
                            storage.set("statisPageLengthForSend", res.data);
                        }
                    });
                }else{
                    storage.set("statisPageInfo",arrInfo);
                }
            }   
        });
    })
     
})($,window)