define(function(require, exports, module) {
	$.ns("c360.storage");
	var a = c360.storage;
	a.set = function(key,value){
		if(window.localStorage){
			if(typeof value !== "undefined"){
				//防止localStorage,报错或超出大小抛出异常
				try{
					localStorage.setItem(key,JSON.stringify(value));
				}
				catch(e){
					console.log("localStorage set Error:"+JSON.stringify(e));
				}
			}
		}
	};
	a.get = function(key){
		if(!key) return;
		try{
			var value = localStorage.getItem(key);
			if(value !=null && (value.indexOf("{") || value.indexOf("["))){
				return JSON.parse(value);
			}
			return value;
		}
		catch(e){
			return null;
		}
	};

	a.clear = function(key){
		try{
			key?localStorage.removeItem(key):localStorage.clear();
		}
		catch(e){
			console.log("localStorage removeItem Error:"+JSON.stringify(e));
		}
	}

	a.setSession = function(key,value){
		if(window.sessionStorage){
				if(value){
				if(typeof value == ""){
					sessionStorage.setItem(key,value);
				}else{
					sessionStorage.setItem(key,JSON.stringify(value));
				}
			}
		}
	};

	a.getSession = function(key){
		if(!key) return;
		try{
			var value = sessionStorage.getItem(key);
			if(value){
				if(value.indexOf("{") || value.indexOf("[")){
					return JSON.parse(value);
				}
				return value;
			}else{
				return null;
			}
		}
		catch(e){
			return null;
		}
	};

	a.setStatis = function(key,num){
		var statis = this.get("statis") || {},
			val = null;
		if(key in statis){
			statis[key] = num || ++statis[key];
		}else{
			statis[key] = num || 1;
		}
		this.set("statis",statis);
	};

	a.getStatis = function(key){
		if(key){
			return this.get("statis")[key];
		}
		return this.get("statis");
	};
	a.clearStatis = function(key){
		var statis = this.get("statis") || {};
		if(key){
			delete statis[key];
			this.set("statis",statis);
		}else{
			this.clear("statis");
		}
	};

	a.setCookie = function(name, value, options){
		console.log(name, value, options);
		options = $.extend({}, options);
	    if (value === null || value === undefined) {
			value = '';
			options.expires = -1;
	    }
	    var expires = '';
	    if (options.expires && (typeof options.expires == 'number' || options.expires.toUTCString)) {
			var date;
			if (typeof options.expires == 'number') {
			    date = new Date();
			    date.setTime(date.getTime() + options.expires);
			} else {
			    date = options.expires;
			}
			expires = '; expires=' + date.toUTCString();
	    }
	    var path = options.path ? '; path=' + (options.path) : '',
	    	domain = options.domain ? '; domain=' + (options.domain) : '',
	    	secure = options.secure ? '; secure' : '';

	    document.cookie = [name, '=', encodeURIComponent(value), expires, path, domain, secure].join('');
	};

	a.getCookie = function(name){
		var cookieValue = null;
	    if (document.cookie && document.cookie != '') {
			var cookies = document.cookie.split(';');
			for (var i = 0; i < cookies.length; i++) {
				var cookie = $.trim(cookies[i]);
				if (cookie.substring(0, name.length + 1) == (name + '=')) {
					cookieValue = decodeURIComponent(cookie.substring(name.length + 1));
					break;
				}
			}
	    }
	    return cookieValue;
	};
	return a;
});