define(function(require, exports, module) {

	require('css/progress.css');

	var winAlert = require('ui/dialog/progress/progress.js'),
		winConfirm = require('ui/dialog/confirm/confirm.js'),
		myTimer = 0,
		screensaverContent = _.template("<p><%= lang.photoIsUpdating%></p>")();
	$screensaver = $("<div id='screensaver' class='screensaver'>" + screensaverContent + "</div>");


	var UploadPhoto = function() {
		this.callback = null;
		this.startTime = 0;
		this.endTime = 0;
		this.prevCount = 0;
		this.showTime = '';
		this.isFirstOne = true;
		this.total = 0;
		this.lightCount = 0;
		this.allowControlLight = false;
		this.brightNess = 0.6;
		this.picIsMaking = 1;
	};

	UploadPhoto.prototype.appendDom = function(count) {
		var _this = uploadPhoto;
		$("#uploadContainer").append(" <div id='progressContainer' class='progress-container'><div class='progress-left'><div class='title'><span id='progressTitle'></span>&nbsp;&nbsp;<span class='nowCount' id='nowCount'>1</span>/<span class='totalCount' id='totalcount'>" + count + "</span><span class='restTime' id='restTime'><span>" + lang.isCalcing + "</span></span><div id='progress' class='progress'><div class='nowProgress' id='nowProgress'></div></div></div></div>\
									<div class='progress-right'>\
										<span class='btn' id='uploadCancel'>" + lang.cancel + "</span><div style='clear:both;'></div></div>\
									</div></div>");
		$('#upLoadTips').attr('visibility','hidden');
		$('#uploadCancel').on('tap', _this.handlerUploadCancel);
	};

	//UploadPhoto.prototype.appendDom(10);

	UploadPhoto.prototype.begin = function(callback, keepMode) {
		var _this = this;
		this.callback = function() {
			callback();
		};
		//安卓环境下直接跳转到上传设置页面
		if (navigator.userAgent.toLowerCase().match(/android/)) {
			utils.gotoPage('uploadSetting.html', true, {
				showTitleBar: true
			});
		} else { //IOS上传方式
			window.cNative.getUploadInfo(function(res) {
				if (res.error == 200) {
					if (res.totalCount != 0) {
						_this.total = res.totalCount;
						_this.method = res.method;
						_this.appendDom(res.totalCount);
						//return;
						if (res.method == 0) {
							_this.doUpload(true, keepMode ? keepMode : false);
						} else {
							_this.doUpload(false, keepMode ? keepMode : false);
						}

					} else {
						window.cNative.showBubbleMessage({
							msg: lang.noPhotoNeedUpload,
							duration: 2
						});
					}
				}else{
					c360.notification.bubble(lang.uploadPictureFail);
					_this.callback();
				}
			});
		}
	};

	UploadPhoto.prototype.light = function(event, light) {
		if (!light) {
			$('#screensaver').hide();
		}
		var _this = uploadPhoto,
			light = light || _this.brightNess;
		window.cNative.setBrightness({
			brightness: light
		});
		_this.lightCount = 0;
	};


	UploadPhoto.prototype.screenTimerFunction = function() {
		var _this = uploadPhoto;
		_this.screenTimer = window.setInterval(function() {
			if (_this.allowControlLight) {
				_this.lightCount += 1;
				if (_this.lightCount == 60) {
					if ($('#screensaver').length >= 1) {
						$('#screensaver').show();
					} else {
						$('body').append($screensaver);
						document.getElementById('screensaver').addEventListener('touchstart', _this.light);
						//$('#screensaver').bind('touchmove',function(e){utils.stopBubble(e)});
					}
					_this.light(null, 0.5);
				}
			}
		}, 1000);
	};

	UploadPhoto.prototype.restTimerFunction = function() {
		var _this = uploadPhoto;
		_this.restTimer = window.setInterval(function() {
			if (_this.restTime) {
				_this.restTime--;
				_this.restTime = Math.max(0, _this.restTime);
				var second = parseInt(_this.restTime % 60),
					time = parseInt(_this.restTime / 60) + ':' + (second < 10 ? '0' + second : second);
				$('#restTime span').text(time);
			}
		}, 1000);
	};

	UploadPhoto.prototype.doUpload = function(method, keepMode) {
		var _this = uploadPhoto;
		_this.allowControlLight = true;
		window.cNative.getBrightness(function(data) {
			if (data.error == 200) {
				_this.brightNess = data.brightness || 0.6;
			}
		});

		if (method == false) { //做图上传 需要屏保 做图完成之前不需要计时
			_this.screenTimerFunction();
		}

		if (method == true) { // 直接上传 不要屏保 直接计时
			_this.startTime = new Date().getTime();
			_this.restTimerFunction();
		}


		if (!keepMode) {
			$('body').prepend('<div class="shade"></div>');
			window.cNative.startUploading({
				keepCallback: true
			}, uploadPhoto.timerFunction);
		}else{
			$('#restTime').show(); 
			_this.restTimerFunction();
		}

		c360.events.on("uploadEvent", function(res) {
			uploadPhoto.timerFunction(res);
		});

		//防止锁屏
		window.cNative.disabledScreenLock({
			disable: true
		});
	};

	UploadPhoto.prototype.calcRestTime = function(restCount) {
		var _this = uploadPhoto;
		if (_this.prevCount > restCount) {
			_this.endTime = new Date().getTime();
			_this.prevCount = restCount;
			if (_this.isFirstOne == true) {
				_this.isFirstOne = false;
				_this.baseTime = _this.endTime - _this.startTime;
				var distance = _this.endTime - _this.startTime;
				_this.needTime = (distance * restCount) / 1000;
				_this.startTime = new Date().getTime();
			} else {
				var distance = _this.endTime - _this.startTime;
				distance = (distance + _this.baseTime) / 2;
				_this.baseTime = distance;
				_this.needTime = (distance * restCount) / 1000;
				_this.startTime = new Date().getTime();
			}
		}
	};

	UploadPhoto.prototype.clearDom = function() {
		var _this = uploadPhoto;
		_this.startTime = 0;
		_this.endTime = 0;
		_this.prevCount = 0;
		_this.showTime = '';
		_this.isFirstOne = true;
		_this.allowControlLight = false;
		$('#screensaver').remove();
		$('#nowProgress').width('0%');
		$('#restTime span').text(lang.isCalcing);
		$('.shade').remove();
	};

	UploadPhoto.prototype.clearMethod = function() {
		var _this = uploadPhoto;
		_this.lightCount = 0;
		window.clearInterval(_this.restTimer);
		window.clearInterval(_this.screenTimer);
		window.cNative.removeKeepedCallBack({
			name: 'startUploading'
		});
		window.cNative.disabledScreenLock({
			disable: false
		});
		try {
			// 必须房子c360.dialog.close()之前
			if(document.getElementById('screensaver')){
				document.getElementById('screensaver').removeEventListener('touchstart', _this.light);
			}
		} catch (err) {
			console.log("uploadPhoto.clear: ERROR: " + err);
		}
	};



	UploadPhoto.prototype.timerFunction = function(res) {
		var _this = uploadPhoto;
		if (!res) {
			console.log('timerFunction: res is null, ingored!');
			return;
		}
		if (res.isMaking == 1) {
			$('#progressTitle').html(lang.dataPreparing);
		} else {
			$('#progressTitle').html(lang.isUploading);
		}
		try {
			if (res.error == 200) {
				if(res.isUploading == 0 && res.isMaking == 0){
					_this.threegCancel(res.restCount);
					return;
				}
				_this.picIsMaking = res.isMaking;
				if (res.restCount == 0) { //上传完成 c12-16
					console.log('timerFunction 上传完成');
					setTimeout(uploadPhoto.handlerUploadComplete, 50, res);
				} else if (!myTimer) { //更新上传状态
					console.log('timerFunction 更新上传状态');
					myTimer = setTimeout(uploadPhoto.updateUploadProgress, 300, res);
				} else {
					console.log('timerFunction ingore');
				}
			} else if (res.error == 420) {
				uploadPhoto.clearDom();
				uploadPhoto.clearMethod();
				uploadPhoto.callback(res.restCount);

			} else { //处理上传出错的情况	
				console.log('timerFunction 处理上传出错的情况');
				//uploadPhoto.handlerUploadError(res);
				setTimeout(uploadPhoto.handlerUploadError, 50, res);
			}
		} catch (err) {
			console.log("timerFunction: ERROR: " + err);
		}

	}

	//处理上传完成的情况
	UploadPhoto.prototype.handlerUploadComplete = function(res) {
		var _this = uploadPhoto;
		if (res.isMaking == 1) {
			$('#restTime').show(); // 做图完成,开始预估上传完成时间
			_this.restTimerFunction();

			uploadPhoto.clearDom();
		} else {

			uploadPhoto.clearDom();
			uploadPhoto.clearMethod();
			uploadPhoto.callback(res.restCount);
		}
	};

	//处理上传出错的情况
	UploadPhoto.prototype.handlerUploadError = function(res) {
		c360.notification.bubble(lang.uploadPictureFail);
		var _this = uploadPhoto,
			status = res.error;

		uploadPhoto.clearDom();
		uploadPhoto.clearMethod();
		_this.callback(res.restCount);

	};

	//更新上传状态
	UploadPhoto.prototype.updateUploadProgress = function(res) {
		myTimer = 0;
		var _this = uploadPhoto;
		if (_this.prevCount == 0) {
			
			_this.prevCount = res.totalCount;
			if(res.restTime > 0){
				_this.restTime = res.restTime;
			}
			
		}else if(_this.prevCount > res.restCount){

			_this.restTime = res.restTime;
			_this.prevCount = res.restCount;

		}

		$('#nowProgress').width(res.progress + '%');
		$('#nowCount').text(_this.total + 1 - res.restCount);

	};


	//用户点击取消
	UploadPhoto.prototype.handlerUploadCancel = function() {
		var _this = uploadPhoto;

		winConfirm.render({
			title: lang.tips,
			content: lang.ensureCancel,
			certain: lang.ensureStop,
			cancel: lang.continueUpload
		}, function() {
			_this.ensureCancel();
		});


	};

	UploadPhoto.prototype.threegCancel = function(restCount){
		uploadPhoto.clearDom();
		uploadPhoto.clearMethod();
		uploadPhoto.callback(restCount);
	};

	//用户确定点击取消
	UploadPhoto.prototype.ensureCancel = function() {

		c360.notification && c360.notification.loading(true, 'loading', true);

		window.cNative.stopUploading(function(data) {
			c360.notification && c360.notification.loading(false, 'loading');
			uploadPhoto.clearDom();
			uploadPhoto.clearMethod();
			uploadPhoto.callback(data.restCount);
		});
	};

	window.uploadPhoto = new UploadPhoto();

	return uploadPhoto;

});