var utils = {
	startTime:new Date().getTime(),
	endTime:0,
	ver:178,
	supportDatebase: (function(){
		if(window.openDatabase){
			return true;
		}else{
			return false;
		}
	})(),
	stopBubble: function(e) {
		//阻止默认行为
		e.preventDefault();
		//因此它支持W3C的stopPropagation()方法 
		e.stopPropagation();
		return false;
	},
	getQuery: function(name) {
		var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)", "i");
		var r = window.location.search.substr(1).match(reg);
		if (r != null) return decodeURIComponent(r[2]);
		return null;
	},
	getRootUrl:function(){
		return location.href.split("?")[0];
	},
	getQueryArr:function(){
		return location.search.replace("?","").split("&");
	},
	deleteUrlQueryByName:function(name){
		var arr = this.getQueryArr();
		for(var i = 0,len = arr.length; i<len; i++){
			if(arr[i].match(name)){
				arr.splice(i,1);
				break;
			}
		}
		return arr.join("&");
	},
	HTMLEnCode: function(str) {
		if (str.length == 0 || str.length == undefined) return str;
		var s = "";
		s = str.replace(/&/g, "&amp;");
		s = s.replace(/</g, "&lt;");
		s = s.replace(/>/g, "&gt;");
		s = s.replace(/ /g, "&nbsp;");
		s = s.replace(/\'/g, "'");
		s = s.replace(/\"/g, "&quot;");
		s = s.replace(/\n/g, "<br>");
		return s;
	},
	HTMLDeCode: function(str) {
		if (str.length == 0 || str.length == undefined) return str;
		var s = "";
		s = str.replace(/&amp;/g, "&");
		s = s.replace(/&lt;/g, "<");
		s = s.replace(/&gt;/g, ">");
		s = s.replace(/&nbsp;/g, " ");
		s = s.replace(/'/g, "\'");
		s = s.replace(/&quot;/g, "\"");
		s = s.replace(/<br>/g, "\n");
		return s;
	},
	isMobile: (function() {
		var system = {
			win: false,
			mac: false,
			xll: false
		};
		var p = navigator.platform;
		system.win = p.indexOf("Win") == 0;
		system.mac = p.indexOf("Mac") == 0;
		system.x11 = (p == "X11") || (p.indexOf("Linux") == 0);
		if (system.win || system.mac || system.xll) {
			return false;
		} else {
			return true;
		}
	})(),
	click: function() {
		if (this.isMobile) {
			return 'touchend';
		} else {
			return 'click';
		}
	}(),
	/*
	 *中英文字符串截断, cutstr("我是中文",6)=我是中..
	 */
	cutstr: function(str, len, callback) {
		var str_length = 0,
			str_cut = new String(),
			str_len = str.length,
			i = 0,
			a = '';
		for (; i < str_len; i++) {
			a = str.charAt(i);
			str_length++;
			if (escape(a).length > 4) {
				//中文字符的长度经编码之后大于4
				str_length++;
			}
			str_cut = str_cut.concat(a);

			if (str_length >= len) {
				if ($.isFunction(callback)) {
					callback(str_cut);
				}
				return str_cut;
			}
		}
		//如果给定字符串小于指定长度，则返回源字符串；
		if (str_length < len) {
			return str;
		}
	},
	/*
	 *中英文字符串截断, cutstr("我是中文",6)=我是中..
	 */
	substr: function(str) {
		var str_length = 0,
			str_len = str.length,
			i = 0,
			a = '';
		for (; i < str_len; i++) {
			a = str.charAt(i);
			str_length++;
			if (escape(a).length > 4) {
				//中文字符的长度经编码之后大于4
				str_length++;
			}
		}
		return str_length;
	},
	log: function(prefix, resp) {
		if(undefined==window.cachedIsDebug){
			window.cachedIsDebug=window.localStorage && window.localStorage.getItem('isDebug')=='true';
		}
		
		if(!window.cachedIsDebug){
			return;
		}

		if (!resp) {
			console.log(prefix);
			return;
		}
		try {
			var toString = Object.prototype.toString;
			var ret = toString.call(resp);
			switch (ret) {
				case "[object Object]":
					for (var key in resp) {
						var type = toString.call(resp[key]);
						if (type == '[object Object]' || type == '[object Array]') {
							console.log(prefix + key + ' is ' + type);
							this.log(prefix + key + " ", resp[key]);
						} else {
							console.log(prefix + key + "=" + resp[key]);
						}
					}
					break;
				case "[object Array]":
					for (var i = resp.length - 1; i >= 0; i--) {
						this.log(prefix + i + " ", resp[i]);
					};
					break;
				case "[object String]":
					console.log(prefix + resp);
					break;
				case "[object Number]":
					console.log(prefix + resp);
					break;
				case "[object Boolean]":
					console.log(prefix + resp);
					break;
				case "[object RegExp]":
				case "[object Function]":
				case "[object Null]":
				case "[object Undefined]":
					console.log(prefix + ret);
					break;
				default:
					console.log(prefix + resp);
					break;
			}
		} catch (e) {
			alert(e);
		};


	},
	gotoPage:function(url,useOpenNewView, options){
		url = url+(url.lastIndexOf('?')==-1?"?":"&")+"ver="+this.ver;
		if(this.isMobile && useOpenNewView){
			if(!options) options={};
			// 这里可以用组合来扩展
			var opt = $.extend({
				url:url,
				showTitleBar:false,
				animation:1
			},options);

			//根据2013-07-17的需求, 所有页面都不再显示titlebar
			opt.showTitleBar=false;
			
			window.cNative.openNewView(opt,function(data){});
		}else{
			window.location.href = url;
		}
	},

	basicInfoReadyHandler:function(status, readyCallback){
		console.log("basicInfoReadyHandler: "+status);
		
		if(status!=7)return;

		console.log("javascript initializing cost: " + (this.endTime - this.startTime) + "ms");
		/*/
		setTimeout(readyCallback,20);
		//等所有的相关native接口执行完了，在执行动态加载多语言包
		/*/
		utils.setLanguage(readyCallback);
		//*/
	},

	devicereadyHandler:function(readyCallback){
		var _this = this;
		var status=0;
		var n = window.cNative;
		n.getNativeInfo(function(info) {
			n.app_key = info.app_key;
			n.deviceType = info.deviceType;
			n.deviceScreenWidth = info.deviceScreenWidth;
			n.deviceScreenHeight = info.deviceScreenHeight;
			n.deviceDPI = info.deviceDPI;
			n.deviceMac = info.deviceMac;
			n.softWareName = info.softWareName;
			n.softWareVersion = info.softWareVersion;
			n.systemVersion = info.systemVersion;
			n.staticSystem = info.staticSystem;
			n.nativeAPIVersion = info.nativeAPIVersion;
            n.lang = info.lang;
			status|=1;
			console.log("init native data ok");
			_this.basicInfoReadyHandler(status,readyCallback);
		}, function(e) {
			console.error("[ERROR] Error initializing Cordova: " + e);
		});

		var debug = true;
		if (debug) {
			window.cNative.getServerHost(function(resp) {
				if (resp.error == 200 && resp.host) {
					$.serverIp = resp.host;
					console.log("update serverIp to " + resp.host);
				}
				status|=2;
				_this.basicInfoReadyHandler(status,readyCallback);
			});
		} else {
			//强制设置服务器地址为https://cloud.camera360.com
			var host = 'https://cloud.camera360.com';
			$.serverIp = host;
			window.cNative.setServerHost({
				host: host
			}, function(resp) {
				status|=2;
				console.log('强制设置服务器地址为https://cloud.camera360.com');
				_this.basicInfoReadyHandler(status,readyCallback);
			});
		}

		cNative.getLoginUser(function(data) {
			_this.endTime = new Date().getTime();
			status|=4;
			console.log('user ready v05202243');
			_this.basicInfoReadyHandler(status,readyCallback);			
		});
	},

	ready: function(readyCallback) {
		var _this = this;
		$(function() {
			if (utils.isMobile) {
				document.addEventListener('deviceready', function(event) {
					console.log('device ready');
					_this.devicereadyHandler(readyCallback);	
					if(window.c360 && window.c360.events){
						window.c360.events.trigger("sendStatis");	
					}				
				}, false);
			} else {
				_this.endTime = new Date().getTime();
				console.log("javascript initializing cost: " + (_this.endTime - _this.startTime) + "ms");
				utils.setLanguage(readyCallback);
			}
		});
	},

	openWin: function(url, sign, successCallback, cancelCallback) {

		// 判断网络是否存在,不存在直接弹出气泡
		if(navigator.network && navigator.network.connection.type == 'none'){
			window.cNative.showBubbleMessage({msg:lang.timeout,duration:2},function(data){});
		}else{
			var _this = this;
			url = url + '&app_key=' + (window.cNative.app_key?window.cNative.app_key:'');
			var browser = window.open(url, '_blank', 'location=no');
				
			if(utils.isIOS()){
				browser.addEventListener('loadstart', iabLoadStart);
			}else{
				browser.addEventListener('loadstop', iabLoadStart);
			}
			browser.addEventListener('exit', iabClose);

			function removeListener(){
				if(utils.isIOS()){
					browser.removeEventListener('loadstart', iabLoadStart);
				}else{
					browser.removeEventListener('loadstop', iabLoadStart);
				}
				browser.removeEventListener('exit', iabClose);
			};

			function iabLoadStart(event) {
				if (event.url.indexOf(sign) > -1) {
					successCallback.call(_this, event.url);
					removeListener();
					browser.close();
				}
			};

			function iabClose(event) {
				notification.loading(false);
				if(cancelCallback){
					cancelCallback.call(_this, event.url);
				}
				removeListener();
			};
		}

	},
	checkEmail: function(value) {
		var flag = false;
		if (!value) return false;
		if (typeof value == "string") {
			value = value.replace(/(^\s*)|(\s*$)/g, "").split(";");
		}
		if (value[value.length - 1] == "") {
			value.pop();
		}
		var regularExpression = /^[0-9a-z_-][_.0-9a-z-]{0,31}@([0-9a-z][0-9a-z-]{0,30}\.){1,4}[a-z]{2,4}$/i;
		for (var i = 0, len = value.length; i < len; i++) {
			if (regularExpression.test(value[i])) {
				flag = true;
			} else flag = false;
		}
		return flag;
	},
	detect: (function(ua) {
		var os = this.os = {}, browser = this.browser = {},
			webkit = ua.match(/WebKit\/([\d.]+)/),
			android = ua.match(/(Android)\s+([\d.]+)/),
			ipad = ua.match(/(iPad).*OS\s([\d_]+)/),
			iphone = !ipad && ua.match(/(iPhone\sOS)\s([\d_]+)/),
			webos = ua.match(/(webOS|hpwOS)[\s\/]([\d.]+)/),
			touchpad = webos && ua.match(/TouchPad/),
			kindle = ua.match(/Kindle\/([\d.]+)/),
			silk = ua.match(/Silk\/([\d._]+)/),
			blackberry = ua.match(/(BlackBerry).*Version\/([\d.]+)/),
			bb10 = ua.match(/(BB10).*Version\/([\d.]+)/),
			rimtabletos = ua.match(/(RIM\sTablet\sOS)\s([\d.]+)/),
			playbook = ua.match(/PlayBook/),
			chrome = ua.match(/Chrome\/([\d.]+)/) || ua.match(/CriOS\/([\d.]+)/),
			firefox = ua.match(/Firefox\/([\d.]+)/)

			// Todo: clean this up with a better OS/browser seperation:
			// - discern (more) between multiple browsers on android
			// - decide if kindle fire in silk mode is android or not
			// - Firefox on Android doesn't specify the Android version
			// - possibly devide in os, device and browser hashes

			if (browser.webkit = !! webkit) browser.version = webkit[1]

			if (android) os.android = true, os.version = android[2]
			if (iphone) os.ios = os.iphone = true, os.version = iphone[2].replace(/_/g, '.')
			if (ipad) os.ios = os.ipad = true, os.version = ipad[2].replace(/_/g, '.')
			if (webos) os.webos = true, os.version = webos[2]
			if (touchpad) os.touchpad = true
		if (blackberry) os.blackberry = true, os.version = blackberry[2]
		if (bb10) os.bb10 = true, os.version = bb10[2]
		if (rimtabletos) os.rimtabletos = true, os.version = rimtabletos[2]
		if (playbook) browser.playbook = true
		if (kindle) os.kindle = true, os.version = kindle[1]
		if (silk) browser.silk = true, browser.version = silk[1]
		if (!silk && os.android && ua.match(/Kindle Fire/)) browser.silk = true
		if (chrome) browser.chrome = true, browser.version = chrome[1]
		if (firefox) browser.firefox = true, browser.version = firefox[1]

		os.tablet = !! (ipad || playbook || (android && !ua.match(/Mobile/)) || (firefox && ua.match(/Tablet/)))
		os.phone = !! (!os.tablet && (android || iphone || webos || blackberry || bb10 || (chrome && ua.match(/Android/)) || (chrome && ua.match(/CriOS\/([\d.]+)/)) || (firefox && ua.match(/Mobile/))))
		return os;
	})(navigator.userAgent),
	isIOS: function() {
		return this.detect.ios == true;
	},

	isAndroid: function() {
		return this.detect.android == true;
	},
	incloud: function(file) {
		if (file.match(/\.css/i)) {
			file += "?ver=" + this.ver;
			file = '<link title="default" href="' + file + '" type="text/css" rel="stylesheet">';
		} else {
			file += "?ver=" + this.ver;
			file = '<script type="text/javascript" src="' + file + '"></script>';
		}
		document.write(file);
	},

	adcloud: function(file,callback) {
		var element = '';
		if (file.match(/\.css/i)) {
			element = document.createElement('link');
			element.href = file + "?ver=" + this.ver;
			element.rel = 'stylesheet';
			element.type = 'text/css';
		} else {
			element = document.createElement('script');
			element.src = file + "?ver=" + this.ver;
			element.type = "text/javascript";
		}
		// 不管js或css加载成功还是失败都要做回调函数
		element.onload = function(){
			console.log('js加载成功'+file);
			if(typeof callback === 'function'){
				setTimeout(callback,0);
			}
		}
		element.onerror = function(){
			console.log('js加载失败'+file);
			if(typeof callback === 'function'){
				setTimeout(callback,0);
			}
		}
		document.body.appendChild(element);
	},
	/*
	* 设置多语言css和js
	* by goingta
	 */
	setLanguage:function(readyCallback){
		//把回调函数放在多语言的js 中,就可以了因为css加载完了之后会自动覆盖之前的样式的所以添加多语言css不用回调函数
		utils.adcloud('language/'+this.getLanguage()+".js",readyCallback);

		utils.adcloud('language/'+this.getLanguage()+".css");
	},
	getLanguage:function(){
		var language = null,
			lang = window.cNative.lang;

		if(!lang){
			lang = navigator.language;
		}

		switch(lang.toLowerCase()){
			case 'zh-cn':
			case 'zh_cn':
				language = 'zh_cn';
				break;
			case 'th':
			case 'th_th':
				language = 'th_th';
				break;
			case 'zh-tw':
			case 'zh_tw':
			case 'zh-hk':
			case 'zh_hk':
				language = 'zh_tw';
				break;
			default:
				language = 'en_us';
				break;
		}
		return language;
	},

	emailToLoad: function(email, obj) {

		//主流邮箱登录地址hash值
		email = email || this.email;
		if (!email) return;
		var hash = {
			'qq.com': 'http://mail.qq.com',
			'gmail.com': 'http://mail.google.com',
			'sina.com': 'http://mail.sina.com.cn',
			'163.com': 'http://mail.163.com',
			'126.com': 'http://mail.126.com',
			'yeah.net': 'http://www.yeah.net/',
			'sohu.com': 'http://mail.sohu.com/',
			'tom.com': 'http://mail.tom.com/',
			'sogou.com': 'http://mail.sogou.com/',
			'139.com': 'http://mail.10086.cn/',
			'hotmail.com': 'http://www.hotmail.com',
			'live.com': 'http://login.live.com/',
			'live.cn': 'http://login.live.cn/',
			'live.com.cn': 'http://login.live.com.cn',
			'189.com': 'http://webmail16.189.cn/webmail/',
			'yahoo.com.cn': 'http://mail.cn.yahoo.com/',
			'yahoo.cn': 'http://mail.cn.yahoo.com/',
			'eyou.com': 'http://www.eyou.com/',
			'21cn.com': 'http://mail.21cn.com/',
			'188.com': 'http://www.188.com/',
			'foxmail.com': 'http://www.foxmail.com'
		};
		var url = email.split('@')[1];
		if (hash[url]) {
			//$(obj).attr('href', hash[url]);
			return hash[url];
		} else {
			return 'http://mail.' + url;
			//$(obj).attr('href', 'http://mail.' + url);
		}
	}
};
////////////////////////////
(function() {
	Date.prototype.format = function(format) {
		var o = {
			"M+": this.getMonth() + 1, //month
			"d+": this.getDate(), //day
			"h+": this.getHours(), //hour
			"m+": this.getMinutes(), //minute
			"s+": this.getSeconds(), //second
			"q+": Math.floor((this.getMonth() + 3) / 3), //quarter
			"S": this.getMilliseconds() //millisecond
		}
		if (/(y+)/.test(format)) format = format.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
		for (var k in o) if (new RegExp("(" + k + ")").test(format)) format = format.replace(RegExp.$1,
					RegExp.$1.length == 1 ? o[k] : ("00" + o[k]).substr(("" + o[k]).length));
		return format;
	}

	window.onerror = function(message, url, lineNumber) {
        utils.log("!! Error: "+" in "+url+" at line "+lineNumber+" ", message);
    }

})();