/**************************************************************************/
/*                                                                        */
/* Copyright (c)2010-2012  Pinguo Company             　　　　　　　      */
/*                 品果科技                            版权所有 2010-2012 */
/*                                                                        */
/* PROPRIETARY RIGHTS of Pinguo Company are involved in the  　　　　　　 */
/* subject matter of this material.  All manufacturing, reproduction, use,*/
/* and sales rights pertaining to this subject matter are governed by the */
/* license agreement.  The recipient of this software implicitly accepts  */
/* the terms of the license.                                              */
/* 本软件文档资料是品果公司的资产,任何人士阅读和使用本资料必须获得        */
/* 相应的书面授权,承担保密责任和接受相应的法律约束.                       */
/*                                                                        */
/**************************************************************************/
define(function(require, exports, module) {

	$.ns('c360.dialog');

	require('component/dialog/dialog');

	require('component/dialog/abstract.css');

	var templateDom = '<div id="dialogLoad" class="loading">\
			<img src="images/loading.gif" />\
		</div>',
		abstract = Backbone.View.extend({
		// 初始化弹出框
		initialize : function() {
			this.model = new Backbone.Model();
			this.options.afterunload = $.proxy(this,'delEvents');
		},
		events:{
			'keyup input':'checkInput',
			'change input':'checkInput'
		},
		// 初始化参数
		options:{

		},
		// 验证input的输入长度
		checkInput:function(event){
			var target = $(event.currentTarget);
			utils.cutstr(target.val(),60,function(text){
				target.val(text);
				notification.bubble(lang.over60);
			});
		},
		template:null,
		// 设置模版
		setTemplate:function(){

			// 得到模版内容
			this.$el.addClass(this.id+" dialog").attr('id',this.id).html(this.getPanelTemplate());
			
			if(this.$el.find('#dialogLoad').length == 0){
				this.$el.append(this.getLoadTemplate());
			}
			
			this.options.content = this.$el;
		},
		// 得到load模版
		getLoadTemplate:function(){
			// loading的模版动态加载
			var loadingTemplate = _.template(templateDom);
			// 根据model数据替换模版数据
			return loadingTemplate(this.model.toJSON());
		},
		// 得到panel模版s
		getPanelTemplate:function(){
			// panel的模版动态加载
			if(document.getElementById(this.templateId)){
				this.template = _.template($('#'+this.templateId).html());
			}

			if(!this.template) throw new Error('dialog initialize error!');

			// 根据model数据替换模版数据
			return this.template(this.model.toJSON());
		},
		// 渲染弹出框
		render : function(model,complete,cancel,option) {
			// 设置model数据
			this.model.set(model || {id:this.id});

			this.setTemplate();

			if($.isFunction(complete)) {
				this.completeCallback = complete;
			};

			if($.isFunction(cancel)) {
				this.cancelCallback = cancel;
			};

			c360.dialog = $.dialog($.extend(this.options,option));
		},
		close:function(){
			this.$('.target-btn').removeClass('target-btn');
			c360.dialog.close();
		},
		// 完成回调函数
		completeCallback:function(flag){
			flag && c360.dialog.showLoad();
		},
		// 删除事件
		delEvents:function(){
			$.isFunction(this.cancelCallback) && this.cancelCallback.call(this);
		}
	});

	return abstract;

});