/**************************************************************************/
/*                                                                        */
/* Copyright (c)2010-2012  Pinguo Company             　　　　　　　      */
/*                 品果科技                            版权所有 2010-2012                    */
/*                                                                        */
/* PROPRIETARY RIGHTS of Pinguo Company are involved in the  　　　　　　 */
/* subject matter of this material.  All manufacturing, reproduction, use,*/
/* and sales rights pertaining to this subject matter are governed by the */
/* license agreement.  The recipient of this software implicitly accepts  */
/* the terms of the license.                                              */
/* 本软件文档资料是品果公司的资产,任何人士阅读和使用本资料必须获得                               */
/* 相应的书面授权,承担保密责任和接受相应的法律约束.                          */
/*                                                                        */
/**************************************************************************/
(function(window){
	//有些方法不需要localkey也能够访问, 这些方法名需要保存在unlogined里面
	var unlogined = 'mobile/user/login,mobile/site/h5upgrade,mobile/user/logout,'; 
	if(!$.serverIp){
		$.serverIp='https://cloudtest.camera360.com';
	}
	// $.upgradeHost = 'https://192.168.1.106'; 
	//$.upgradeHost = 'https://cloud-tanglei.camera360.com'; 
	$.upgradeHost = 'https://cloud-liuhongwei.camera360.com'; 
	/*
	* url:发送请求地址。
	* serverData:待发送 Key/value 参数。
	* callback:载入成功时回调函数。
	* 使用方法：
	* getJSON(url,[serverData],callback);
	*/

	var getJSON = function(){
		var method = null;
		var callback = null;
		var serverData = {};
		switch(arguments.length){
			case 0:
			case 1:
				throw Error('Missing arguments');
				break;
			case 2:
				method = arguments[0];
				callback = arguments[1];
				if(! callback instanceof Function){
					throw Error('Invild Arguments');
				}
				break;
			case 3:
				method = arguments[0];
				serverData = arguments[1];
				callback = arguments[2];
				if(! callback instanceof Function){
					throw Error('Invild Arguments');
				}
				break;
		}
		console.log('server '+method);
		//有些方法不需要localkey也能够访问
		if(unlogined.indexOf(method.toLowerCase())==-1 && utils.isMobile && method.toLowerCase().indexOf('mobile/site/h5upgrade')==-1){
			var user = window.cNative.getUser();
			if(!user || !user.uid){
				alert('Please login');
				callback({status:435,message:'Please login'});
				return;
			}
			serverData.localkey = user.pwd;
		}
		var url = '';
		if(method.toLowerCase().indexOf('http')==0){
			url = method;
		}else{
			url = $.serverIp+($.serverIp[$.serverIp.legnth-1]=='/'?'':'/')+method;
		}
		utils.log("requesting "+url);
 		utils.log("request "+method+" ", serverData);
 		var t = new Date().getTime();
 		///////////////////////////////////////////////////////////////////////
		return $.ajax({

			timeout:31000,
			type:"get",
			url:url,
			data:serverData,
			dataType:"jsonp",
			jsonp:'jsonpCallback',
			success:function(resp){
				utils.log("resp "+method+" COST="+ (new Date().getTime()-t));
                utils.log("resp "+method+" ", resp);
				if(callback)
					callback(resp);
			},
			error:function(request, textStatus, errorThrown){
                console.log("resp "+method+" error");
				if(errorThrown == 'abort' || errorThrown == '')return;
				var message = null;
				callback({status:500,message:textStatus});
			},
			statusCode: {
				404: function() {
                	console.log("resp "+method+" statusCode 400");
				    callback({status:404,message:lang.error404});
				},
				500: function(){
                	console.log("resp "+method+" ßstatusCode 500");
					callback({status:500,message:lang.error500});
				}
			}
		});
	}
	
	var Server = function(){},

		a = Server.prototype,
	
/******************************************************
					初始化每个页面的请求对象
*******************************************************/

	homePage = a.homePage = {},

	albumPage = a.albumPage = {},

	trashPage = a.trashPage = {},

	singlePage = a.singlePage = {},

	share = a.share = {},

	secretPage = a.secretPage = {},

	wallPage = a.wallPage = {},

	tagPage = a.tagPage = {},

	messagePage = a.messagePage = {},

	common = a.common = {},

	user = a.user = {};

	a.h5Upgrade = function(host, callback){
		return getJSON(host+'/mobile/site/H5Upgrade',{ver:utils.ver, t:new Date().getTime()}, function(data){
			callback(data);
		});
	}

	/*
	 *用户登陆的发送请求
	*/
	user.login = function(json,callback){
		return getJSON('mobile/user/login',json, function(data){
			callback(data);
		});
	};

	user.logout = function(callback){
		return getJSON('mobile/user/logout',function(data){
			callback(data);	
		})
	}

	share.getThirdInfo = function(callback){
		return getJSON('mobile/share/showThird',{}, function(data){
			callback(data);
		});
	}

	share.setExpireTime = function(appcode,uid,callback){
		return getJSON('mobile/share/setExpireTime',{siteCode:appcode,uid:uid}, function(data){
			callback(data);
		});
	};

	share.getPhotoBase64 = function(key, callback){
		console.log("share.getPhotoBase64 ");
		return getJSON('mobile/picture/info',{remoteId:key, t:new Date().getTime()}, function(data){
			callback(data);
		});
	}
	
/******************************************************
					yearPage页面的请求方法
*******************************************************/
	

	window.server = new Server();

})(window);