define(function(require, exports, module) {

	var notification = require('common/Notification.js'),
		md5 = require('common/md5.js');
	require('route/backButton.js');

	var BindEmailView = Backbone.View.extend({

		el: $('.bindcontain'),

		template: _.template($('#email-bind-show-template').html()),

		nativeUserInfo: {
			email: '',
			uid: '',
			pwd: '',
			expire: 82000,
			data: ''
		},

		initialize: function() {
			this.step = 1;
			this.render();
		},
		events: {
			'touchstart .firstemail.enable': 'firstStep',
			'tap .surebtn': 'sureStep',
			'tap .returnbtn': 'back',
			'blur #focusInput': 'passInputmove',
			'focus #focusInput':'passInputmove'
		},
		render: function(step) {
			this.step = step || 1;
			if (this.step == 1) {
				this.h = document.documentElement.clientHeight || document.body.clientHeight;
				this.inputwrapH = $('.btextcontain').height();
			}
			var htm = this.template({
				step: this.step
			});
			this.$el.html(htm);
		},

		verticalLoc: 0,

		setverticalLoc: function() {
			var movedistance = parseInt($('.btextcontain').css('marginTop') + ''),
				inputwraph = this.inputwrapH;

			var verticalLoc = this.verticalLoc;
			if (movedistance > 10) {
				$('.btextcontain').animate({
					'marginTop': 0
				}, 100);
				this.verticalLoc = 0;
			} else if (movedistance < -inputwraph + 80) {
				var loc = -inputwraph + 80;
				this.verticalLoc = loc;
				$('.btextcontain').animate({
					'marginTop': loc
				}, 100);
			} else {
				this.verticalLoc = parseInt($('.btextcontain').css('marginTop') + '');
			}
		},

		passInputmove: function(event) {
			if (navigator.userAgent.toLowerCase().match(/android/)) {
				var pos = {};
				pos.marginTop = event.type == 'focus'? (-100 + 'px') : (0+'px');
				$('.btextcontain').animate(pos, 300);
				this.verticalLoc = -100;
			}
		},

		firstStep: function(event) {
			var that = this;
			var email = $.trim($('.email').val()),
				pass = $.trim($('.pass').val()),
				passtwo = $.trim($('.passtwo').val());

			if (that.check.checkEmail(email).flag == 0) {
				notification.bubble(that.check.checkEmail(email).message, 1);
				return;
			}
			if (that.check.checkPass(pass, 1).flag == 0) {
				notification.bubble(that.check.checkPass(pass, 1).message, 1);
				return;
			} else if (that.check.checkPass(passtwo, 2).flag == 0) {
				notification.bubble(that.check.checkPass(passtwo, 2).message, 1);
				return;
			} else if (pass !== passtwo) {
				notification.bubble(lang.passwordDifferent, 1);
				return;
			} else {
				pass = md5(md5(pass));
				notification.loading(true, '', true);
				$('.firstemail').removeClass('enable');
				c360.server.bindEmal({
					email: email,
					password: pass
				}, function(resp) {
					$('.firstemail').addClass('enable');
					if (resp.status == 200 && resp.uid != '') {
						window.cNative.getLoginUser(function(res) {
							if (res.error == 200) {
								that.nativeUserInfo.email = email;
								that.nativeUserInfo.uid = res.uid;
								that.nativeUserInfo.pwd = res.pwd;
								that.nativeUserInfo.data = res.data;
								that.nativeUserInfo.data.email = email;

								window.cNative.setLoginUser(that.nativeUserInfo, function(json) {
									if (json.error == 200) {
										window.cNative.nativeViewDispatchEvent({
											event: "bindEmailSuccess",
											data: {}
										}, function(data) {});
										notification.loading(false, '', true);
										that.render(2);
									} else {
										notification.loading(false, '', true);
										notification.bubble(lang.saveNativeFailed, 4);
									}
								});
							} else {
								notification.loading(false, '', true);
							}
						})

					} else if (resp.uid == '') {
						window.cNative.setLoginUser({
							email: '',
							uid: '',
							pwd: '',
							expire: 0
						}, function(data) {
							if (window.localStorage) {
								window.localStorage.setItem('database.isCreated', 'false');
							}
							window.cNative.gotoNativeView({
								viewId: 'cloudHomeView'
							});
						});
					} else {
						notification.loading(false, '', true);
						notification.alert(resp.message, function() {}, lang.tips);
					}
				});
			}

		},

		sureStep: function() {
			window.cNative.closeTopestView();
		},

		back : function() {
			window.cNative.closeTopestView();
		},

		check: {
			checkEmail: function(email) {
				if (email.length == 0) {
					return {
						message: lang.haveNoEmail,
						flag: 0
					};
				}
				if (utils.checkEmail(email)) {
					return {
						message: '',
						flag: 1
					};
				} else return {
					message: lang.falseFormatEmail,
					flag: 0
				};
			},
			checkPass: function(pass, firstOrSecond) {
				if (pass.length == 0 && firstOrSecond == 1) {
					return {
						message: lang.haveNoPassword,
						flag: 0
					};
				} else if (pass.length == 0 && firstOrSecond == 2) {
					return {
						message: lang.ensurePasswordIsNeed,
						flag: 0
					};
				}
				if (pass.length < 6 || pass.length > 20) {
					return {
						message: lang.passwordLimit,
						flag: 0
					};
				} else return {
					message: '',
					flag: 1
				};
			}
		}

	});

	return new BindEmailView();

});