define(function(require, exports, module) {
	var notification = require('common/Notification.js');
	require('common/storage.js');

	document.addEventListener("backbutton", backbuttonFn, false);

	function backbuttonFn() {
		//关闭loading
		cNative.displayLoadingIcon({
			show: false,
			msg: "Loading",
			modal: false
		});

		//关闭dialog
		if (c360.dialog && c360.dialog.closed == false) {
			c360.dialog.close();
			return;
		}

		//回到设置页
		if (typeof c360 == "object" && typeof c360.backButtonFn == "function") {
			c360.backButtonFn();
		} else {
			cNative.gotoNativeView({
				viewId:'returnLastView',
				from:''
			});
		}
	};

	window.backbutton = backbuttonFn;

	var util = utils,
		server = c360.server,
		//sns授权取得的数据。
		obj = {
			'isTrue': '',
			'login': '',
			'userInfo': '',
			'thirdInfo': '',
			'bindUserIdUrl': ''
		};

	var nativeUserInfo = {
		email: '',
		uid: '',
		pwd: '',
		expire: 82000,
		data: ''
	};


	function decode(newurl) {
		var urlArr = newurl.split('callResult?')[1].split('&');
		for (var i = 0, l = urlArr.length; i < l; i++) {
			var val = urlArr[i].split('=');
			obj[val[0]] = val[1];
		}
		if (obj['errorMsg']) {
			notification.alert(decodeURIComponent((obj.errorMsg + '').replace(/\+/g, '%20')));
		}
		if (obj.isTrue == 1) {
			obj.userInfo = $.parseJSON(decodeURIComponent((obj.userInfo + '').replace(/\+/g, '%20'))),
			obj.thirdInfo = $.parseJSON(decodeURIComponent((obj.thirdInfo + '').replace(/\+/g, '%20'))),
			obj.bindUserIdUrl = decodeURIComponent((obj.bindUserIdUrl + '').replace(/\+/g, '%20')),
			obj.isTrue = obj.isTrue,
			obj.login = obj.login;
		}
	};
	/*个人设置-登陆账号*/

	/**************
	 *********SNS授权回调函数
	 ****************/

	function thirdCallback(url) {
		decode(url);
		if (obj.isTrue == 1) {
			nativeUserInfo = {
				email: obj.userInfo.email,
				uid: obj.userInfo.userId,
				pwd: obj.userInfo.localkey,
				expire: 82000,
				data: obj.userInfo
			};
			var infor = obj.userInfo,
				third = infor.third,
				email = thirdStatus = thirdTextTip = thirdNickname = thirdName = thirdId = '';
			infor.email ? email = infor.email : email = '';
			infor.status ? status = infor.status : status = '';
			if (third.length != 0) {
				switch (third[0].name) {
					case 'sina':
						thirdTextTip = lang.sinaText;
						break;
					case 'qzone':
						thirdTextTip = lang.qzoneText;
						break;
					case 'twitter':
						thirdTextTip = lang.twitterText;
						break;
					case 'facebook':
						thirdTextTip = lang.facebookText;
						break;
					default:
						break;
				}
				thirdNickname = third[0].nickname;
				thirdName = third[0].name;
				thirdId = third[0].id;
			}
			
			accountbindview.model.set({
				thirdid: thirdId,
				thirdname: thirdName,
				thirdnickname: thirdNickname,
				thirdtip: thirdTextTip,
				email: email,
				emailstatus: status
			});

			window.cNative.setLoginUser(nativeUserInfo, function(data) {
				if (data.error == 200) {
					accountbindview.render();
				}
			});
		} else {
			//notification.bubble(lang.authorizationFailed, 2);
		}
	};

	var accountBindView = Backbone.View.extend({
		className: 'bindcontain',
		events: {
			'tap .bind-sina': 'bindSina',
			'tap .bind-qzone': 'bindQzone',
			'tap .bind-facebook': 'bindFacebook',
			'tap .bind-twitter': 'bindTwitter',
			'tap .bind-email': 'bindEmail',
			'tap .identi-email.enable': 'identiEmail',
			'tap .return': 'back',
			'tap #logout': 'logout'
		},
		template: _.template($('#account-bind-show-template').html()),
		initialize: function() {
			this.flag = true;
			this.model = new Backbone.Model();
			this.getNativeData();
			this.getUserInfo();
			c360.events.on('bindEmailSuccess', function(data) {
				utils.gotoPage("bindAccount.html?t=" + (new Date).getTime());
			});
		},
		bindSina: function() {
			this.getSNS('sina');
		},
		bindQzone: function() {
			this.getSNS('qzone');
		},
		bindFacebook: function() {
			this.getSNS('facebook');
		},
		bindTwitter: function() {
			this.getSNS('twitter');
		},
		getSNS: function(sitecode) {
			var that = this;
			var language = window.cNative.lang;
			var user = window.cNative.getUser();
			if (!user || !user.data || !user.data.localkey) {
				window.cNative.showBubbleMessage({
					msg: lang.pleaseLogin,
					duration: 3
				});
			}
			var url = $.serverIp + '/sns/login/index?' + 'siteCode=' + sitecode + '&source=mobile&lang=' + language + '&redirect=1&bindLogin=1&localkey=' + user.data.localkey;
			util.openWin(url, 'callResult', thirdCallback);
		},
		bindEmail: function() {
			utils.gotoPage('bindEmail.html', true);
		},

		logout: function() {
			this.flag = false;
			c360.storage.clear();
			if (c360.database) {
				c360.database.clearAllTables();
			}

			window.cNative.userLogout(function(resp) {
				if (resp.error == 200) {
					window.cNative.stopUploading(function(data) {
						if (data.error == 200) {
							window.cNative.showStatusMessage({
								text: '', //string   消息内容
								type: 1, //int   消息类型 0,等待 1,完成 2,错误
								duration: 2, //int  消息持续显示的时长 -1,不消失,单位:秒
								animation: false, //bool   是否显示翻页动画
								immediate: true, //bool 是否立即显示消息，如果是true，之前消息队列中所有消息会被清空
								position: -1, //int 显示在状态栏的水平相对位置,默认在200
								width: -1, //int   宽度，默认120
							});
						}
					});
					window.cNative.gotoNativeView({
						viewId: 'cloudHomeView',
						from: ''
					});
				} else {
					window.cNative.showBubbleMessage({
						msg: resp.message,
						duration: 2
					});
				}
			});
		},
		//认证邮箱
		identiEmail: function() {
			var dom = $('.identi-email'),
				num = 20;
			dom.removeClass('enable');
			server.verifyEmail(function(resp) {
				if (resp.status == 200) {
					notification.bubble(lang.identifyHasSendText, 2);
					var timer = setInterval(function() {
						dom.text(num);
						num--;
						if (num < 0) {
							dom.text(lang.identify).addClass('enable');
							clearInterval(timer);
						}
					}, 1000);
				} else {
					notification.bubble(resp.message, 2);
				}
			});
		},
		back: function() {
			//跳转到native设置页面
			window.cNative.gotoNativeView({
				viewId: 'returnLastView',
				from: ''
			});
		},
		getUserInfo: function() {
			var self = this;
			window.cNative.getLoginUser(function(data) {
				if (data.error == 200 && data.uid != '') {
					var localkey = data.data.localkey;
					server.userinfor({
						localkey: localkey
					}, function(resp) {
						if (self.flag == false) return; //如果用户已经点击退出按钮,则不再setLoginUser,避免退出后再次自动登录
						if (resp.status == 200) {
							cNative.setLoginUser({
								email: resp.data.email,
								uid: resp.data.userId,
								pwd: resp.data.localkey,
								expire: 82000,
								data: resp.data
							}, function(data) {
								if (data.error == 200) {
									//zhangzhi 以后需要修改逻辑
									self.getNativeData('isEnableToClickEmail');
								}
							});
						}
					})
				} else if (data.uid == '') {
					window.cNative.setLoginUser({
						email: '',
						uid: '',
						pwd: '',
						expire: 0
					}, function(data) {
						if (window.localStorage) {
							window.localStorage.setItem('database.isCreated', 'false');
						}
						window.cNative.gotoNativeView({
							viewId: 'cloudHomeView'
						});
					});
				}
			})
		},
		getNativeData: function(arg) {
			var self = this,
				language = window.cNative.lang;
			cNative.getLoginUser(function(resp) {
				if (resp.error == 200 && resp.uid != '') {
					var infor = resp.data,
						third = resp.data.third,
						email = thirdStatus = thirdTextTip = thirdNickname = thirdName = thirdId = '';
					infor.email ? email = infor.email : email = '';
					infor.status ? status = infor.status : status = '';
					if (third.length !== 0) {
						switch (third[0].name) {
							case 'sina':
								thirdTextTip = lang.sinaText;
								break;
							case 'qzone':
								thirdTextTip = lang.qzoneText;
								break;
							case 'twitter':
								thirdTextTip = lang.twitterText;
								break;
							case 'facebook':
								thirdTextTip = lang.facebookText;
								break;
							default:
								break;
						}
						thirdNickname = third[0].nickname;
						thirdName = third[0].name;
						thirdId = third[0].id;
					};
					//有第三方nickname就取第三方nickname,没有的话就取 data.nickname
					//之前nickname直接取的data.nickname导致第三方的昵称始终显示的是云相册的nickname  by goingta  2013-07-29
					thirdNickname = thirdNickname?thirdNickname:resp.data.nickname;

					self.model.set({
						thirdid: thirdId,
						thirdname: thirdName,
						thirdnickname: thirdNickname,
						thirdtip: thirdTextTip,
						email: email,
						emailstatus: status,
						language: language
					})
					self.render(arg);
				} else if (resp.uid == '') {
					window.cNative.setLoginUser({
						email: '',
						uid: '',
						pwd: '',
						expire: 0
					}, function(data) {
						if (window.localStorage) {
							window.localStorage.setItem('database.isCreated', 'false');
						}
						window.cNative.gotoNativeView({
							viewId: 'cloudHomeView'
						});
					});
				}
			});
		},
		render: function(arg) {
			$('.bindcontain')[0] ? $('.logincontain').html('') : $('body').append(this.$el);
			var htm = this.template(this.model.toJSON());
			this.$el.html(htm);
			if (arg == 'isEnableToClickEmail') {
				$('.bind-email').addClass('enable');
			}
		}
	});

	var accountbindview = new accountBindView();

});