define(function(require, exports, module) {

	document.addEventListener("backbutton", backbuttonFn, false);

	function backbuttonFn() {
		//关闭loading
		cNative.displayLoadingIcon({
			show: false,
			msg: "Loading",
			modal: false
		});

		//关闭dialog
		if (c360.dialog && c360.dialog.closed == false) {
			c360.dialog.close();
			return;
		}

		//回到设置页
		if (typeof c360 == "object" && typeof c360.backButtonFn == "function") {
			c360.backButtonFn();
		} else {
			cNative.gotoNativeView({
				viewId:'returnLastView',
				from:''
			});
		}
	};

	window.backbutton = backbuttonFn;

	var baseView = Backbone.View.extend({

		el: document.getElementById('cloudSettingPage'),

		events: {
			'tap .siteControl.enable': 'siteControl',
			'tap #gotoTrash': 'gotoTrash',
			'tap .back': 'back'
		},

		initialize: function() {
			var _this = this;
			this.template = _.template($('#base-template').html());
			this.model = new Backbone.Model();
			window.cNative.getLoginUser(function(data) {
				if (data.error == 200 && data.uid != '') {
					_this.model.set({
						count: data.data.pictureCount
					});
					_this.render();
				} else if (data.uid == '') {
					window.cNative.setLoginUser({
						email: '',
						uid: '',
						pwd: '',
						expire: 0
					}, function(data) {
						if (window.localStorage) {
							window.localStorage.setItem('database.isCreated', 'false');
						}
						window.cNative.gotoNativeView({
							viewId: 'cloudHomeView'
						});
					});
				}
			});
		},

		back: function() {
			window.cNative.gotoNativeView({
				viewId: 'returnLastView',
				from: 'cloudSetting.html'
			});
		},

		gotoTrash: function() {
			// window.cNative.openNewView({
			// 	url:'recycle.html'
			// });
			utils.gotoPage("recycle.html", true, {
				showTitleBar: true
			});
		},

		render: function() {
			this.$el.html(this.template(this.model.toJSON()));
			$('.hasUploadedCount').text(this.model.get('count'));
		},

		siteControl: function(event) {
			var target = $(event.target);
			target.removeClass('enable');
			setTimeout(function(){
				target.addClass('enable');
			},1000);
			utils.gotoPage($(event.target).attr('data-target'), true, {
				showTitleBar: true
			});
			// window.cNative.openNewView({
			// 	url:$(event.target).attr('data-target')
			// },function(){
			// });
		}
	});

	new baseView();

});