define(function(require, exports, module) {

	var CONSTANT = {

		},

		disabled = 'disabled',			// 定义点击失效class样式

		footerDraw = Backbone.View.extend({

			el:document.getElementById('drawFooter'),

			// 定义裁切底部模版
			template:_.template($('#draw-footer-template').html()),

			/**********************************************
			 * @actionName	定义页面事件.
			 *********************************************/
			events:{
				'tap .footer-left':'back',
				'tap .footer-right':'save'
			},

			/**********************************************
			 * @actionName	初始化页面.
			 *********************************************/
			initialize:function(){
				this.$el = $('#drawFooter');

				this.el = this.$el[0];

				this.model = new Backbone.Model({
					content:lang.cropPhoto
				});

				this.render();
			},

			/**********************************************
			 * @actionName	渲染页面.
			 *********************************************/
			render:function(){
				this.$el.append(this.template(this.model.toJSON()));
			},

			/**********************************************
			 * @actionName	返回上一级页面.
			 *********************************************/
			back:function(){
				location.href = '#';
			},

			/**********************************************
			 * @actionName	更新头像接口.
			 * @param face string 表示头像路径
			 *********************************************/
			updateFace:function(face){
				window.userInfo.data.face=face;
				window.cNative.setLoginUser(window.userInfo,function(data){});
			},

			/**********************************************
			 * @actionName	保存头像接口.
			 *********************************************/
			save:function(event){
				var target = $(event.currentTarget);
				if(target.hasClass(disabled))return;

				target.addClass(disabled);

				c360.notification.loading(true,'Loading');
				
				var draw = c360.page.draw,
					photeData = draw.photeData,
					rate = draw.rate,
				    _this = this,
				    // 计算出最大宽度
				    photoWidth = Math.min(Math.max(photeData.w*rate,0),draw.imageWidth),
				    // 计算出最大高度
				    photoHeight = Math.min(Math.max(photeData.h*rate,0),draw.imageHeight),
				    // 计算出裁切出的最大高度和宽度
				    photoSize = Math.min(photoWidth,photoHeight),
				    // 计算出最大横坐标
				    photoX = Math.min(Math.max(photeData.x*rate,0),draw.imageWidth - photoSize),
				    // 计算出最大纵坐标
				    photoY = Math.min(Math.max(photeData.y*rate,0),draw.imageHeight - photoSize);

				// 停止功能事件
				$.stopDraw();

			    window.cNative.cropImage({
					file: c360.storage.get('picUrl'),
					x: photoX,
					y: photoY,
					width: photoSize,
					height: photoSize,
					size: Math.min(photoSize,photeData.size)
			    }, function(json) {
			    	if(json.error == 200){
			    		window.cNative.doHttpPost($.serverIp+'/mobile/user/uploadAvatar',{
							face:json.data
						},function(json){
							c360.notification.loading(false,'Loading');
							if(json.code == 200){
								json = $.parseJSON(json.body);
								if(json && json.status == 200){
									var face = json.data.face;
									c360.page.user.model.set('urlc','https://dn-c360.qbox.me/'+face);
									c360.notification.bubble(lang.cropSuccess);
									_this.updateFace(face);
									_this.back();
								}else{
									c360.notification.bubble(lang.cropError);
								}
							}else{
								c360.notification.bubble(lang.cropError);
							}

							// 开启功能事件
							$.startDraw();

							target.removeClass(disabled);
						});
			    	}else{
			    		c360.notification.loading(false,'Loading');

			    		c360.notification.bubble(lang.cropError);

			    		// 开启功能事件
						$.startDraw();

						target.removeClass(disabled);
			    	}
			        
			    });

			}


		});

		return footerDraw;
});