define(function(require, exports, module) {

	var winAlert = require('ui/dialog/alert/alert.js');
	var notification = require('common/Notification.js');
	//require('route/backButton.js');

	var isOpenNewView = null;
	if(window.location.href.split('isOpenNewView=')[1] != undefined){
		isOpenNewView = window.location.href.split('isOpenNewView=')[1];
	}else{
		require.async('route/backButton.js');
	}


	var pageView = Backbone.View.extend({

		el: document.getElementById('pageContainer'),

		template: _.template($('#findpass-template').html()),

		events: {
			'tap #submit.sendable': 'findPass',
			'tap .back':'back'
		},

		initialize: function() {
			this.model = new Backbone.Model();
			this.render();
		},

		render: function() {
			this.$el.html(this.template(this.model.toJSON()));
		},

		back:function(){
			if(isOpenNewView == 'false'){
				window.cNative.gotoNativeView({
					viewId:'returnLastView',
					from:''
				});	
			}else{
				window.cNative.closeTopestView();
			}
		},

		findPass: function() {
			var href,
				email = $.trim(this.$el.find('.emailInput').val());
			if (email == '') {
				window.cNative.showBubbleMessage({
					msg: lang.needEmail,
					duration: 2
				});
			} else {
				if (utils.checkEmail(email)) {
					$('#submit').removeClass('sendable');
					$('#emailInput').blur();
					notification.loading(true, '', true);
					c360.server.sendResetEmail({
						email: email
					}, function(res) {
						notification.loading(false, '', true);
						$('#submit').addClass('sendable');
						if (res.status == 200) {
							winAlert.render({
								title: lang.emailHasSend,
								content: lang.emailHasSendContent,
								certain: lang.loginEmail
							}, function(event) {
								this.close();
								window.open(href, "window_" + href, "");
							}, null, {
								domShowCallback: function() {
									$('#userEmail').html($('#emailInput').val());
									href = utils.emailToLoad(email);
								}
							});
						}else{
							window.cNative.showBubbleMessage({
								msg:res.message,
								duration:2
							});
						}
					});
				} else {
					window.cNative.showBubbleMessage({
						msg: lang.emailError,
						duration: 2
					});
				}
			}
		}
	});

	new pageView();
});