define(function(require, exports, module) {

	var showTopView = require('page/loginweb/topshow/index');
	var notification = require('common/Notification.js'),
		util = utils,
		autoUpdate = require('common/autoUpdate'), //自动更新模块
		md5 = require('common/md5.js'),
		server = c360.server;

	require('ui/dialog/alert/alert');
	//sns授权取得的数据。
	var obj = {
		'isTrue': '',
		'login': '',
		'userInfo': '',
		'thirdInfo': '',
		'bindUserIdUrl': ''
	};
	//转码


	function decode(newurl) {
		var urlArr = newurl.split('?')[1].split('&');
		for (var i = 0, l = urlArr.length; i < l; i++) {
			var val = urlArr[i].split('=');
			obj[val[0]] = val[1];
		}
		if (obj.isTrue == 1) {
			obj.userInfo = $.parseJSON(decodeURIComponent((obj.userInfo + '').replace(/\+/g, '%20')));
			obj.thirdInfo = $.parseJSON(decodeURIComponent((obj.thirdInfo + '').replace(/\+/g, '%20')));
			obj.bindUserIdUrl = decodeURIComponent((obj.bindUserIdUrl + '').replace(/\+/g, '%20'));	
		}
		utils.log('sns login data decode\t ', obj);
	}
	var nativeUserInfo = {
		email: '',
		uid: '',
		pwd: '',
		expire: 82000,
		data: ''
	};

	var UserModel = Backbone.Model.extend({
		initialize: function() {
			this.set({
				'albumCount': '',
				'pictureCount': '',
				'face': '',
				'nickName': '',
				'localkey': ''
			});
		}
	});

	//检测邮箱或者密码格式
	var check = {
		checkEmail: function(email) {
			if (email.length == 0) {
				return {
					message: lang.haveNoEmail,
					flag: 0
				};
			}
			if (util.checkEmail(email)) {
				return {
					message: '',
					flag: 1
				};
			} else return {
				message: lang.falseFormatEmail,
				flag: 0
			};
		},
		checkPass: function(pass) {
			if (pass.length == 0) {
				return {
					message: lang.haveNoPassword,
					flag: 0
				};
			}
			if (pass.length < 6 || pass.length > 20) {
				return {
					message: lang.passwordLimit,
					flag: 0
				};
			} else return {
				message: '',
				flag: 1
			};
		}
	}

	/*首页email，sns登陆区域view*/
	var LoginView = Backbone.View.extend({
		el: $("#indexpage"),
		template:(function(){
			var language = utils.getLanguage();
			if(language == 'zh_cn'){
				return (_.template($('#login-cn-template').html()));
			}else if(language == 'zh_tw'){
				return (_.template($('#login-tw-template').html()));
			}else{
				return (_.template($('#login-us-template').html()));
			}
		})(),

		loginedTemplate:_.template($('#user-template').html()),

		events: {
			'tap .resetPassword': 'findPass',
			"singletap .more": 'showMore',
			"singletap #emailLogin": 'emailLogin',
			"singletap .sinabtn": 'sinaLogin',
			"singletap .qzonebtn": 'qzoneLogin',
			"singletap .facebookbtn": 'facebookLogin',
			"singletap .twitterbtn": 'twitterLogin',   //singletap will write back
			"singletap .cloud-info.enable":'gotoIndexPage'
		},
		initialize: function() {
			var _this = this;
			this.render();		
			window.cNative.getLoginUser(function(resp) {
				_this.getHomeInfo({
					imei:resp.imei,
					localkey:resp.data.localkey,
					ver: utils.ver
				});
				_this.localEmail = resp.email;
			});
		},

		getHomeInfo:function(json){
			server.homeInfo(json,function(resp){
				if(resp.status == 200){
					//自动更新,放在渲染数据之前
					var upgradeInfo = resp.data.upgrade || false;
					autoUpdate.update(upgradeInfo);
				}else{
					notification.bubble(resp.message);
				}
			});
		},

		showMore:function(event){
			if($('#method-area').hasClass('animate-back')){
				$('#method-area').removeClass('animate-back');
				$('.more').text(lang.back);
			}else{
				$('#method-area').addClass('animate-back');
				$('.more').text(lang.loginMore);
			}
		},

		findPass: function() {
			utils.gotoPage('findPassword.html', true);
		},

		emailLogin: function() {
			//如果是邮箱登录方式，则跳转到老的登录页面loginweb
			
			utils.gotoPage('loginWeb.html?page=home.html');
		},
		render: function() {
			var _this = this;
			cNative.getLoginUser(function(data) {
				if (data.error == 200 && data.pwd && data.uid != '') { 
					//已经登录，则显示用户信息
					_this.returnDom(data.data);
					_this.updateUserInfoFromSever(data);
				} else if (data.uid == '') { 
					//未登录情况，则显示登录界面
					_this.$el.find('.content').html(_this.template(userModel.toJSON()));
				}
			})
		},

		updateUserInfoFromSever:function(resp){
			var _this = this;
			c360.server.userinfor({
				localkey:resp.pwd,
				h5version:utils.ver
			}, function(res){
				if(res.status == 200){

					resp.data = $.extend(true,resp.data,res.data);
					resp.uid = res.data.userId;
					resp.pwd = res.data.localkey;
					resp.expire = 82000;
					window.cNative.setLoginUser(resp ,function(info){
						_this.returnDom(info.data);
					});
				}
			});
		},

		returnDom:function(data){
			var _this = this;
			if(data.face == null || data.face == ''){
				data.face = 'images/userbig.png';
			}else{
				data.face = 'http://dn-c360.qbox.me/'+data.face+'-95';
			}
			if(utils.isIOS()){
				window.cNative.getUploadInfo(function(info){
					data['dom'] = info.restCount >= 30?('<div class="update-alert-ios">'+info.restCount+'</div>'):'';
					_this.$el.find('.content').html(_this.loginedTemplate(data));
				});
				
			}else{
				window.cNative.getUploadEnableState(function(setting){
					data['dom'] = setting.canUpload?'':('<img class="update-alert-android" src="images/home/update_alert.png" />');
					_this.$el.find('.content').html(_this.loginedTemplate(data));
				});
			}
		},

		gotoIndexPage:function(){
			$('.cloud-info').removeClass('enable');
			setTimeout(function(){
				$('.cloud-info').addClass('enable');
			},1000);
			utils.gotoPage("index.html?openNewView=1", true);
		},

		sinaLogin: function() {
			var _this = this;
			notification.loading(true);
			window.cNative.ssoLogin({
				keepCallback: true
			}, function(data) {
				window.cNative.removeAllKeepedCallBack();
				if (data.error == 200) {
					obj = data.data.data;
					_this.loginComplete();
				} else {
					notification.loading(false);
					_this.getSNS('sina');
				}
			});
		},
		qzoneLogin: function() {
			this.getSNS('qzone');
		},
		facebookLogin: function() {
			this.getSNS('facebook');
		},
		twitterLogin: function() {
			this.getSNS('twitter');
		},
		getSNS: function(sitecode) {
			var that = this,
				language = window.cNative.lang,
				url = $.serverIp + '/sns/login/index?' + 'siteCode=' + sitecode + '&source=mobile&lang=' + language + '&redirect=1&localEmail=' + that.localEmail;
			this.browser = utils.openWin(url, 'callResult', that.loginProcess);
		},
		loginProcess: function(url) {
			decode(url);
			loginView.loginComplete();
		},

		loginComplete: function() {
			var _this = this;
			if (obj.isTrue == 1) {
				nativeUserInfo = {
					email: obj.userInfo.email,
					uid: obj.userInfo.userId,
					pwd: obj.userInfo.localkey,
					expire: 82000,
					data: obj.userInfo
				};
				pagemodelSetDate(obj.userInfo.albumCount, obj.userInfo.pictureCount, obj.userInfo.face, obj.userInfo.nickname, obj.userInfo.localkey);
				if (obj.login == 1) {
					if (obj.userInfo.agreeLicence == 0) {
						new serviceView();
					} else {
						window.cNative.setLoginUser(nativeUserInfo, function(data) {
							if (data.error == 200) {
								// 重新渲染登录成功后的页面 change by zhangzhi
								loginView.render();
							}
						});
					}
				}
				if (obj.login == 0) {
					new bindPageView();
				}
			} else {
				//notification.bubble(lang.authorizationFailed, 2);
			}
			notification.loading(false);
		}

	})

	/*sns登录以后，绑定邮箱VIEW*/
	var bindEmailView = Backbone.View.extend({
		className: 'bindemailwrap',
		events: {
			'tap .bind': 'bind',
			'tap .buildnew': 'buildnew',
			'focus .pass': 'slideUp',
			'blur .pass': 'slideDown'
		},
		template: _.template($('#bind-email-template').html()),
		initialize: function() {
			this.render();
		},
		render: function() {
			var htm = this.template(this.model.toJSON());
			this.$el.html(htm);
		},
		slideUp: function() {
			if (navigator.userAgent.toLowerCase().match(/android/)) {
				$('.bindpage-container').animate({
					marginTop: -$('.showtopwrap').height()
				}, 300);
			}
		},
		slideDown: function() {
			if (navigator.userAgent.toLowerCase().match(/android/)) {
				$('.bindpage-container').animate({
					marginTop: 0
				}, 300);
			}
		},
		bind: function() {
			notification.loading(true, '', true);
			var password = $.trim($('.pass').val());
			if (!check.checkPass(password).flag) {
				notification.loading(false, '', true);
				notification.bubble(check.checkPass(password).message, 2);
			} else {
				password = md5(md5(password));
				var email = this.model.get('bindemail'),
					sitecode = this.model.get('siteCode'),
					thirdid = this.model.get('thirdId');
				server.snsbindAccount({
					username: email,
					password: password,
					siteCode: sitecode,
					thirdId: thirdid
				}, function(resp) {
					new serviceView();
					return;
					var data = resp.data;
					if (resp.status == 200) {
						notification.loading(false, '', true);
						nativeUserInfo.email = data.userInfo.email;
						nativeUserInfo.uid = data.userInfo.userId;
						nativeUserInfo.pwd = data.userInfo.localkey;
						nativeUserInfo.data = data.userInfo;
						pagemodelSetDate(data.albumCount, data.pictureCount, data.face, data.nickname, data.localkey);
						if (data.userInfo.agreeLicence == 0) {
							new serviceView();
						} else {
							cNative.setLoginUser(nativeUserInfo, function(jdata) {
								if (jdata.error == 200) {
									//重新渲染登录成功后的页面 change by zhangzhi
									window.location.reload();
								}
							})
						}
					} else {
						notification.loading(false, '', true);
						notification.bubble(lang.bindFailed, 3);
					}
				})
			}

		},
		buildnew: function() {
			notification.loading(true, '', true);
			var sitecode = this.model.get('siteCode'),
				thirdid = this.model.get('thirdId');
			server.createSnsUser({
				siteCode: sitecode,
				thirdId: thirdid
			}, function(resp) {
				if (resp.status == 200) {
					notification.loading(false, '', true);
					nativeUserInfo.email = resp.data.userInfo.email;
					nativeUserInfo.uid = resp.data.userInfo.userId;
					nativeUserInfo.pwd = resp.data.userInfo.localkey;
					nativeUserInfo.data = resp.data.userInfo;
					pagemodelSetDate(resp.data.albumCount, resp.data.pictureCount, resp.data.face, resp.data.nickname, resp.data.localkey);
					if (resp.data.userInfo.agreeLicence == 0) {
						new serviceView();
					} else {
						cNative.setLoginUser(nativeUserInfo, function(data) {
							if (data.error == 200) {
								window.location.reload();
							}
						})
					}
				} else {
					notification.loading(false, '', true);
					notification.bubble(lang.createUserFailed, 2);
				}
			})
		}

	})

	/*服务条款页面*/
	var serviceView = Backbone.View.extend({
		className: 'servicePage',
		events: {
			'tap .agreebtn': 'enterIndex',
			'tap .disagreebtn': 'reLogin',
			'tap .termText': 'openServiceTerms'
		},
		template: _.template($('#service-template').html()),
		initialize: function() {
			$('.servicePage')[0] ? $('.servicePage').html() : $('body').append(this.$el);
			$('body').append(this.$el);
			this.$el.attr({
				'data': 'page'
			});
			this.render();
		},
		render: function() {
			$('[data="page"]').hide();
			this.$el.show();
			this.renderTopshow();
			this.renderContent();
		},
		renderTopshow: function() {
			var model = userModel;
			var topview = new showTopView({
				model: model
			}, this.$el);
		},
		renderContent: function() {
			var htm = this.template();
			this.$el.append(htm);
		},
		openServiceTerms: function() {
			utils.gotoPage('term.html', true);
		},
		//同意条款
		enterIndex: function() {
			notification.loading(true, '', true);
			server.updateUserInfo({
				agreeLicence: 1,
				localkey: nativeUserInfo.data.localkey
			}, function(resp) {
				notification.loading(false, '', true);
				if (resp.status == 200) {
					nativeUserInfo.data.agreeLicence = 1;
					cNative.setLoginUser(nativeUserInfo, function(data) {
						if (data.error == 200) {
							//重新渲染登录后的页面 change by zhangzhi
							location.reload();
						}
					});
				}
			})
		},
		//不同意条款
		reLogin: function() {
			notification.loading(true, '', true);
			server.updateUserInfo({
				agreeLicence: 0,
				localkey: nativeUserInfo.data.localkey
			}, function(resp) {
				if (resp.status == 200) {
					notification.loading(false, '', true);
					location.reload();
				} else {
					notification.loading(false, '', true);
				}
			});
		}
	})

	var bindEmailMoel = Backbone.Model.extend({});

	/*绑定页面 包括顶部信息显示view(topshowview)，邮箱绑定显示view (bindEmailview)   */
	var bindPageView = Backbone.View.extend({
		className: 'bindpage-container',
		initialize: function() {
			$('.bindpage-container')[0] ? $('.bindpage-container').html() : $('body').html(this.$el);
			$('body').append(this.$el);
			this.$el.attr({
				'data': 'page'
			});
			this.render();
		},
		render: function() {
			this.$el.siblings().hide();
			this.$el.show();
			this.renderTopshow();
			this.renderBindemail();
			this.adjustSize();
		},
		//渲染顶部图片
		renderTopshow: function() {
			var model = userModel;
			var topview = new showTopView({
				model: model
			}, this.$el);
		},
		//渲染绑定邮箱区域
		renderBindemail: function() {
			var bindemailmodel = new bindEmailMoel();
			bindemailmodel.set({
				bindemail: obj.userInfo.email,
				siteCode: obj.thirdInfo.name,
				thirdId: obj.thirdInfo.uid
			});
			var bindview = new bindEmailView({
				model: bindemailmodel
			});
			this.$el.append(bindview.el);
		},
		adjustSize: function() {
			var h = document.documentElement.clientHeight || document.body.clientHeight;
			$('.bindpage-container').height(h);
		}

	});


		function pagemodelSetDate(albumCount, pictureCount, face, nickname, localkey) {
			if (!face) {
				face = "images/userbig.png";
			} else {
				face = 'http://dn-c360.qbox.me/' + face + '-95';
			}
			userModel.set({
				'albumCount': albumCount,
				'pictureCount': pictureCount,
				'face': face,
				'nickName': nickname,
				'localkey': localkey
			})
		}

	var userModel = new UserModel();

	var loginView = new LoginView();
	//alert(window.screen.height);

	$('.loginwrap').css({
		'top': window.screen.height - 130
	});//解决IOS7下在登录界面2使用邮箱登录后回到HOME页面，导致底部信息看不到的问题（IOS7键盘导致）

	/****************
体系结构
{
	pageview:整个登录页面view{
		AdView：广告图片view
		circle：切换圆圈
		LoginView： Email,SNS登录登录页面view{
				
		}
		serviceview: 服务条款view
		bindPageView: 绑定页面view{
			topshowview: 顶部信息展示区域，
			bindEmailView： 绑定邮箱区域VIEW
		}
	}
}
*************/


})