define(function(require, exports, module) {
	var showTopView = require('page/loginweb/topshow/index');
	var notification = require('common/Notification.js'),
		util = utils,
		md5 = require('common/md5.js'),
		server = c360.server,
		targetPage = null;
	if (window.location.href.indexOf('?page=') >= 0) {
		targetPage = window.location.href.split('?page=')[1].split('&')[0];
	}
	require('ui/dialog/alert/alert');
	//sns授权取得的数据。
	var obj = {
		'isTrue': '',
		'login': '',
		'userInfo': '',
		'thirdInfo': '',
		'bindUserIdUrl': ''
	};
	//转码

	function decode(newurl) {
		var urlArr = newurl.split('?')[1].split('&');
		for (var i = 0, l = urlArr.length; i < l; i++) {
			var val = urlArr[i].split('=');
			obj[val[0]] = val[1];
		}
		if (obj.isTrue == 1) {
			obj.userInfo = $.parseJSON(decodeURIComponent((obj.userInfo + '').replace(/\+/g, '%20')));
			obj.thirdInfo = $.parseJSON(decodeURIComponent((obj.thirdInfo + '').replace(/\+/g, '%20')));
			obj.bindUserIdUrl = decodeURIComponent((obj.bindUserIdUrl + '').replace(/\+/g, '%20'));
			//obj.isTrue = obj.isTrue,
			//obj.login = obj.login;		
		}
		utils.log('sns login data decode\t ', obj);
	}
	var nativeUserInfo = {
		email: '',
		uid: '',
		pwd: '',
		expire: 82000,
		data: ''
	};
	var width = document.documentElement.clientWidth || document.documentElement.clientHeight;
	//多语言图片引用处理
	var adlist;
		
	if (lang.language == 'zh_CN') {
		adlist = ['images/ad/b1.jpg', 'images/ad/b2.jpg', 'images/ad/b3.jpg', 'images/ad/b4.jpg'];
	} else if(lang.language == 'zh_TW') {
		adlist = ['images/ad/b1_tw.jpg', 'images/ad/b2_tw.jpg', 'images/ad/b3_tw.jpg', 'images/ad/b4_tw.jpg'];
	}else{
		adlist = ['images/ad/b1_en.jpg', 'images/ad/b2_en.jpg', 'images/ad/b3_en.jpg', 'images/ad/b4_en.jpg'];
	}

	//检测邮箱或者密码格式
	var check = {
		checkEmail: function(email) {
			if (email.length == 0) {
				return {
					message: lang.haveNoEmail,
					flag: 0
				};
			}
			if (util.checkEmail(email)) {
				return {
					message: '',
					flag: 1
				};
			} else return {
				message: lang.falseFormatEmail,
				flag: 0
			};
		},
		checkPass: function(pass) {
			if (pass.length == 0) {
				return {
					message: lang.haveNoPassword,
					flag: 0
				};
			}
			if (pass.length < 6 || pass.length > 20) {
				return {
					message: lang.passwordLimit,
					flag: 0
				};
			} else return {
				message: '',
				flag: 1
			};
		}
	}

	//渲染图片的model
	var AdModel = Backbone.Model.extend({

	})
	//渲染图片的view
	var AdView = Backbone.View.extend({
		className: 'imgWrap',
		template: _.template($('#ad-show-template').html()),
		initialize: function() {
			this.render();
		},
		render: function() {
			var htm = this.template(this.model.toJSON());
			this.$el.html(htm);
			this.$el.width(width);
			$('.adcontainer').append(this.$el);
		}

	})

	//图片切换的小圆圈
	var circle = function() {
		this.options = arguments[0];
		this.initialize();
	}
	circle.prototype = {
		initialize: function() {
			this.createdom();
			this.show();
		},
		createdom: function() {
			var num = this.options.nums,
				uldom = $('<ul></ul>');
			for (var i = 0; i < num; i++) {
				var lidom = $('<li></li>');
				uldom.append(lidom);
			}
			var left = width / 2 - (num * 10);
			this.uldom = uldom;
		},
		show: function(date) {
			this.uldom.find('li').removeClass('red');
			this.uldom.find('li').eq(date).addClass('red');
		}
	}

	/*邮箱登陆model*/
	var loginEmailModel = Backbone.Model.extend({
		initialize: function() {},
		vilidate: function(e, p) {
			var self = this;
			if (!check.checkEmail(e).flag) {
				notification.bubble(check.checkEmail(e).message, 2);
			} else if (!check.checkPass(p).flag) {
				notification.bubble(check.checkPass(p).message, 2);
			} else {
				p = md5(md5(p));
				this.set({
					email: e,
					pass: p
				});
				notification.loading(true, lang.waitLoginText, true);
				this.getJson();
			}
		},
		getJson: function() {
			var server = c360.server,
				self = this,
				email = self.get('email'),
				pass = self.get('pass');
			server.login({
				email: email,
				password: pass
			}, function(resp) {
				if (resp.status == 200) {
					nativeUserInfo = {
						email: resp.data.email,
						uid: resp.data.userId,
						pwd: resp.data.localkey,
						expire: 82000,
						data: resp.data
					};
					//没有同意过服务条款
					pagemodelSetDate(resp.data.albumCount, resp.data.pictureCount, resp.data.face, resp.data.nickname, resp.data.localkey);
					if (resp.data.agreeLicence == 0) {
						notification.loading(false, '', true);
						new serviceView();
					}
					//判断已经同意过服务条款	
					else {
						cNative.setLoginUser(nativeUserInfo, function(data) {
							if (data.error === 200) {
								notification.loading(false, '', true);
								if (targetPage) {
									window.location.href = targetPage + '?t=' + new Date().getTime();
								} else {
									window.cNative.gotoNativeView({
										viewId: 'returnLastView',
										from: ''
									});
								}
							}
						});
					}

				} else {
					self.set({
						email: '',
						password: ''
					});
					notification.loading(false, '', true);
					notification.bubble(resp.message, 2);
				}
			});
		}
	});

	/*首页email，sns登陆区域view*/
	var LoginView = Backbone.View.extend({
		el: $(".loginwrap"),
		sw: 1,
		template_cn: _.template($('#login-cn-template').html()),
		template_us: _.template($('#login-us-template').html()),
		events: {
			'tap .resetPassword': 'findPass',
			"singletap #email": 'showEmail',
			"singletap .more": 'showMore',
			"singletap #slideleft": 'showSns',
			"singletap #slideright": 'showSns',
			"singletap #login": 'emailLogin',
			"singletap .sinabtn": 'sinaLogin',
			"singletap .qzonebtn": 'qzoneLogin',
			"singletap .facebookbtn": 'facebookLogin',
			"singletap .twitterbtn": 'twitterLogin'
		},
		initialize: function() {
			var w = this.w = $('.loginwrap').width();
			this.model = new loginEmailModel();
			this.render();
			if(targetPage && targetPage == 'home.html'){
				this.showEmail();
			}
		},

		findPass: function() {
			utils.gotoPage('findPassword.html', true);
		},
		showEmail: function() {
			this.moveto(-1);
		},
		showMore: function() {
			this.moveto(1);
		},
		showSns: function() {
			this.moveto(0);
		},
		emailLogin: function() {
			var email = $.trim($('.username').val()),
				pass = $.trim($('.password').val());
			this.model.vilidate(email, pass);
		},
		moveto: function() {
			var w = this.w,
				dom = $('.content');
			switch (arguments[0]) {
				case -1:
					dom.css({
						left: 0 + 'px'
					});
					this.sw = 0;
					this.selectspan();
					break;
				case 1:
					dom.css({
						left: -2 * w + 'px'
					});
					this.sw = 2;
					this.selectspan();
					break;
				case 0:
					dom.css({
						left: -w + 'px'
					});
					this.sw = 1;
					this.selectspan();
					break;
				default:
					break;
			}
		},
		render: function() {
			var html = this.template_cn(),
				self = this;
			if (lang.language == 'zh_CN' || lang.language == 'zh_TW') {
				html = self.template_cn();
			} else {
				html = self.template_us();
			}
			var w = self.w;
			$('.content').html(html);

			window.cNative.getLoginUser(function(resp) {
				self.localEmail = resp.email;
				if (resp.email && resp.email.length > 0) {
					$('.emailLogin').find('.username').val(resp.email);
				}
			});

			$('.second').css({
				'width': w + 'px'
			});
			$('.first').css({
				'width': w + 'px'
			});
			$('.third').css({
				'width': w + 'px'
			});
			$('.content').css({
				'left': -w + 'px'
			});
			self.selectspan();
		},
		selectspan: function(thenum) {
			//输入框长度
			$('.emailLogin input').width($('.topo').width() - 60);
			var doms = $('.tipwrap span'),
				num = thenum ? thenum : this.sw;
			doms.removeClass('selectspan');
			doms.eq(num).addClass('selectspan');
		},
		sinaLogin: function() {
			var _this = this;
			notification.loading(true);
			window.cNative.ssoLogin({
				keepCallback: true
			}, function(data) {
				notification.loading(false);
				window.cNative.removeAllKeepedCallBack();
				if (data.error == 200) {
					obj = data.data.data;
					_this.loginComplete();
				} else {
					_this.getSNS('sina');
				}
			});
		},
		qzoneLogin: function() {
			this.getSNS('qzone');
		},
		facebookLogin: function() {
			this.getSNS('facebook');
		},
		twitterLogin: function() {
			this.getSNS('twitter');
		},
		getSNS: function(sitecode) {
			var that = this,
				language = window.cNative.lang,
				url = $.serverIp + '/sns/login/index?' + 'siteCode=' + sitecode + '&source=mobile&lang=' + language + '&redirect=1&localEmail=' + that.localEmail;
			this.browser = util.openWin(url, 'callResult', that.loginProcess);
		},
		loginProcess: function(url) {
			decode(url);
			pageview.footerView.loginComplete();
		},

		loginComplete: function() {
			var _this = this;
			if (obj.isTrue == 1) {
				nativeUserInfo = {
					email: obj.userInfo.email,
					uid: obj.userInfo.userId,
					pwd: obj.userInfo.localkey,
					expire: 82000,
					data: obj.userInfo
				};
				pagemodelSetDate(obj.userInfo.albumCount, obj.userInfo.pictureCount, obj.userInfo.face, obj.userInfo.nickname, obj.userInfo.localkey);
				if (obj.login == 1) {
					if (obj.userInfo.agreeLicence == 0) {
						new serviceView();
						//new bindPageView();
					} else {
						window.cNative.setLoginUser(nativeUserInfo, function(data) {
							if (data.error == 200) {
								if (targetPage) {
									window.location.href = targetPage + '?t=' + new Date().getTime();
								} else {
									window.cNative.gotoNativeView({
										viewId: 'returnLastView',
										from: ''
									});
								}
							}
						});
					}
				}
				if (obj.login == 0) {
					new bindPageView();
				}
			} else {
				//notification.bubble(lang.authorizationFailed, 2);
			}
			notification.loading(false);
		}

	})


	var bindEmailMoel = Backbone.Model.extend({});

	/*sns登录以后，绑定邮箱VIEW*/
	var bindEmailView = Backbone.View.extend({
		className: 'bindemailwrap',
		events: {
			'tap .bind': 'bind',
			'tap .buildnew': 'buildnew',
			'focus .pass': 'slideUp',
			'blur .pass': 'slideDown'
		},
		template: _.template($('#bind-email-template').html()),
		initialize: function() {
			this.render();
		},
		render: function() {
			var htm = this.template(this.model.toJSON());
			this.$el.html(htm);
		},
		slideUp: function() {
			if (navigator.userAgent.toLowerCase().match(/android/)) {
				$('.bindpage-container').animate({
					marginTop: -$('.showtopwrap').height()
				}, 300);
			}
		},
		slideDown: function() {
			if (navigator.userAgent.toLowerCase().match(/android/)) {
				$('.bindpage-container').animate({
					marginTop: 0
				}, 300);
			}
		},
		bind: function() {
			notification.loading(true, '', true);
			var password = $.trim($('.pass').val());
			if (!check.checkPass(password).flag) {
				notification.loading(false, '', true);
				notification.bubble(check.checkPass(password).message, 2);
			} else {
				password = md5(md5(password));
				var email = this.model.get('bindemail'),
					sitecode = this.model.get('siteCode'),
					thirdid = this.model.get('thirdId');
				server.snsbindAccount({
					username: email,
					password: password,
					siteCode: sitecode,
					thirdId: thirdid
				}, function(resp) {
					var data = resp.data;
					if (resp.status == 200) {
						notification.loading(false, '', true);
						nativeUserInfo.email = data.userInfo.email;
						nativeUserInfo.uid = data.userInfo.userId;
						nativeUserInfo.pwd = data.userInfo.localkey;
						nativeUserInfo.data = data.userInfo;
						pagemodelSetDate(data.albumCount, data.pictureCount, data.face, data.nickname, data.localkey);
						if (data.userInfo.agreeLicence == 0) {
							new serviceView();
						} else {
							cNative.setLoginUser(nativeUserInfo, function(jdata) {
								if (jdata.error == 200) {
									if (targetPage) {
										window.location.href = targetPage + '?t=' + new Date().getTime();
									} else {
										window.cNative.gotoNativeView({
											viewId: 'returnLastView',
											from: ''
										});
									}
								}
							})
						}
					} else {
						notification.loading(false, '', true);
						notification.bubble(lang.bindFailed, 3);
					}
				})
			}

		},
		buildnew: function() {
			notification.loading(true, '', true);
			var sitecode = this.model.get('siteCode'),
				thirdid = this.model.get('thirdId');
			server.createSnsUser({
				siteCode: sitecode,
				thirdId: thirdid
			}, function(resp) {
				if (resp.status == 200) {
					notification.loading(false, '', true);
					nativeUserInfo.email = resp.data.userInfo.email;
					nativeUserInfo.uid = resp.data.userInfo.userId;
					nativeUserInfo.pwd = resp.data.userInfo.localkey;
					nativeUserInfo.data = resp.data.userInfo;
					pagemodelSetDate(resp.data.albumCount, resp.data.pictureCount, resp.data.face, resp.data.nickname, resp.data.localkey);
					if (resp.data.userInfo.agreeLicence == 0) {
						new serviceView();
					} else {
						cNative.setLoginUser(nativeUserInfo, function(data) {
							if (data.error == 200) {
								if (targetPage) {
									window.location.href = targetPage + '?t=' + new Date().getTime();
								} else {
									window.cNative.gotoNativeView({
										viewId: 'returnLastView',
										from: ''
									});
								}
							}
						})
					}
				} else {
					notification.loading(false, '', true);
					notification.bubble(lang.createUserFailed, 2);
				}
			})
		}

	})

	/*服务条款页面*/
	var serviceView = Backbone.View.extend({
		className: 'servicePage',
		events: {
			'tap .agreebtn': 'enterIndex',
			'tap .disagreebtn': 'reLogin',
			'tap .termText': 'openServiceTerms'
		},
		template: _.template($('#service-template').html()),
		initialize: function() {
			$('.servicePage')[0] ? $('.servicePage').html() : $('body').append(this.$el);
			$('body').append(this.$el);
			this.$el.attr({
				'data': 'page'
			});
			this.render();
		},
		render: function() {
			$('[data="page"]').hide();
			this.$el.show();
			this.renderTopshow();
			this.renderContent();
		},
		renderTopshow: function() {
			var model = pagemodel;
			var topview = new showTopView({
				model: model
			}, this.$el);
		},
		renderContent: function() {
			var htm = this.template();
			this.$el.append(htm);
		},
		openServiceTerms: function() {
			utils.gotoPage('term.html', true);
		},
		//同意条款
		enterIndex: function() {
			notification.loading(true, '', true);
			server.updateUserInfo({
				agreeLicence: 1,
				localkey: nativeUserInfo.data.localkey
			}, function(resp) {
				if (resp.status == 200) {
					notification.loading(false, '', true);
					nativeUserInfo.data.agreeLicence = 1;
					cNative.setLoginUser(nativeUserInfo, function(data) {
						if (data.error == 200) {
							if (targetPage) {
								window.location.href = targetPage + '?t=' + new Date().getTime();
							} else {
								window.cNative.gotoNativeView({
									viewId: 'returnLastView',
									from: ''
								});
							}
						}
					});
				} else {
					notification.loading(false, '', true);
				}
			})
		},
		//不同意条款
		reLogin: function() {
			notification.loading(true, '', true);
			server.updateUserInfo({
				agreeLicence: 0,
				localkey: nativeUserInfo.data.localkey
			}, function(resp) {
				if (resp.status == 200) {
					notification.loading(false, '', true);
					location.reload();
				} else {
					notification.loading(false, '', true);
				}
			});
		}
	})

	/*绑定页面 包括顶部信息显示view(topshowview)，邮箱绑定显示view (bindEmailview)   */
	var bindPageView = Backbone.View.extend({
		className: 'bindpage-container',
		initialize: function() {
			$('.bindpage-container')[0] ? $('.bindpage-container').html() : $('body').html(this.$el);
			$('body').append(this.$el);
			this.$el.attr({
				'data': 'page'
			});
			this.render();
		},
		render: function() {
			this.$el.siblings().hide();
			this.$el.show();
			this.renderTopshow();
			this.renderBindemail();
			this.adjustSize();
		},
		//渲染顶部图片
		renderTopshow: function() {
			var model = pagemodel;
			var topview = new showTopView({
				model: model
			}, this.$el);
		},
		//渲染绑定邮箱区域
		renderBindemail: function() {
			var bindemailmodel = new bindEmailMoel();
			bindemailmodel.set({
				bindemail: obj.userInfo.email,
				siteCode: obj.thirdInfo.name,
				thirdId: obj.thirdInfo.uid
			});
			var bindview = new bindEmailView({
				model: bindemailmodel
			});
			this.$el.append(bindview.el);
		},
		adjustSize: function() {
			var h = document.documentElement.clientHeight || document.body.clientHeight;
			$('.bindpage-container').height(h);
		}

	})


	/**/
	var PageModel = Backbone.Model.extend({
		initialize: function() {
			this.set({
				'albumCount': '',
				'pictureCount': '',
				'face': '',
				'nickName': '',
				'localkey': ''
			});
		}
	})

	var PageView = Backbone.View.extend({
		el: $('body'),
		imgsLength: adlist.length,
		wid: width,
		//当前显示的是第几张图片，默认从第0张开始计数
		theImg: 0,
		movelevelflag: 1,
		adviewArr: [],
		initialize: function() {
			this.hasLogin();
			this.render();
			this.setImgTimer();
		},
		events: {
			'downtap .adone': 'cancelTimer',
			'movetap .adone': 'preventdefault',
			'cross	.adone': 'imgLevelMove',
			'uptap .adone': 'upTap',
			'tap .returnpanel': 'doReturn',
			'mousedown .username': 'upInputLoc',
			'mousedown .password': 'upInputLoc',
			'blur .username': 'downInputLoc',
			'blur .password': 'downInputLoc',
			'downtap .bindpage': 'preventdefault',
			'movetap .bindpage': 'preventdefault',
			'cross .bindpage': 'verticalMove',
			'uptap .bindpage': 'setverticalLoc'
		},
		setImgTimer: function() {
			var self = this;
			this.imgTimer = setInterval(function() {
				self.imgAutoMove('left');
			}, 4000);
		},
		cancelTimer: function(event, e) {
			clearInterval(this.imgTimer);
			this.preventdefault(event, e);
		},
		preventdefault: function(event, e) {
			e.preventDefault();
		},
		verticalLoc: 0,
		verticalMove: function(event, data) {
			var target = $('.bindpage'),
				h0 = this.verticalLoc;
			var pos = {};
			pos.marginTop = data.clientY + h0 + 'px';
			target.animate(pos, 0);
		},
		setverticalLoc: function(event, e) {
			e.preventDefault();
			this.verticalLoc = parseInt($('.bindpage').css('marginTop') + '');
		},
		upInputLoc: function() {
			if (navigator.userAgent.toLowerCase().match(/android/) || navigator.userAgent.toLowerCase().indexOf('os 7') >=0) {
				$('#indexpage').animate({
					'marginTop': -$('.adone').height() + 30
				}, 300);
			}
		},
		downInputLoc: function() {
			if (navigator.userAgent.toLowerCase().match(/android/) || navigator.userAgent.toLowerCase().indexOf('os 7') >=0) {
				$('#indexpage').animate({
					'marginTop': 0
				}, 300);
			}
		},
		distanceVertical: 0,
		imgLevelMove: function(event, data) {
			if (this.movelevelflag == 1) {
				var target = $('.adcontainer'),
					width = this.wid,
					w = this.wid / 2;
				var pos = {};
				var distanceX = data.clientX - width;
				this.clientX = data.clientX;
				pos.left = distanceX + 'px';
				target.animate(pos, 0);
			}
		},
		/************
		 * 滑动结束后，数据初始化。
		 ***************/
		regress: function() {
			cir.show(this.theImg);
			this.clientX = 0;
			this.movelevelflag = 1;
		},
		/**********************************************
		 * @actionName  判断向左或者向右运动
		 * *******************************************/
		upTap: function(event, e) {
			e.preventDefault();
			this.setImgTimer();
			if (this.movelevelflag == 1) {
				this.movelevelflag = 0;
				var self = this;
				var clientx = this.clientX;
				if (clientx > 0) {
					if (clientx > (width / 5)) {
						self.imgAutoMove('right');
					} else {
						self.imgAutoMove('back');
					}
				}
				if (clientx < 0) {
					if (Math.abs(clientx) > (width / 5)) {
						self.imgAutoMove('left');
					} else {
						self.imgAutoMove('back');
					}
				}

			}
		},
		/**********************************************
		 * @actionName  图片运动类型方式。
		 * *******************************************/
		imgAutoMove: function(dir) {
			var self = this,
				theimg = this.theImg,
				width = this.wid,
				target = $('.adcontainer'),
				adviewarr = this.adviewArr;
			var pos = {}, num;
			if (dir == 'back') {
				pos.left = -width + 'px';
				target.animate(pos, 300, 'linear', function() {
					self.regress();
				});
			}
			if (dir == 'right') {
				pos.left = '0px';
				target.animate(pos, 300, 'linear', function() {
					var num = theimg <= 0 ? adviewarr.length - 1 : theimg - 1;
					self.theImg = num;
					var a = $('.adcontainer .imgWrap:last-child').clone();
					$('.adcontainer .imgWrap:last-child').remove();
					$('.adcontainer').prepend(a[0]);
					$('.adcontainer').css({
						left: -width
					});
					self.regress();
				});
			}
			if (dir == 'left') {
				pos.left = -2 * width + 'px';
				target.animate(pos, 300, 'linear', function() {
					var num = theimg >= adviewarr.length - 1 ? 0 : theimg + 1;
					self.theImg = num;
					var a = $('.adcontainer .imgWrap:first-child').clone();
					$('.adcontainer .imgWrap:first-child').remove();
					$('.adcontainer').append(a[0]);
					$('.adcontainer').css({
						left: -width
					});
					self.regress();
				})
			}
		},
		render: function() {
			this.renderAd();
			this.renderCircle();
			this.renderFooter();
		},
		//渲染页面顶部图片
		renderAd: function() {
			var adviewarr = this.adviewArr;
			var width = document.documentElement.clientWidth || document.body.clientWidth,
				height = document.documentElement.clientHeight || document.body.clientHeight;
			var wid = width > 640 ? 640 : width;
			var h0 = (580 / 640) * wid;
			var h1 = height - 240 > h0 ? h0 : height - 240;
			var h2 = height - 240 > h0 ? 0 : height - 240 - h0;
			$('.adone').css({
				height: h1
			});

			for (var i = 0; i < adlist.length; i++) {
				var model = new AdModel({
					imgurl: adlist[i]
				});
				var imgview = new AdView({
					model: model
				});
				imgview.$el.css({
					'marginTop': h2
				});
				adviewarr.push(imgview);
			}
			$('.adcontainer imgWrap:last-child').remove();
			$('.adcontainer').prepend(adviewarr[adviewarr.length - 1].$el).css({
				left: -width
			});
			//	$('.adcontainer').append(adviewarr[adviewarr.length-1].$el).append(adviewarr[0].$el).append(adviewarr[1].$el).css({left:-width});	
		},
		//渲染切换小圆形
		renderCircle: function() {
			cir = new circle({
				nums: 4
			});
			cir.show(0);
			$('.circlewrap').append(cir.uldom);
		},
		//渲染登录部分
		renderFooter: function() {
			var footerView = this.footerView = new LoginView();
			$('.indexpage').append(footerView.el);
		},
		doReturn: function() {
			if(targetPage && targetPage == 'home.html'){
				window.location.href = targetPage+'?v='+new Date().getTime();
			}else{
				cNative.gotoNativeView({
					viewId: 'returnLastView',
					from: ''
				});
			}
		},
		hasLogin: function() {
			var self = this;
			cNative.getLoginUser(function(data) {
				if (data.error == 200 && data.pwd && data.uid != '') {
					utils.gotoPage('index.html');
				} else if (data.uid == '') {
					window.cNative.setLoginUser({
						email: '',
						uid: '',
						pwd: '',
						expire: 0
					}, function(data) {
						if (window.localStorage) {
							window.localStorage.setItem('database.isCreated', 'false');
						}
						/*window.cNative.gotoNativeView({
							viewId: 'cloudHomeView'
						});*/
					});
				}

			})
		},
		show: function() {
			$('[data=page]').hide();
			$('.indexpage').show();
		}
	})


		function pagemodelSetDate(albumCount, pictureCount, face, nickname, localkey) {
			if (!face) {
				face = "images/userbig.png";
			} else {
				face = 'http://dn-c360.qbox.me/' + face + '-95';
			}
			pagemodel.set({
				'albumCount': albumCount,
				'pictureCount': pictureCount,
				'face': face,
				'nickName': nickname,
				'localkey': localkey
			})
		}
	var pagemodel = new PageModel();
	var pageview = new PageView();



	/****************
体系结构
{
	pageview:整个登录页面view{
		AdView：广告图片view
		circle：切换圆圈
		LoginView： Email,SNS登录登录页面view{
				
		}
		serviceview: 服务条款view
		bindPageView: 绑定页面view{
			topshowview: 顶部信息展示区域，
			bindEmailView： 绑定邮箱区域VIEW
		}
	}
}
*************/


})