define(function(require, exports, module) {

	var CONSTANT = c360.constant.photo, //定义页面常量类

		DetailView = Backbone.View.extend({

			el:document.getElementById('photoDetail'),

			template:_.template($('#photo-detail-template').html()),

			/**********************************************
			 * @actionName	初始化页面.
			 *********************************************/
			initialize: function() {

				var count = utils.getQuery('count');

				this.model = new Backbone.Model({
					count:count,
					total:count,
					name:utils.getQuery('name'),
					index:0
				});

				this.model.on('change:index',this.setPage,this);
				this.model.on('change:count',this.setPage,this);
				this.model.on('change:name',this.setName,this);

				this.render();
			},

			/**********************************************
			 * @actionName  初始化照片的DOM
			 * *******************************************/
			initDom:function(){
				this.$photoNumDom = this.$('.photo-num');
				this.$photoNameDom = this.$('.photo-name');
			},

			/**********************************************
			 * @actionName  设置照片的名称
		     * @param model object 表示照片的model
			 * *******************************************/
			setName:function(model){
				this.$photoNameDom.text(model.get('name'));
			},

			/**********************************************
			 * @actionName  设置照片的页码
		     * @param model object 表示照片的model
			 * *******************************************/
			setPage:function(model){
				if(c360.container.photo.model.get('hasAudio') == 1){
					this.$el.addClass(CONSTANT.ACTIVE);
				}else{
					this.$el.removeClass(CONSTANT.ACTIVE);
				}
				this.$photoNumDom.text(model.get('index')+'/'+model.get('count'));
			},

			/**********************************************
			 * @actionName  渲染照片详情模块
			 * *******************************************/
			render:function(){
				this.$el.append(this.template(this.model.toJSON()));
				this.initDom();
			}
		});

	return DetailView;

});