define(function(require, exports, module) {

	require('common/download');

	require('ui/share/main');

	var alertDialog = require('ui/dialog/alert/alert'),

		CONSTANT = c360.constant.photo, //定义页面常量类

		FooterView = Backbone.View.extend({

			el:document.getElementById('photoFooter'),

			template:_.template($('#photo-footer-template').html()),

			/**********************************************
			 * @actionName	初始化页面.
			 *********************************************/
			initialize: function() {
				this.$el.append(this.template({
					share:lang.share,
					download:lang.download,
					deletes:lang.deletes
				}));
			},

			/**********************************************
			 * @actionName	定义页面事件.
			 *********************************************/
			events:{
				'tap .photo-share':'share',
				'tap .photo-download':'download',
				'tap .photo-delete':'deletes'
			},

			/**********************************************
			 * @actionName  分享功能.
			 * @param event object 表示事件event
			 ********************************************/
			share: function(event) {

				// 屏蔽快速点击情况
				if(c360.page.photo.$el.hasClass(CONSTANT.DISABLED)) return;

				c360.page.photo.$el.addClass(CONSTANT.DISABLED);

				var timer = setTimeout(function(){
						clearTimeout(timer);
						c360.page.photo.$el.removeClass(CONSTANT.DISABLED);
					},500),

					photo = c360.container.photo,

					model = photo.model;

				photo.releaseAudio(false,false);

				c360.storage.set("shareData",{
					pids:[model.get('id')],
					photos:[{
						key:model.get('key'),
						hasAudio:model.get('hasAudio'),
						w:model.get('w'),
						h:model.get('h')
					}],
					name:utils.getQuery('name'),
					aids:[],
					url:location.href
				});

				c360.share.main.share();
			},

			/**********************************************
			 * @actionName  下载功能.
			 * @param event object 表示事件event
			 ********************************************/
			download:function(event){
				
				// 屏蔽快速点击情况
				if(c360.page.photo.$el.hasClass(CONSTANT.DISABLED)) return;

				c360.page.photo.$el.addClass(CONSTANT.DISABLED);

				var timer = setTimeout(function(){
						clearTimeout(timer);
						c360.page.photo.$el.removeClass(CONSTANT.DISABLED);
					},500),

					photo = c360.container.photo,

					model = photo.model;

				photo.releaseAudio(false,false);

				c360.downloadPhoto.showDownLoadDialog([model.get('key')]);
				
				// alertDialog.render({
				// 	title:lang.downLoadTipTitle,
				// 	content:lang.downLoadTipContent,
				// 	certain:lang.iKnow
				// },function(){
				// 	c360.page.photo.$el.removeClass(CONSTANT.DISABLED);
				// 	this.close();
				// },function(){
				// 	c360.page.photo.$el.removeClass(CONSTANT.DISABLED);
				// });
			},

			/**********************************************
			 * @actionName  删除功能.
			 * @param event object 表示事件event
			 ********************************************/
			deletes:function(event){
				
				// 屏蔽快速点击情况
				if(c360.page.photo.$el.hasClass(CONSTANT.DISABLED)) return;

				c360.page.photo.$el.addClass(CONSTANT.DISABLED);

				var photo = c360.container.photo,

					collection = photo.collection,
					
					model = photo.model;

				photo.releaseAudio(false,false);

				notification.loading(true,lang.deleting);

				c360.server.deletes([model.get('id')],function(json){
					notification.loading(false,lang.deleting);
					if(json.status == 200){
						notification.bubble(lang.deleteTips);
						collection.remove(model);
					}else{
						notification.bubble(json.message);
						c360.page.photo.$el.removeClass(CONSTANT.DISABLED);
					}
				});

			}

		});

	return FooterView;

});