define(function(require, exports, module) {

	var CONSTANT = c360.constant.photo, //定义页面常量类

		HeaderView = Backbone.View.extend({

			el:document.getElementById('photoHeader'),

			template:_.template($('#photo-header-template').html()),

			/**********************************************
			 * @actionName	定义页面事件.
			 *********************************************/
			events:{
				'tap .photo-back':'back'
			},

			/**********************************************
			 * @actionName	初始化页面.
			 *********************************************/
			initialize: function() {
				this.render();
			},

			/**********************************************
			 * @actionName  返回页面功能.
			 * @param event object 表示事件event
			 ********************************************/
			back:function(event){

				var target = $(event.currentTarget);

				if(target.hasClass(CONSTANT.DISABLED)) return;

				target.addClass(CONSTANT.DISABLED);

				c360.page.photo.$el.addClass(CONSTANT.DISABLED);

				var timer = setTimeout(function(){
						clearTimeout(timer);
						target.removeClass(CONSTANT.DISABLED);
						c360.page.photo.$el.removeClass(CONSTANT.DISABLED);
					},500);

				c360.backButtonFn();
			},

			/**********************************************
			 * @actionName  渲染照片顶部模块.
			 ********************************************/
			render:function(){
				this.$el.append(this.template());
			}
		});

	return HeaderView;

});