define(function(require, exports, module) {
	$.ns('c360.page.photo','c360.cache.photo','c360.header.photo','c360.container.photo','c360.footer.photo','c360.backButtonFn');

	window.notification = require('common/Notification');

	require('page/photo/constant');

	require('common/sync');

	require('common/storage');

	require('route/backButton');

	c360.backButtonFn = function(){
		//关闭loading
        cNative.displayLoadingIcon({show:false,msg:"Loading",modal:false});
        //关闭dialog
        if(c360.dialog && c360.dialog.closed == false){
            c360.dialog.close();
            return;
        }

        if(c360.downloadPhoto && c360.downloadPhoto.isDownloading == true){window.cNative.stopDownlaod(function(){});};

        c360.container.photo.clear();

        // ios下会直接销毁webView,可能会造成性能低的机子会闪退
		setTimeout(function(){
			if(utils.isMobile) cNative.closeTopestView();
			else location.href = c360.storage.get("photoData").url;
		},0);
	}

	var HeaderView = require('page/photo/header'),

		ContainerView = require('page/photo/container'),

		DetailView = require('page/photo/detail'),

		AudioView = require('page/photo/audio'),

		Cache = require('page/photo/data'),

		FooterView = require('page/photo/footer');

	// 如果是IOS就加入加速硬件引擎
	if(utils.detect.ios){
		require.async('css/animate.css');
	}

	require('css/photo.css');

	c360.page.photo = new (Backbone.View.extend({

		el:document.getElementById('photoPage'),

		/**********************************************
		 * @actionName	初始化页面.
		 *********************************************/
		initialize:function(){
			this.initHeader();
			this.initContainer();
			this.initFooter();
		},

		/**********************************************
		 * @actionName	初始化顶部模块.
		 *********************************************/
		initHeader:function(){
			c360.header.photo = new HeaderView();
		},

		/**********************************************
		 * @actionName	初始化内容模块.
		 *********************************************/
		initContainer:function(){

			var photoData = c360.storage.get("photoData"),

				array = photoData.data,

				url = photoData.url,

				photo = c360.container.photo = new ContainerView(),

				cache = photo.cache = c360.cache.photo = new Cache(),

				aid = photo.aid,

				pid = photo.pid,

				index = utils.getQuery('countIndex'),

				count = utils.getQuery('count');

			photo.index = parseInt(index,10);

			photo.next = photoData.next;

			photo.pre = photoData.pre;

			cache.setData(aid,{
				next:photo.next,
				pre:photo.pre,
				name:utils.getQuery('name'),
				count:count,
				total:count
			});

			cache.setCollection(aid,array,'');

			photo.collection = cache.getCollection(aid);

			this.length = photo.collection.length;

			this.index = cache.getIndex(aid,pid);

			// 根据当前总条数动态创建照片模版
			if(this.length == 0){
				return;
			}else if(this.length == 1){
				this.createOnePhoto();
			}else if(this.length == 2){
				this.createTwoPhoto();
			}else{
				if(this.index == 0 || this.index == this.length - 1){
					this.createTwoPhoto();
				}else{
					this.createThreePhoto();
				}
			}

			photo.detail = new DetailView();

			photo.layout(this.index,'');

			photo.audio = new AudioView();
		},

		/**********************************************
		 * @actionName	初始化底部模块.
		 *********************************************/
		initFooter:function(){
			c360.footer.photo = new FooterView();
		},

		/**********************************************
		 * @actionName	创建一个照片.
		 *********************************************/
		createOnePhoto:function(){
			c360.container.photo.addPhoto(c360.container.photo.collection.at(0));
		},

		/**********************************************
		 * @actionName	创建二个照片.
		 *********************************************/
		createTwoPhoto:function(){
			var i = this.index,
				length = 2;

			if(i != 0){
				i = this.length - 2;
				length = this.length;
			}

			for(;i < length;i ++){
				c360.container.photo.addPhoto(c360.container.photo.collection.at(i));
			}
		},

		/**********************************************
		 * @actionName	创建三个照片.
		 *********************************************/
		createThreePhoto:function(){
			var i = this.index - 1,
				length = i + 3;

			for(i;i < length;i ++){
				c360.container.photo.addPhoto(c360.container.photo.collection.at(i));
			}
		}

	}));

});