define(function(require, exports, module) {

	require('../../skin/blue/skin.css');
	require('route/backButton'); //back键路由
	var winConfirm = require('ui/dialog/confirm/confirm.js');

	// c360.backButtonFn = function(){
	// 			cNative.gotoNativeView({viewId:'returnLastView',from:''});
	// 		};

	var uploadView = Backbone.View.extend({

		el: document.getElementById('uploadSettingPage'),

		template: _.template($('#upload-template').html()),

		events: {
			'tap .valve': 'changeStatus',
			'leftswipe .valve': 'changeStatus',
			'rightswipe .valve': 'changeStatus',
			'tap .uploadback': 'back',
			'tap .radioLi': 'changeRadio'
		},

		initialize: function() {
			var _this = this;
			this.model = new Backbone.Model();
			this.model.on('change', this.render, this);
			window.cNative.getUploadSetting(function(data) {
				if (data.error == 200) {
					_this.model.set(data);
				}
			});

			/*var obj = {
				valve: false,
				net: 'WIFI3G', //字符串, 可用值为:WIFI, 3G, 全大写.
				onlyCharging: true,
				count: 34,
				canUpload: false,
				error: 200,
				msg: 'ok'
			};

			 this.model.set(obj);*/
		},

		back: function() {
			window.cNative.closeTopestView();
		},

		changeStatus: function(event) {
			var _this = this;
			var id = event.target.id,
				status = $(event.target).attr('data-status');
			if ((status == 'false' && event.type == 'leftswipe') || (status == 'true' && event.type == 'rightswipe')) {
				return;
			}
			_this.doChange(id, status);
		},

		changeRadio: function(event) {
			var _this = this,
				radio = $(event.target).find('.radio').length == 1 ? $(event.target).find('.radio') : $(event.target),
				id = radio.attr('id'),
				status = radio.attr('data-status');

			if (id == 'wifi3g' && status == 'false') {
				winConfirm.render({
					title: lang.tips,
					content: lang.threegNotice,
					certain: lang.turnOn,
					cancel: lang.cancel
				}, function() {
					_this.model.set('net', 'WIFI3G');
					c360.statis.storageKey("uploadSetting_wifi3g_certain");
					this.close();
				}, function() {
					c360.statis.storageKey("uploadSetting_wifi3g_cancle");
					this.close();
				});
			}else if(id == 'wifi' && status == 'false'){
				this.model.set('net', 'WIFI');
			};

			/*if (id == 'wifi') {
				this.model.set('net', 'WIFI');
			} else {
				this.model.set('net', 'WIFI3G');
			}*/
		},

		doChange: function(id, status) {
			this.model.attributes[id] = status == 'true' ? false : true;
			this.model.trigger('change');
		},

		sendStatus: function(json) {
			window.cNative.setUploadSetting(this.model.attributes, function(data) {
				cNative.nativeViewDispatchEvent({
					event: "upLoadSwitchOpen",
					data: {
						open: data.canUpload
					}
				}, function(data) {});
			});
		},

		render: function(data) {
			this.sendStatus();
			this.$el.html(this.template(this.model.toJSON()));
		}
	});

	new uploadView();

});