/**
 * [ 瀑布流相关]
 * author by  goingta
 * date 2013-04-18
 */
define(function(require, exports, module) {

	require('ui/dialog/list/list.css');

	var listView = Backbone.View.extend({
		className:'listPanel',
		events:{
			'tap .mask':'hide'
		},
		initialize:function(model){

			if(this.templateHTML == ''){
				utils.log("listPanel templateHTML is null");
				return;
			}
			this.template = _.template('<div class="mask"><div class="content">'+this.templateHTML+'</div></div>');
			model = model ||{};
			this.model = new Backbone.Model(model);
			this.render();
			this.initEventListener();
		},
		initEventListener:function(){
			c360.events.on("activePanel",this.activePanel,this);
			c360.events.on("showListPanel",this.show,this);
			this.$el.on("touchmove",function(e){utils.stopBubble(e)});
		},
		render:function(){
			this.$el.html(this.template(this.model.toJSON()));
			$("body").append(this.el);
		},
		activePanel:function(json){
			this.show(json);
		},
		show:function(json){
			if(typeof json === "object"){
				this.model.set(json);
			}
			this.$el.addClass("active");
			var _this = this,
				timer = null;
			timer = setTimeout(function(){
				_this.$(".content").addClass("active");
				clearTimeout(timer);
			},0);
			//注册物理返回键,使用物理返回键可关闭listPanel
			c360.events.trigger("addBackHistory",{obj:this,fn:'hide'});
		},
		hide:function(evt){
			if(evt){
				if(!$(evt.target).hasClass("cancel") && !$(evt.target).hasClass("mask")){
					return;
				}
			}
			this.$(".content").removeClass("active");
			var _this = this,
				timer = null;
			timer = setTimeout(function(){
				_this.$el.removeClass("active");
				clearTimeout(timer);
			},250);
			//取消物理返回键监听状态
			c360.events.trigger("removeBackHistory");
		}
	});

	return listView;

});


