define(function(require, exports, module) {

	$.ns('c360.share.list','c360.backButtonFn');

	window.notification = require('common/Notification');

	require('ui/share/detail');

	require('common/SNS');

	require('common/storage');

	require('ui/share/base.css');

	require('ui/share/list.css');

	c360.backButtonFn = function(){
		//关闭loading
        cNative.displayLoadingIcon({show:false,msg:"Loading",modal:false});
		if(utils.isMobile) cNative.closeTopestView();
		else location.href = c360.storage.get("photoData").url;
	}

	//定义页面常量类
	var CONSTANT = {
			CIRCLE:'circle',	// 定义朋友圈名称
			WEIXIN:'weixin',	// 定义微信名称
			NOTO:'noto',		// 定义短信名称
			EMAIL:'email',		// 定义邮件名称
			SHARETIME:1 		// 定义分享缓存时间
		},

		disabled = 'disabled',			// 定义点击失效class样式

		Base = require('ui/share/base');

	c360.share.list = new (Base.extend({

		/**********************************************
		 * @actionName	定义页面事件.
		 *********************************************/
		events:_.extend({
			'tap .share-item':'toDetail',
			'tap .back-panel':'toBack'
		},Base.prototype.events),

		sns:null,

		// 定义分享列表模版
		template : _.template(" <header class='header-color share-header'>\
									<span class='back-panel'><span class='back-icon back-image'></span></span>\
									<span class='title-panel'><span class='title'><%= title %></span></span>\
								</header>\
								<div class='share-panel'>\
									<% if(sns.length != 0){ %>\
										<div class='share-content'>\
											<div class='share-text <%= bindLen == 0 ? 'hide' : '' %>' ><%= bind %></div>\
											<div class='share-list'>\
												<%for( var i in sns ){%>\
													<% if(sns[i].binding == 1) {%>\
												    	<span class='share-<%=sns[i].name%> bind share-item' share-appcode='<%=sns[i].name%>'>\
													      <span class='share-<%=sns[i].name%>-icon share-icon'><img src='images/<%=sns[i].name%>.png'/></span>\
													      <span class='share-value'><%=sns[i].text%></span>\
													      <img class='share-load' src='images/white_loading.gif' />\
													      <span class='share-arrow'></span>\
													    </span>\
													<%}%>\
										    	<%}%>\
									    	</div>\
									    	<div class='share-text <%= unbindLen == 0 ? 'hide' : '' %>'><%= unbind %></div>\
									    	<div class='share-list'>\
									    		<%for( var i in sns ){%>\
													<% if(sns[i].binding == 0) {%>\
												    	<span class='share-<%=sns[i].name%> unbind share-item' share-appcode='<%=sns[i].name%>'>\
													      <span class='share-<%=sns[i].name%>-icon share-icon'><img src='images/<%=sns[i].name%>_.png'/></span>\
													      <span class='share-value'><%=sns[i].text%></span>\
													      <span class='share-arrow'></span>\
													    </span>\
													<%}%>\
										    	<%}%>\
									    	</div>\
										</div>\
									<% } %>\
								</div>\
								<div class='share-buttom'></div>"),
	
		/**********************************************
		 * @actionName	初始化页面.
		 *********************************************/
		initialize:function(){
			Base.prototype.initialize.call(this);
			this.pageId = 'list';
			this.model.set({
				title:lang.share,
				cancel:lang.cancel,
				bind:lang.onbind,
				unbind:lang.offbind
			});
			require('route/share');
		},

		/**********************************************
		 * @actionName	初始化DOM.
		 *********************************************/
		initDom:function(){
			this.$shareContentDom = this.$('.share-content');
			this.$shareHeaderDom = this.$('.share-header');
			this.$sharePanelDom = this.$('.share-panel');
			this.$shareButtomDom = this.$('.share-buttom');
		},

		/**********************************************
		 * @actionName  显示分享列表.
	     * @param flag int 表示方向(-1:表示分享列表滑出,1:表示分享列表滑入)
		 * *******************************************/
		show:function(flag){
			if(flag == -1) {
				this.$el.show();
				c360.events.trigger('hidesharedetail:event',-1);
			}else{
				if(this.model.has('sns')){
					this.$el.show();
				}else{
					notification.loading(true,'Loading');
					this.model.set({
						sns:[]
					},{silent:true});
					this.render();
					this.animateComplete();
					this.doShareList();
				}
			}
		},

		/**********************************************
		 * @actionName  隐藏分享列表.
		 * *******************************************/
		hide:function(){
			this.$el.hide();
		},

		/**********************************************
		 * @actionName  请求分享列表.
		 * *******************************************/
		doShareList:function(){
			var _this = this;

			this.sns = c360.storage.get('sns');

			// 缓存sns数据,缓存5分钟
			if(this.sns){
				if(this.sns.language !== lang.language 
					|| this.sns.uid === undefined 
					|| this.sns.uid != cNative.getUser().uid 
					|| Date.now() - this.sns.expires >= CONSTANT.SHARETIME*60*1000){
					// 如果大于5分钟就情况sns数据缓存
					c360.storage.clear('sns');
					this.sns = null;
				}
			}

			// 判断sns列表是否存在
			if(this.sns){
				// 更新层c360.SNS分享数据
				c360.SNS.unbindLen = this.sns.unbindLen;
				c360.SNS.bindLen = this.sns.bindLen;
				c360.SNS.info = this.sns.sns;
				// 由于对象的change事件无法验证是否改变,所以统一自己手动渲染防止安全
				this.model.set(this.sns,{silent:true});

				notification.loading(false,'Loading');

				this.setTemplate();

				this.animateComplete();
			}else{
				c360.SNS.getSNSList(function(){
					// 需求变更,要求把email放在最后面显示
					var email = c360.SNS.info[CONSTANT.EMAIL];
					delete c360.SNS.info[CONSTANT.EMAIL];
					if (utils.isMobile) {
							// 如果是移动端需要自己组合第三方sns和native的sns
						window.cNative.getNativeShareInfo(function(json){
							if(json.error == 200){
								
								var info = json.info,
									code = null;

								for(var i in info){
									code = info[i].name;
									if(info[i].name == CONSTANT.WEIXIN && info[i].support && info[i].installed){
										c360.SNS.info[code] = {
											name:code,
											binding:1,
											text:lang[code]
										};
										c360.SNS.info[CONSTANT.CIRCLE] = {
											name:CONSTANT.CIRCLE,
											binding:1,
											text:lang[CONSTANT.CIRCLE]
										};
										break;
									}
								}

								// 当前设备是iPad的时候就屏蔽短信功能
								if(!window.cNative.deviceType.match(/iPad/)){
									c360.SNS.info[CONSTANT.NOTO] = {
										name:CONSTANT.NOTO,
										binding:1,
										text:lang[CONSTANT.NOTO]
									};
								}

								c360.SNS.info[CONSTANT.EMAIL] = email;
								_this.setShareList();
							}
						});
					}else{
						c360.SNS.info[CONSTANT.EMAIL] = email;
						_this.setShareList();
					}
				});
			}
		},

		/**********************************************
		 * @actionName  设置分享列表.
		 * *******************************************/
		setShareList:function(){
			// 由于设置json对象,可能会造成不触发change事件,因为object对象没法检查是否改变,这样可以更安全
			var expires = Date.now();

			if(this.sns){
				expires = this.sns.expires;
			}

			var json = $.extend({
				sns:c360.SNS.info,
				expires:expires,
				uid:cNative.getUser().uid,
				language:lang.language
			},c360.SNS.getSNSBind());

			c360.storage.set('sns',json);

			this.model.set(json,{silent:true});

			notification.loading(false,'Loading');

			this.setTemplate();

			this.animateComplete();
		},

		/**********************************************
		 * @actionName  到分享详情页面.
		 * *******************************************/
		toDetail:function(event){
			var target = $(event.currentTarget),
				shareCode = target.attr('share-appcode'),
				arr = [],
				_this = this;
			// 判断当前站点是否绑定
			if(target.hasClass('bind')){
				this.shareData = c360.storage.get("shareData");
				switch(shareCode){
					case CONSTANT.WEIXIN:
					case CONSTANT.CIRCLE:
					case CONSTANT.NOTO:

						// 防止用户快速点击
						if(target.hasClass(disabled)) return;

						target.addClass(disabled);

						var shareData = this.shareData,	 // 获取分享数据

							photos = shareData.photos,	// 获取分享的所有照片路径

							length = photos.length,	// 获取分享照片的总个数

							theme = shareData.name, // 获取当前主题名称

							name = lang.cameraShare.replace('{n}',theme),	// 获取照片墙地址

							method = 'shareToWeixin',	//定义微信接口名称,默认为微信接口

							flag = 1,	// 标识是否需要生成base64

							isWallLink = 1,		// 表示是否需要生成照片墙

							isPicWall = null,	// 标识是否是照片墙(false:表示不是照片墙,true:表示是照片墙)

							url = null,		// 记录分享照片墙地址还是照片地址(备注:因为单张照片不需要照片墙地址)

							msg = null,		// 短信消息信息

							data = null;	// 获取后台数据变量

						// 短信接口不需要base64所以传入服务器的参数是0

						if(length == 1){
							isWallLink = 0;
						}

						if(shareCode == CONSTANT.NOTO){
							isWallLink = 1;
							flag = 0;
						}

						c360.server.getPhotoWallLinks({
							pids:shareData.pids,
							aids:shareData.aids,
							sideCode:shareCode,
							title:name,
							piccollage:0,
							isWallLink:isWallLink,
							base64Content:flag,
							themeName:theme
						},function(json){
							target.removeClass(disabled);
							if(json.status == 200){
								data = json.data;
								// 如果是短信接口就调用发送短信接口
								if(shareCode == CONSTANT.NOTO){
									if(length == 1){
										if(photos[0].hasAudio == 1){
											msg = lang.cameraShareTitle;
											url = data.audioPuburl;
										}else{
											msg = lang.connectTip.replace('{n}',theme);
											url = data.puburl;
										}
									}else{
										msg = lang.connectTip.replace('{n}',theme);
										url = data.puburl;
									}

									_this.doSendSMS(msg+url);
								}else{

									if(shareCode == CONSTANT.CIRCLE){
										method = 'shareToWeixinGroup';
									}

									if(length == 1){
										if(photos[0].hasAudio == 1){
											isPicWall = true;
											url = data.audioPuburl;
										}else{
											isPicWall = false;
											url = 'http://dn-c360.qbox.me/'+photos[0].key+'-w480';
										}
									}else{
										isPicWall = true;
										url = data.puburl;
									}
									_this.doCircle(method,isPicWall,data.picBase64Content,url,theme,name);
								}
							}else{
								notification.bubble(json.message);
							}
						});
						break;
					default:
						location.href = '#share-detail/'+shareCode+'/1';
						break;
				}
			}else{
				c360.SNS.login(shareCode, function(){
					_this.setShareList();

					if (utils.isMobile) {
						for(var key in c360.SNS.info){
							if(c360.SNS.info[key].status == 200){
								arr.push(c360.SNS.info[key]);
							}
						}
						
						window.cNative.setSNSInfo({data:arr}, function(data){
							if(data.error == 200){
							}
						});
					}
				});
			}
		},

		/**********************************************
		 * @actionName  发送短信接口.
		 * @param msg string 表示发送短信的内容
		 * *******************************************/
		doSendSMS:function(msg){
			window.cNative.sendSMS({
				msg:msg
			},function(data) {
	        	if(data.error != 200 && data.msg){
					notification.bubble(data.msg);
				}
	        });
		},

		/**********************************************
		 * @actionName  发送微信接口.
		 * @param method string 表示方法名
		 * @param base64 string 表示二进制流图片内容
		 * @param key string 表示图片key
		 * *******************************************/
		doCircle:function(method,type,base64,url,title,description){
			window.cNative[method]({
				isPicWall:type,
				title:title,
				description:description,
				image:base64,
				imageUrl:url
			}, function(data){
				if(data.error != 200 && data.msg){
					notification.bubble(data.msg);
				}
			});
		},

		/**********************************************
		 * @actionName  返回上一级页面.
		 * *******************************************/
		toBack:function(event){
			c360.backButtonFn();
		},

		/**********************************************
		 * @actionName  设置当前列表面板高度.
		 * *******************************************/
		setPanelPos:function(){
			var height = $(window).height() - this.$shareHeaderDom.height() - this.$shareButtomDom.height() - 1;
			if(this.$shareContentDom.length == 0){
				this.$sharePanelDom.height(height);
			}else{
				this.$sharePanelDom.height(Math.max(height,this.$shareContentDom.height()));
			}
		},

		/**********************************************
		 * @actionName  动画完成后的回调函数.
		 * *******************************************/
		animateComplete:function(){
			Base.prototype.animateComplete.call(this);
			this.initDom();
			this.setPanelPos();
		},

		/**********************************************
		 * @actionName  初始化页面事件.
		 * *******************************************/
		initEventListener:function(){
			Base.prototype.initEventListener.call(this);
			c360.events.on('hidesharelist:event',$.proxy(this,'hide'));
			c360.events.on('showsharelist:event',$.proxy(this,'show'));
		}
	}));
	
});