define(function(require, exports, module) {

	$.ns('c360.share.main');

	require('common/SNS');

	require('ui/share/main.css');

	require('common/storage');

	var CONSTANT = {
			PHOTONUM:8,			// 定义分享拼图模版显示最大8张数量
			VERSION:8,			// 定义当前版本号
			CIRCLE:'circle',	// 定义朋友圈名称
			WEIXIN:'weixin',	// 定义微信名称
			NOTO:'noto',		// 定义短信名称
			NUM:3,				// 定义最大显示站点数量
			SHARETIME:1 		// 定义分享缓存时间
		}, //定义页面常量类

		notification = require('common/Notification'),

		disabled = 'disabled',			// 定义点击失效class样式

		ListView = require("ui/dialog/list/list"),

		snsShareList = {
			qzone:null,		// 定义QQ空间
			sina:null,		// 定义新浪微博
			qq:null,		// 定义腾讯微博
			renren:null, 	// 定义人人网
			facebook:null,  // 定义facebook
			twitter:null	// 定义twitter
		},

		snsShareList_us = {
			facebook:null,  // 定义facebook
			twitter:null,	// 定义twitter
			sina:null,		// 定义新浪微博
			qq:null,		// 定义腾讯微博
			qzone:null,		// 定义QQ空间
			renren:null 	// 定义人人网
		},

		mainView = new (Backbone.View.extend({

			shareView:null,

			/**********************************************
			 * @actionName	分享照片.
			 *********************************************/
			share:function(){
				if(cNative.nativeAPIVersion > CONSTANT.VERSION && utils.isAndroid()){
					var _this = this;

					this.sns = c360.storage.get('sns');

					// 缓存sns数据,缓存1分钟
					if(this.sns){
						if(this.sns.language !== lang.language 
							|| this.sns.uid === undefined 
							|| this.sns.uid != cNative.getUser().uid 
							|| Date.now() - this.sns.expires >= CONSTANT.SHARETIME*60*1000){
							// 如果大于5分钟就情况sns数据缓存
							c360.storage.clear('sns');
							this.sns = null;
						}
					}

					// 判断sns列表是否存在
					if(this.sns){
						// 更新层c360.SNS分享数据
						c360.SNS.info = this.sns.sns;

						this.render();
					}else{
						notification.loading(true,'Loading');

						c360.SNS.getSNSList(function(){
							if (utils.isMobile) {
								// 如果是移动端需要自己组合第三方sns和native的sns
								window.cNative.getNativeShareInfo(function(json){

									notification.loading(false,'Loading');

									if(json.error == 200){
										
										var info = json.info;

										for(var i in info){
											if(info[i].name == CONSTANT.WEIXIN && info[i].support && info[i].installed){
												c360.SNS.info[CONSTANT.WEIXIN] = {
													name:CONSTANT.WEIXIN,
													binding:1,
													text:lang[CONSTANT.WEIXIN]
												};
												c360.SNS.info[CONSTANT.CIRCLE] = {
													name:CONSTANT.CIRCLE,
													binding:1,
													text:lang[CONSTANT.CIRCLE]
												};
												break;
											}
										}

										// 当前设备是iPad的时候就屏蔽短信功能
										if(!window.cNative.deviceType.match(/iPad/)){
											c360.SNS.info[CONSTANT.NOTO] = {
												name:CONSTANT.NOTO,
												binding:1,
												text:lang[CONSTANT.NOTO]
											};
										}

										_this.show();

									}else{
										notification.bubble(lang.shareListError);
									}
								});
							}else{
								// 方便PC端测试
								c360.SNS.info[CONSTANT.WEIXIN] = {
									name:CONSTANT.WEIXIN,
									binding:1,
									text:lang[CONSTANT.WEIXIN]
								};
								c360.SNS.info[CONSTANT.CIRCLE] = {
									name:CONSTANT.CIRCLE,
									binding:1,
									text:lang[CONSTANT.CIRCLE]
								};
								c360.SNS.info[CONSTANT.NOTO] = {
									name:CONSTANT.NOTO,
									binding:1,
									text:lang[CONSTANT.NOTO]
								};
								_this.show();
							}
						});
					}
				}else{
					utils.gotoPage("share.html",true,{showTitleBar:true,animation:4});
				}
			},
			/**********************************************
			 * @actionName  显示页面.
			 * *******************************************/
			show:function(){
				// 由于设置json对象,可能会造成不触发change事件,因为object对象没法检查是否改变,这样可以更安全
				var expires = Date.now();

				if(this.sns){
					expires = this.sns.expires;
				}

				var json = {
					sns:c360.SNS.info,
					expires:expires,
					uid:cNative.getUser().uid,
					language:lang.language
				};

				c360.storage.set('sns',json);

				this.syncShare();

				this.render();
			},
			/**********************************************
			 * @actionName  同步native分享数据.
			 * *******************************************/
			syncShare:function(){
				if (utils.isMobile) {
					var arr = [];
					for(var key in c360.SNS.info){
						if(c360.SNS.info[key].status == 200){
							arr.push(c360.SNS.info[key]);
						}
					}
					
					window.cNative.setSNSInfo({data:arr}, function(data){
						if(data.error == 200){
						}
					});
				}
			},

			/**********************************************
			 * @actionName  渲染页面.
			 * *******************************************/
			render:function(){
				var str = '<ul>';

				if(c360.SNS.info[CONSTANT.WEIXIN] && c360.SNS.info[CONSTANT.WEIXIN].binding == 1){
					str += '<li><span share-appcode="weixin" data-btn="share_weixin" id="weixinId" class="btnGray-color"><%=lang.shareToWeixin%></span></li>';
					str += '<li><span share-appcode="circle" data-btn="share_pengyouquan" id="circleId" class="btnGray-color"><%=lang.shareToCircle%></span></li>';
				}

				// 当前设备是iPad的时候就屏蔽短信功能
				if(!window.cNative.deviceType.match(/iPad/)){
					str += '<li><span share-appcode="noto" data-btn="share_sms" id="notoId" class="btnGray-color"><%=lang.shareToNoto%></span></li>';
				}

				str += '<li><span share-appcode="email" id="emailId" class="btnGray-color"><%=lang.shareToEmail%></span></li>';

				str += '<li><span share-appcode="sns" id="snsId" class="sns-share btnGray-color"><div><%=lang.shareToSns%></div>';

				var index = 0;

				switch(lang.language.toLowerCase()){
					case 'en_us':
					case 'th_th':
						snsShareList = snsShareList_us;
						break;
					default:
						break;
				}

				// 先查找绑定的站点信息
				for(var key in snsShareList){
					if(c360.SNS.info[key].binding == 1){
						if(index == 3) break;
						str += '<img src = images/' + key + '.png />';
						index++;
					}
				}

				// 判断绑定的站点是否已经有了3个,没有继续查找没有绑定的站点信息,一共最多保持3个站点
				if(index != 3){
					for(var key in snsShareList){
						if(c360.SNS.info[key].binding == 0){
							if(index == 3) break;
							str += '<img src = images/' + key + '_.png />';
							index++;
						}
					}
				}

				str += '</span></li>';

				str += '<li><span class="cancel btnGray-color"><%=lang.cancelShare%></span></li>';

				str += '</ul>';

				if(this.shareView){
					this.shareView.$el.empty().html(_.template('<div class="mask"><div class="content">'+str+'</div></div>'));
				}else{
					this.shareView = new ShareView({
						str:str
					});
				}

				this.shareView.show(c360.storage.get("shareData"));
			}
		})),

		ShareView = ListView.extend({
			events:$.extend({
				'tap #emailId':'toEmailShare',
				'tap #snsId':'toSnsShare',
				'tap #weixinId,#circleId,#notoId':'toNativeShare'
			},ListView.prototype.events),

			/**********************************************
			 * @actionName  初始化数据.
			 * *******************************************/
			initialize:function(json){
				this.templateHTML = json.str;
				ListView.prototype.initialize.call(this);
			},

			/**********************************************
			 * @actionName  进入SNS分享接口.
			 * *******************************************/
			toSnsShare:function (){
				var shareData = this.model.toJSON(),

					photos = shareData.photos,

					_this = this,

					theme = shareData.name,

					pids = shareData.pids,

					length = pids.length;
				
				// 照片墙封面拼图8张限制
				photos = photos.slice(0,Math.min(photos.length,CONSTANT.PHOTONUM));

				notification.loading(true,'Loading');

				window.cNative.shareToSNS({
					aids:shareData.aids,
					pids:pids,
					photos:photos,
					count:shareData.count||length,
					title:lang.cameraShare.replace('{n}',theme),
					imageUrl:'http://dn-c360.qbox.me/'+photos[0].key + '?imageView/1/w/80/h/80',
					themeName:theme
				},function(json){
					notification.loading(false,'Loading');
					_this.hide();
					if(json.error != 200){
						notification.bubble(json.msg);
					}
				});
			},

			/**********************************************
			 * @actionName  进入邮件分享接口.
			 * *******************************************/
			toEmailShare:function(){
				this.hide();
				utils.gotoPage("email.html",true,{showTitleBar:true,animation:4});
			},

			/**********************************************
			 * @actionName  发送native分享接口.
			 * @param event object 表示事件对象
			 * *******************************************/
			toNativeShare:function(event){
				var target = $(event.currentTarget);
				// 防止用户快速点击
				if(target.hasClass(disabled)) return;
				target.addClass(disabled);

				notification.loading(true,'Loading');

				shareCode = target.attr('share-appcode');

				var shareData = this.model.toJSON(),	 // 获取分享数据

					_this = this,

					photos = shareData.photos,	// 获取分享的所有照片路径

					length = photos.length,	// 获取分享照片的总个数

					theme = shareData.name, // 获取当前主题名称

					name = lang.cameraShare.replace('{n}',theme),	// 获取照片墙地址

					method = 'shareToWeixin',	//定义微信接口名称,默认为微信接口

					flag = 1,	// 标识是否需要生成base64

					isWallLink = 1,		// 表示是否需要生成照片墙

					isPicWall = null,	// 标识是否是照片墙(false:表示不是照片墙,true:表示是照片墙)

					url = null,		// 记录分享照片墙地址还是照片地址(备注:因为单张照片不需要照片墙地址)

					msg = null,		// 短信消息信息
					
					data = null;	// 获取后台数据变量

				// 短信接口不需要base64所以传入服务器的参数是0

				if(length == 1){
					isWallLink = 0;
				}

				if(shareCode == CONSTANT.NOTO){
					isWallLink = 1;
					flag = 0;
				}

				c360.server.getPhotoWallLinks({
					pids:shareData.pids,
					aids:shareData.aids,
					sideCode:shareCode,
					title:name,
					piccollage:0,
					isWallLink:isWallLink,
					base64Content:flag,
					themeName:theme
				},function(json){
					target.removeClass(disabled);
					notification.loading(false,'Loading');
					if(json.status == 200){
						_this.hide();
						data = json.data;
						// 如果是短信接口就调用发送短信接口
						if(shareCode == CONSTANT.NOTO){
							if(length == 1){
								if(photos[0].hasAudio == 1){
									msg = lang.cameraShareTitle;
									url = data.audioPuburl;
								}else{
									msg = lang.connectTip.replace('{n}',theme);
									url = data.puburl;
								}
							}else{
								msg = lang.connectTip.replace('{n}',theme);
								url = data.puburl;
							}

							_this.doSendSMS(msg+url);
						}else{

							if(shareCode == CONSTANT.CIRCLE){
								method = 'shareToWeixinGroup';
							}

							if(length == 1){
								if(photos[0].hasAudio == 1){
									isPicWall = true;
									url = data.audioPuburl;
								}else{
									isPicWall = false;
									url = 'http://dn-c360.qbox.me/'+photos[0].key+'-w480';
								}
							}else{
								isPicWall = true;
								url = data.puburl;
							}
							_this.doCircle(method,isPicWall,data.picBase64Content,url,theme,name);
						}
					}else{
						notification.bubble(json.message);
					}
				});
			},

			/**********************************************
			 * @actionName  发送短信接口.
			 * @param msg string 表示发送短信的内容
			 * *******************************************/
			doSendSMS:function(msg){
				window.cNative.sendSMS({
					msg:msg
				},function(data) {
		        	if(data.error != 200 && data.msg){
						notification.bubble(data.msg);
					}
		        });
			},

			/**********************************************
			 * @actionName  发送微信接口.
			 * @param method string 表示方法名
			 * @param base64 string 表示二进制流图片内容
			 * @param url string 表示有声照片或照片墙地址
			 * @param key string 表示图片key
			 * *******************************************/
			doCircle:function(method,type,base64,url,title,description){
				window.cNative[method]({
					isPicWall:type,
					title:title,
					description:description,
					image:base64,
					imageUrl:url
				}, function(data){
					if(data.error != 200 && data.msg){
						notification.bubble(data.msg);
					}
				});
			}
		});

	c360.share.main = mainView;

	return mainView;

});